/****************************************************************
KPIT Cummins Infosystems Ltd, Pune, India. - 17-Jan-2006.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*****************************************************************/
/***********************************************************************************
FILE NAME  		resetprg.c
DESCRIPTION		Reset Initialisation Functions for RSKM32C87
			The users program will start in this file.

***********************************************************************************/

/***********************************************************************************
System Includes
***********************************************************************************/

/***********************************************************************************
User Includes
***********************************************************************************/
/* iodefine.h provides a structure to access all of the device registers. */

#include "iodefine.h"
#include "hwinit.h"
#include "main.h"

/**********************************************************************************
Global variables
***********************************************************************************/

/***********************************************************************************
User Program Code
***********************************************************************************/

/**********************************************************************************
Function Name: 	Initialise
Description:	Initialise the micon then call main
Parameters: 	none
Return value: 	none
***********************************************************************************/
void Initialise(void)
{ 
	/* Initialise all the required peripheral modules */
	hw_initialise();

	/* main function including users code */
	main();

	/* This function must never exit */
	for(;;);
}
/**********************************************************************************
End of function Initialise
***********************************************************************************/   

