;/****************************************************************
;KPIT Cummins Infosystems Ltd, Pune, India. 08-Aug-2005.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
;
;*****************************************************************/

/* Start-up code for M32C or M32CM targets only */

.text
	.global	_start
	.type	_start, @function
	
_start:
	ldc	#_istack, isp	/* set interrupt stack pointer */
	mov.b	#0x02,0x0a	/* write enable in protect register */
	mov.b	#0x00,0x04	/* set processer mode  :single chip mode */
						/* 0x04 is the address of processor mode register 0 */
	mov.b	#0x00,0x0a	/* write disable in protect register */
	ldc	#0x0080,flg		/* select USER STACK POINTER (BIT7=1,USP) (BIT7=0,ISP) */
	ldc	#_ustack,sp		/* set user stack pointer */
	
	/* INTERRUPT VECTOR ADDRESS  definition	*/
	ldc 	#0x0FFBE00, intb	/* load variable vector address in intb register */

	fset	I			/* ADD THIS TO ENABLE INTERRUPTS */
		
/* load data section from ROM to RAM only if ROMSTART is defined */
#if ROMSTART

	mov.l	#_mdata,a0 	/* store the load address of data section in A0 */
	mov.w	#_data,a1  	/* store the start address of data section in, A1 */
	mov.w	#_edata,r3 	/* store the end address of data section in R3 */
	sub.w    a1,r3     	/* R3=R3-A1 Store size of data section in R3 */
	smovf.b
	
#endif // ROMSTART


/* bss initialisation : zero out bss */

	mov.b	#0x00,R0L  	/* load R0L reg with 0x0 (value at which bss section will be initialised) */
	mov.w	#_bss, a1  	/* store the start address of bss in A1 */
	mov.w	#_ebss, a0 	/* store the end address of bss in A0 */
	sub.w   a1,a0	   	/* (A0 = A0-A1) */
	mov.w   a0,r3	   	/* Store size of bss section in reg R3 */
	sstr.b


/* start user program */
	jsr.a	_Initialise		
	
	.end
