/****************************************************************
KPIT Cummins Infosystems Ltd, Pune, India. - 17-Jan-2006.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*****************************************************************/


/****************************************************************
  iodefine.h

  Please add the definitions of the internal register addresses
  depending on your CPU.

*****************************************************************/
#ifndef IODEFINE_H_INCLUDED
#define IODEFINE_H_INCLUDED

#define     pm0    (*(volatile union byte_def *)	(0x0004))       /* Processor mode register 0 */
#define     pm1    (*(volatile union byte_def *)	(0x0005))       /* Processor mode register 1 */
#define     cm0    (*(volatile union byte_def *)	(0x0006))       /* System clock control register 0 */
#define     cm1    (*(volatile union byte_def *)	(0x0007))       /* System clock control register 1 */

#define     aier   (*(volatile union byte_def *)	(0x0009))       /* Address match interrupt enable register */
#define     prcr   (*(volatile union byte_def *)	(0x000a))       /* Protect register */
#define     ds     (*(volatile union byte_def *)	(0x000b))       /* External data bus width control register */
#define     mcd    (*(volatile union byte_def *)	(0x000c))       /* Main clock division register */
#define     cm2    (*(volatile union byte_def *)	(0x000d))       /* Oscillation stop detect register */
#define     wdts   (*(volatile union byte_def *)	(0x000e))       /* Watchdog timer start register */
#define     wdc    (*(volatile union byte_def *)	(0x000f))       /* Watchdog timer control register */
#define     rmad0  (*(volatile union rmadi_def *)	(0x0010))       /* Address match interrupt register 0 */
#define     pm2    (*(volatile union byte_def *)	(0x0013))       /* Processor mode register 2 */
#define     rmad1  (*(volatile union rmadi_def *)	(0x0014))       /* Address match interrupt register 1 */
#define     vcr2   (*(volatile union byte_def *)	(0x0017))       /* Voltage detection register 2 */
#define     rmad2  (*(volatile union rmadi_def *)	(0x0018))       /* Address match interrupt register 2 */
#define     vcr1   (*(volatile union byte_def *)	(0x001b))       /* Voltage detection register 1 */
#define     rmad3  (*(volatile union rmadi_def *)	(0x001c))       /* Address match interrupt register 3 */


#define     plc    (*(volatile union uarti_reg_def*) (0x0026))       /* PLL control register */
#define     plc0   (*(volatile union byte_def *)	(0x0026))       /* PLL control register 0 */
#define     plc1   (*(volatile union byte_def *)	(0x0027))       /* PLL control register 1 */
#define     rmad4  (*(volatile union rmadi_def *)	(0x0028))       /* Address match interrupt register 4 */

#define     rmad5  (*(volatile union rmadi_def *)	(0x002C))       /* Address match interrupt register 5 */
#define     d4int  (*(volatile union byte_def *)    (0x002F))       /* Voltage down detect interrupt register */


#define     rmad6  (*(volatile union rmadi_def *)	(0x0038))       /* Address match interrupt register 6 */
#define     rmad7  (*(volatile union rmadi_def *)	(0x003C))       /* Address match interrupt register 7 */


#define     ewcr0  (*(volatile union byte_def *)	(0x0048))       /* External space wait control register 0 */
#define     ewcr1  (*(volatile union byte_def *)    (0x0049))       /* External space wait control register 1 */
#define     ewcr2  (*(volatile union byte_def *)    (0x004A))       /* External space wait control register 2 */
#define     ewcr3  (*(volatile union byte_def *)    (0x004B))       /* External space wait control register 3 */
#define     pwcr0  (*(volatile union byte_def *)    (0x004C))       /* Page mode wait control register 0 */
#define     pwcr1  (*(volatile union byte_def *)    (0x004D))       /* Page mode wait control register 1 */


#define     fmr1   (*(volatile union byte_def *)	(0x0055))       /* Flash Memory Control Register 1 */

#define     fmr    (*(volatile union uarti_reg_def*)(0x0057))       /* Flash memory control register 0 */
#define     fmr0   (*(volatile union byte_def *)	(0x0057))       /* Flash memory control register 0 */


#define		dm0ic  (*(volatile union icr1_byte_def *) (0x0068))       /* DMA0 interrupt control register */
#define tb5ic  (*(volatile union icr1_byte_def *) (0x0069))       /* Timer B5 interrupt register */
#define dm2ic  (*(volatile union icr1_byte_def *) (0x006a))       /* DMA2 interrupt register */
#define s2ric  (*(volatile union icr1_byte_def *) (0x006b))       /* UART2 receive/ack interrupt control register */
#define ta0ic  (*(volatile union icr1_byte_def *) (0x006c))       /* Timer A0 interrupt control register */
#define s3ric  (*(volatile union icr1_byte_def *) (0x006d))       /* UART3 receive/ack interrupt control register */
#define ta2ic  (*(volatile union icr1_byte_def *) (0x006e))       /* Timer A2 interrupt control register */
#define s4ric  (*(volatile union icr1_byte_def *) (0x006f))       /* UART4 receive/ack interrupt control register */
#define ta4ic  (*(volatile union icr1_byte_def *) (0x0070))       /* Timer A4 interrupt control register */
#define bcn0ic (*(volatile union icr1_byte_def *) (0x0071))       /* Bus collision (UART0) interrupt control register */
#define bcn3ic (*(volatile union icr1_byte_def *) (0x0071))       /* Bus collision (UART3) interrupt control register */
#define s0ric  (*(volatile union icr1_byte_def *) (0x0072))       /* UART0 receive interrupt control register */
#define ad0ic  (*(volatile union icr1_byte_def *) (0x0073))       /* A/D0 conversion interrupt control register */
#define s1ric  (*(volatile union icr1_byte_def *) (0x0074))       /* UART1 receive interrupt control register */
#define iio0ic (*(volatile union icr1_byte_def *) (0x0075))       /* Intelligent I/O interrupt control register */
#define can3ic (*(volatile union icr1_byte_def *) (0x0075))       /* CAN3 Interrupt Control Register*/
#define tb1ic  (*(volatile union icr1_byte_def *) (0x0076))       /* Timer B1 interrupt control register */
#define iio2ic (*(volatile union icr1_byte_def *) (0x0077))       /* Intelligent I/O interrupt control register */
#define tb3ic  (*(volatile union icr1_byte_def *) (0x0078))       /* Timer B3 interrupt control register */
#define iio4ic (*(volatile union icr1_byte_def *) (0x0079))       /* Intelligent I/O interrupt control register */
#define int5ic (*(volatile union icr2_byte_def *) (0x007a))       /* INT5~ interrupt control register */
#define iio6ic (*(volatile union icr1_byte_def *) (0x007b))       /* Intelligent I/O interrupt control register */
#define int3ic (*(volatile union icr2_byte_def *) (0x007c))       /* INT3~ interrupt control register */
#define iio8ic (*(volatile union icr1_byte_def *) (0x007d))       /* Intelligent I/O interrupt control register */
#define int1ic (*(volatile union icr2_byte_def *) (0x007e))       /* INT1~ interrupt control register */
#define can1ic (*(volatile union icr1_byte_def *) (0x007f))       /* CAN1 Interrupt Control Register*/
#define can2ic (*(volatile union icr1_byte_def *) (0x0081))       /* CAN2 Interrupt Control Register*/
#define dm1ic  (*(volatile union icr1_byte_def *) (0x0088))       /* DMA1 interrupt control register */
#define s2tic  (*(volatile union icr1_byte_def *) (0x0089))       /* UART2 transmit/nack interrupt control register */
#define dm3ic  (*(volatile union icr1_byte_def *) (0x008a))       /* DMA3 interrupt control register */
#define s3tic  (*(volatile union icr1_byte_def *) (0x008b))       /* UART3 transmit/nack interrupt control register */
#define ta1ic  (*(volatile union icr1_byte_def *) (0x008c))       /* Timer A1 interrupt control register */
#define s4tic  (*(volatile union icr1_byte_def *) (0x008d))       /* UART4 transmit/nack interrupt control register */
#define ta3ic  (*(volatile union icr1_byte_def *) (0x008e))       /* Timer A3 interrupt control register */
#define bcn2ic (*(volatile union ict_byte_def *) (0x008f))       /* Bus collision (UART2) interrupt control register */
#define s0tic  (*(volatile union icr1_byte_def *) (0x0090))       /* UART0 transmit interrupt control register */
#define bcn1ic (*(volatile union icr1_byte_def *) (0x0091))       /* Bus collision (UART1) interrupt control register*/
#define bcn4ic (*(volatile union icr1_byte_def *) (0x0091))       /* Bus collision (UART4) interrupt control register */
#define s1tic  (*(volatile union icr1_byte_def *) (0x0092))       /* UART1 transmit interrupt control register */
#define kupic  (*(volatile union icr1_byte_def *) (0x0093))       /* Key input interrupt control register */
#define tb0ic  (*(volatile union icr1_byte_def *) (0x0094))       /* Timer B0 interrupt control register */
#define iio1ic (*(volatile union icr1_byte_def *) (0x0095))       /* Intelligent I/O interrupt control register */
#define can4ic (*(volatile union icr1_byte_def *) (0x0095))       /* CAN4 Interrupt Control Register*/
#define tb2ic  (*(volatile union icr1_byte_def *) (0x0096))       /* Timer B2 interrupt control register */
#define iio3ic (*(volatile union icr1_byte_def *) (0x0097))       /* Intelligent I/O interrupt control register */
#define tb4ic  (*(volatile union icr1_byte_def *) (0x0098))       /* Timer B4 interrupt control register */
#define iio5ic (*(volatile union icr1_byte_def *) (0x0099))       /* Intelligent I/O interrupt control register */
#define can5ic (*(volatile union icr1_byte_def *) (0x0099))       /* CAN5 Interrupt Control Register*/
#define int4ic (*(volatile union icr2_byte_def *) (0x009a))       /* INT4~ interrupt control register */
#define iio7ic (*(volatile union icr1_byte_def *) (0x009b))       /* Intelligent I/O interrupt control register */
#define int2ic (*(volatile union icr2_byte_def *) (0x009c))       /* INT2~ interrupt control register */
#define iio9ic (*(volatile union icr1_byte_def *) (0x009d))       /* Intelligent I/O interrupt control register */
#define can0ic (*(volatile union icr1_byte_def *) (0x009d))       /* CAN0 Interrupt Control Register*/
#define int0ic (*(volatile union icr2_byte_def *) (0x009e))       /* INT0~ interrupt control register */
#define rlvl   (*(volatile union byte_def *)	(0x009f))       /* Exit priority register */
#define iio0ir (*(volatile union byte_def *) (0x00a0))       /* Interrupt request register 0 */
#define iio1ir (*(volatile union byte_def *) (0x00a1))       /* Interrupt request register 1 */
#define iio2ir (*(volatile union byte_def *) (0x00a2))       /* Interrupt request register 2 */
#define iio3ir (*(volatile union byte_def *) (0x00a3))       /* Interrupt request register 3 */
#define iio4ir (*(volatile union byte_def *) (0x00a4))       /* Interrupt request register 4 */
#define iio5ir (*(volatile union byte_def *) (0x00a5))       /* Interrupt request register 5 */
#define iio6ir (*(volatile union byte_def *) (0x00a6))       /* Interrupt request register 6 */
#define iio7ir (*(volatile union byte_def *) (0x00a7))       /* Interrupt request register 7 */
#define iio8ir (*(volatile union byte_def *) (0x00a8))       /* Interrupt request register 8 */
#define iio9ir (*(volatile union byte_def *) (0x00a9))       /* Interrupt request register 9 */
#define iio10ir (*(volatile union byte_def *) (0x00aa))       /* Interrupt request register 10 */
#define iio11ir (*(volatile union byte_def *) (0x00ab))       /* Interrupt request register 11 */



#define     iio0ie (*(volatile union byte_def *) (0x00b0))       /* Interrupt enable register 0 */
#define     iio1ie (*(volatile union byte_def *) (0x00b1))       /* Interrupt enable register 1 */
#define     iio2ie (*(volatile union byte_def *) (0x00b2))       /* Interrupt enable register 2 */
#define     iio3ie (*(volatile union byte_def *) (0x00b3))       /* Interrupt enable register 3 */
#define     iio4ie (*(volatile union byte_def *) (0x00b4))       /* Interrupt enable register 4 */
#define     iio5ie (*(volatile union byte_def *) (0x00b5))       /* Interrupt enable register 5 */
#define     iio6ie (*(volatile union byte_def *) (0x00b6))       /* Interrupt enable register 6 */
#define     iio7ie (*(volatile union byte_def *) (0x00b7))       /* Interrupt enable register 7 */
#define     iio8ie (*(volatile union byte_def *) (0x00b8))       /* Interrupt enable register 8 */
#define     iio9ie (*(volatile union byte_def *) (0x00b9))       /* Interrupt enable register 9 */
#define     iio10ie (*(volatile union byte_def *) (0x00ba))      /* Interrupt enable register 10 */
#define     iio11ie (*(volatile union byte_def *) (0x00bb))      /* Interrupt enable register 11 */


#define     g0rb   (*(volatile union uarti_reg_def*)(0x00e8))       /* SI/O receive buffer register 0 */
#define     g0tb   (*(volatile union byte_def *)	(0x00ea))       /* Transmit buffer register 0 */
#define     g0dr   (*(volatile union byte_def *)	(0x00ea))       /* Receive data register 0 */

#define     g0ri   (*(volatile union byte_def *)	(0x00ec))       /* Receive input register 0 */
#define     g0mr   (*(volatile union byte_def *)	(0x00ed))       /* SI/O communication control register 0 */
#define     g0to   (*(volatile union byte_def *)	(0x00ee))       /* Transmit output register 0 */
#define     g0cr   (*(volatile union byte_def *)	(0x00ef))       /* SI/O communication control register 0 */
#define     g0cmp0 (*(volatile union byte_def *)	(0x00f0))       /* Data compare register 00 */
#define     g0cmp1 (*(volatile union byte_def *)	(0x00f1))       /* Data compare register 01 */
#define     g0cmp2 (*(volatile union byte_def *)	(0x00f2))       /* Data compare register 02 */
#define     g0cmp3 (*(volatile union byte_def *)	(0x00f3))       /* Data compare register 03 */
#define     g0msk0 (*(volatile union byte_def *)	(0x00f4))       /* Data mask register 00 */
#define     g0msk1 (*(volatile union byte_def *)	(0x00f5))       /* Data mask register 01 */
#define     ccs    (*(volatile union byte_def *)	(0x00f6))       /* Communication clock select register */

#define     g0rcrc (*(volatile union uarti_reg_def*)	(0x00f8))       /* Receive CRC code register 0 */
#define     g0tcrc (*(volatile union uarti_reg_def*)	(0x00fa))       /* Transmit CRC code register 0 */
#define     g0emr   (*(volatile union byte_def *)	(0x00fc))       /* SI/O expansion mode register 0 */
#define     g0erc   (*(volatile union byte_def *)	(0x00fd))       /* SI/O expansion receive control register 0 */
#define     g0irf   (*(volatile union byte_def *)	(0x00fe))       /* SI/O special communication interrupt detect register 0 */
#define     g0etc   (*(volatile union byte_def *)	(0x00ff))       /* SI/O expansion transmit control register 0 */
#define     g1tm0   (*(volatile union uarti_reg_def*)	(0x0100))       /* Time measurement register 10 */
#define     g1po0   (*(volatile union uarti_reg_def*)	(0x0100))       /* Waveform generate register 10 */
#define     g1tm1   (*(volatile union uarti_reg_def*)	(0x0102))       /* Time measurement register 11 */
#define     g1po1   (*(volatile union uarti_reg_def*)	(0x0102))       /* Waveform generate register 11 */
#define     g1tm2   (*(volatile union uarti_reg_def*)	(0x0104))       /* Time measurement register 12 */
#define     g1po2   (*(volatile union uarti_reg_def*)	(0x0104))       /* Waveform generate register 12 */
#define     g1tm3   (*(volatile union uarti_reg_def*)	(0x0106))       /* Time measurement register 13 */
#define     g1po3   (*(volatile union uarti_reg_def*)	(0x0106))       /* Waveform generate register 13 */
#define     g1tm4   (*(volatile union uarti_reg_def*)	(0x0108))       /* Time measurement register 14 */
#define     g1po4   (*(volatile union uarti_reg_def*)	(0x0108))       /* Waveform generate register 14 */
#define     g1tm5   (*(volatile union uarti_reg_def*)	(0x010a))       /* Time measurement register 15 */
#define     g1po5   (*(volatile union uarti_reg_def*)	(0x010a))       /* Waveform generate register 15 */
#define     g1tm6   (*(volatile union uarti_reg_def*)	(0x010c))       /* Time measurement register 16 */
#define     g1po6   (*(volatile union uarti_reg_def*)	(0x010c))       /* Waveform generate register 16 */
#define     g1tm7   (*(volatile union uarti_reg_def*)	(0x010e))       /* Time measurement register 17 */
#define     g1po7   (*(volatile union uarti_reg_def*)	(0x010e))       /* Waveform generate register 17 */
#define     g1pocr0 (*(volatile union pocr_byte_def*)	(0x0110))      /* Waveform generate control register 10 */
#define     g1pocr1 (*(volatile union pocr_byte_def*)	(0x0111))      /* Waveform generate control register 11 */
#define     g1pocr2 (*(volatile union pocr_byte_def*)	(0x0112))      /* Waveform generate control register 12 */
#define     g1pocr3 (*(volatile union pocr_byte_def*)	(0x0113))      /* Waveform generate control register 13 */
#define     g1pocr4 (*(volatile union pocr_byte_def*)	(0x0114))      /* Waveform generate control register 14 */
#define     g1pocr5 (*(volatile union pocr_byte_def*)	(0x0115))      /* Waveform generate control register 15 */
#define     g1pocr6 (*(volatile union pocr_byte_def*)	(0x0116))      /* Waveform generate control register 16 */
#define     g1pocr7 (*(volatile union pocr_byte_def*)	(0x0117))      /* Waveform generate control register 17 */
#define     g1tmcr0 (*(volatile union tmcr_byte_def *)	(0x0118))      /* Time measurement control register 10 */
#define     g1tmcr1 (*(volatile union tmcr_byte_def *)	(0x0119))      /* Time measurement control register 11 */
#define     g1tmcr2 (*(volatile union tmcr_byte_def *)	(0x011a))      /* Time measurement control register 12 */
#define     g1tmcr3 (*(volatile union tmcr_byte_def *)	(0x011b))      /* Time measurement control register 13 */
#define     g1tmcr4 (*(volatile union tmcr_byte_def *)	(0x011c))      /* Time measurement control register 14 */
#define     g1tmcr5 (*(volatile union tmcr_byte_def *)	(0x011d))      /* Time measurement control register 15 */
#define     g1tmcr6 (*(volatile union tmcr_byte_def *)	(0x011e))      /* Time measurement control register 16 */
#define     g1tmcr7 (*(volatile union tmcr_byte_def *)	(0x011f))      /* Time measurement control register 17 */
#define     g1bt    (*(volatile union uarti_reg_def*)	(0x0120))      /* Base timer register 1 */
#define     g1bcr0  (*(volatile union byte_def *)		(0x0122))      /* Base timer control register 10 */
#define     g1bcr1  (*(volatile union byte_def *)		(0x0123))      /* Base timer control register 11 */
#define     g1tpr6  (*(volatile union byte_def *)		(0x0124))      /* Time measurement prescaler register 16 */
#define     g1tpr7  (*(volatile union byte_def *)		(0x0125))      /* Time measurement prescaler register 17 */
#define     g1fe    (*(volatile union byte_def*)		(0x0126))      /* Function enable register 1 */
#define     g1fs    (*(volatile union byte_def*)		(0x0127))      /* Function select register 1 */
#define     g1rb    (*(volatile union uarti_reg_def*)   (0x0128))      /* SI/O receive buffer register 1 */
#define     g1tb    (*(volatile union byte_def*)		(0x012a))      /* Transmit buffer register 1 */
#define     g1dr    (*(volatile union byte_def*)		(0x012a))      /* Receive data register 1 */

#define     g1ri    (*(volatile union byte_def*)		(0x012c))      /* Receive input register 1 */
#define     g1mr    (*(volatile union byte_def*)		(0x012d))      /* SI/O communication mode register 1 */
#define     g1to    (*(volatile union byte_def*)		(0x012e))      /* Transmit output register 1 */
#define     g1cr    (*(volatile union byte_def*)		(0x012f))      /* SI/O communication control register 1 */
#define     g1cmp0  (*(volatile union byte_def*)		(0x0130))      /* Data compare register 10 */
#define     g1cmp1  (*(volatile union byte_def*)		(0x0131))      /* Data compare register 11 */
#define     g1cmp2  (*(volatile union byte_def*)		(0x0132))      /* Data compare register 12 */
#define     g1cmp3  (*(volatile union byte_def*)		(0x0133))      /* Data compare register 13 */
#define     g1msk0  (*(volatile union byte_def*)		(0x0134))      /* Data mask register 10 */
#define     g1msk1  (*(volatile union byte_def*)		(0x0135))      /* Data mask register 11 */


#define     g1rcrc  (*(volatile union uarti_reg_def*)	(0x0138))      /* Receive CRC code register 1 */
#define     g1tcrc  (*(volatile union uarti_reg_def*)	(0x013a))      /* Transmit CRC code register 1 */
#define     g1emr   (*(volatile union byte_def*)		(0x013c))      /* SI/O extended mode register 1 */
#define     g1erc   (*(volatile union byte_def*)		(0x013d))      /* SI/O extended receive control register 1 */
#define     g1irf   (*(volatile union byte_def*)		(0x013e))      /* SI/O special communication interrupt detect register 1 */
#define     g1etc   (*(volatile union byte_def*)		(0x013f))      /* SI/O extended transmit control register 1 */

#define     g2po0   (*(volatile union uarti_reg_def*)	(0x0140))
#define     g2po1   (*(volatile union uarti_reg_def*)	(0x0142))
#define     g2po2   (*(volatile union uarti_reg_def*)	(0x0144))
#define     g2po3   (*(volatile union uarti_reg_def*)	(0x0146))
#define     g2po4   (*(volatile union uarti_reg_def*)	(0x0148))
#define     g2po5   (*(volatile union uarti_reg_def*)	(0x014a))
#define     g2po6   (*(volatile union uarti_reg_def*)	(0x014c))
#define     g2po7   (*(volatile union uarti_reg_def*)	(0x014e))
#define     g2pocr0 (*(volatile union pocr_byte_def*)	(0x0150))
#define     g2pocr1 (*(volatile union pocr_byte_def*)	(0x0151))
#define     g2pocr2 (*(volatile union pocr_byte_def*)	(0x0152))
#define     g2pocr3 (*(volatile union pocr_byte_def*)	(0x0153))
#define     g2pocr4 (*(volatile union pocr_byte_def*)	(0x0154))
#define     g2pocr5 (*(volatile union pocr_byte_def*)	(0x0155))
#define     g2pocr6 (*(volatile union pocr_byte_def*)	(0x0156))
#define     g2pocr7 (*(volatile union pocr_byte_def*)	(0x0157))



#define     g2bt    (*(volatile union uarti_reg_def*)	(0x0160))
#define     g2bcr0  (*(volatile union byte_def*)		(0x0162))
#define     g2bcr1  (*(volatile union byte_def*)		(0x0163))
#define     btsr    (*(volatile union byte_def*)		(0x0164))

#define     g2fe    (*(volatile union byte_def*)		(0x0166))
#define     g2rtp   (*(volatile union byte_def*)		(0x0167))


#define     g2mr    (*(volatile union byte_def*)	(0x016a))
#define     g2cr    (*(volatile union byte_def*)	(0x016b))
#define     g2tb    (*(volatile union uarti_reg_def*)	(0x016c))
#define     g2rb    (*(volatile union uarti_reg_def*)	(0x016e))
#define     iear    (*(volatile union uarti_reg_def*)	(0x0170))
#define     iecr    (*(volatile union byte_def*)		(0x0172))
#define     ietif   (*(volatile union byte_def*)		(0x0173))
#define     ierif   (*(volatile union byte_def*)		(0x0174))


#define     ipsb    (*(volatile union byte_def*)	(0x0177))      /* Input function select register B */
#define     ips     (*(volatile union byte_def*)	(0x0178))      /* Input function select register */
#define     ipsa    (*(volatile union byte_def*)	(0x0179))      /* Input function select register A */

#define     u5tb   (*(volatile union uarti_reg_def*)(0x01c2))       /* UART5 transmit buffer register */
#define     u5c1   (*(volatile union uic1_def *)	(0x01c5))       /* UART5 transmit/receive control register 1 */
#define     u5rb   (*(volatile union uarti_reg_def*)(0x01c6))       /* UART5 receive buffer register */
#define     u6tb   (*(volatile union uarti_reg_def*)(0x01ca))       /* UART6 transmit buffer register */
#define     u6c1   (*(volatile union uic1_def *)	(0x01cd))       /* UART6 transmit/receive control register 1 */
#define     u6rb   (*(volatile union uarti_reg_def*)(0x01ce))       /* UART6 receive buffer register */
#define     u56con (*(volatile union byte_def *)	(0x01d0))
#define     u56is  (*(volatile union byte_def *)	(0x01d1))


#define     rtp0r  (*(volatile union byte_def *)	(0x01d8))
#define     rtp1r  (*(volatile union byte_def *)	(0x01d9))
#define     rtp2r  (*(volatile union byte_def *)	(0x01da))
#define     rtp3r  (*(volatile union byte_def *)	(0x01db))



/************************************************************************
*   CAN 0 SFR Address area                                              *
************************************************************************/
#define c0sbs    (*(volatile union can01_sbsr *)   (0x0240))      /* CAN0 Slot Buffer Select Register */
#define c1sbs    (*(volatile union can01_sbsr *)   (0x0250))      /* CAN1 Slot Buffer Select Register */

#define c0slot0   (*(volatile union can01_msb *) (0x01e0))      /* CAN0 Message Slot Buffer 0 */
#define c0slot1   (*(volatile union can01_msb *) (0x01f0))      /* CAN0 Message Slot Buffer 1 */
#define c1slot0   (*(volatile union can01_msb *) (0x0260))      /* CAN1 Message Slot Buffer 0 */
#define c1slot1   (*(volatile union can01_msb *) (0x0270))      /* CAN1 Message Slot Buffer 1 */

#define c0afs     (*(volatile union can01_afsr *) (0x0244))      /* CAN0 Acceptance Filter Support Register */
#define c1afs     (*(volatile union can01_afsr *) (0x0254))      /* CAN1 Acceptance Filter Support Register */

#define u0brg  (*(volatile union byte_def *)     (0x0369))       /* UART0 bit rate generator */
#define u1brg  (*(volatile union byte_def *)     (0x02e9))       /* UART1 bit rate generator */
#define u2brg  (*(volatile union byte_def *)     (0x0339))       /* UART2 bit rate generator */
#define u3brg  (*(volatile union byte_def *)     (0x0329))       /* UART3 bit rate generator */
#define u4brg  (*(volatile union byte_def *)     (0x02f9))       /* UART4 bit rate generator */

#define iio10ic (*(volatile union icr1_byte_def *) (0x007f))       /* Intelligent I/O interrupt control register */

#define c0mctl0  (*(volatile union can01_mscr *)   (0x0230))      /* (BANK0) CAN0 Message Slot0 Control Register */
#define c0mctl1  (*(volatile union can01_mscr *)   (0x0231))      /* (BANK0) CAN0 Message Slot1 Control Register */
#define c0mctl2  (*(volatile union can01_mscr *)   (0x0232))      /* (BANK0) CAN0 Message Slot2 Control Register */
#define c0mctl3  (*(volatile union can01_mscr *)   (0x0233))      /* (BANK0) CAN0 Message Slot3 Control Register */
#define c0mctl4  (*(volatile union can01_mscr *)   (0x0234))      /* (BANK0) CAN0 Message Slot4 Control Register */
#define c0mctl5  (*(volatile union can01_mscr *)   (0x0235))      /* (BANK0) CAN0 Message Slot5 Control Register */
#define c0mctl6  (*(volatile union can01_mscr *)   (0x0236))      /* (BANK0) CAN0 Message Slot6 Control Register */
#define c0mctl7  (*(volatile union can01_mscr *)   (0x0237))      /* (BANK0) CAN0 Message Slot7 Control Register */
#define c0mctl8  (*(volatile union can01_mscr *)   (0x0238))      /* (BANK0) CAN0 Message Slot8 Control Register */
#define c0mctl9  (*(volatile union can01_mscr *)   (0x0239))      /* (BANK0) CAN0 Message Slot9 Control Register */
#define c0mctl10  (*(volatile union can01_mscr *)   (0x023a))      /* (BANK0) CAN0 Message Slot10 Control Register */
#define c0mctl11  (*(volatile union can01_mscr *)   (0x023b))      /* (BANK0) CAN0 Message Slot11 Control Register */
#define c0mctl12  (*(volatile union can01_mscr *)   (0x023c))      /* (BANK0) CAN0 Message Slot12 Control Register */
#define c0mctl13  (*(volatile union can01_mscr *)   (0x023d))      /* (BANK0) CAN0 Message Slot13 Control Register */
#define c0mctl14  (*(volatile union can01_mscr *)   (0x023e))      /* (BANK0) CAN0 Message Slot14 Control Register */
#define c0mctl15  (*(volatile union can01_mscr *)   (0x023f))      /* (BANK0) CAN0 Message Slot15 Control Register */

#define c0gmr0  (*(volatile unsigned char *) (0x0228))      /* (BANK1) CAN0 Global Mask Register 0 */
#define c0gmr1  (*(volatile unsigned char *) (0x0229))      /* (BANK1) CAN0 Global Mask Register 1 */
#define c0gmr2  (*(volatile unsigned char *) (0x022a))      /* (BANK1) CAN0 Global Mask Register 2 */
#define c0gmr3  (*(volatile unsigned char *) (0x022b))      /* (BANK1) CAN0 Global Mask Register 3 */
#define c0gmr4  (*(volatile unsigned char *) (0x022c))      /* (BANK1) CAN0 Global Mask Register 4 */
#define c0lmar0 (*(volatile unsigned char *) (0x0230))      /* (BANK1) CAN0 Local Mask A Register 0 */
#define c0lmar1 (*(volatile unsigned char *) (0x0231))      /* (BANK1) CAN0 Local Mask A Register 1 */
#define c0lmar2 (*(volatile unsigned char *) (0x0232))      /* (BANK1) CAN0 Local Mask A Register 2 */
#define c0lmar3 (*(volatile unsigned char *) (0x0233))      /* (BANK1) CAN0 Local Mask A Register 3 */
#define c0lmar4 (*(volatile unsigned char *) (0x0234))      /* (BANK1) CAN0 Local Mask A Register 4 */

#define c0lmbr0 (*(volatile unsigned char *) (0x0238))      /* (BANK1) CAN0 Local Mask B Register 0 */
#define c0lmbr1 (*(volatile unsigned char *) (0x0239))      /* (BANK1) CAN0 Local Mask B Register 1 */
#define c0lmbr2 (*(volatile unsigned char *) (0x023a))      /* (BANK1) CAN0 Local Mask B Register 2 */
#define c0lmbr3 (*(volatile unsigned char *) (0x023b))      /* (BANK1) CAN0 Local Mask B Register 3 */
#define c0lmbr4 (*(volatile unsigned char *) (0x023c))      /* (BANK1) CAN0 Local Mask B Register 4 */

#define tb3mr   (*(volatile union timer_byte_def *) (0x031b))       /* Timer B3 mode register */
#define tb4mr   (*(volatile union timer_byte_def *) (0x031c))       /* Timer B4 mode register */
#define tb5mr   (*(volatile union timer_byte_def *) (0x031d))       /* Timer B5 mode register */

#define u0mr    (*(volatile union uimr_tr_byte_def *) (0x0368))       /* UART0 transmit/receive mode register */
#define u1mr    (*(volatile union uimr_tr_byte_def *) (0x02e8))       /* UART1 transmit/receive mode register */
#define u2mr    (*(volatile union uimr_tr_byte_def *) (0x0338))       /* UART2 transmit/receive mode register */
#define u3mr    (*(volatile union uimr_tr_byte_def *) (0x0328))       /* UART3 transmit/receive mode register */
#define u4mr    (*(volatile union uimr_tr_byte_def *) (0x02f8))       /* UART4 transmit/receive mode register */
#define u5mr    (*(volatile union uimr_tr_byte_def *) (0x01c0))       /* UART5 transmit/receive mode register */
#define u6mr    (*(volatile union uimr_tr_byte_def *) (0x01c8))       /* UART6 transmit/receive mode register */

#define u0c0    (*(volatile union byte_def *)   (0x036c))       /* UART0 transmit/receive control register 0 */
#define u1c0    (*(volatile union byte_def *)   (0x02ec))       /* UART1 transmit/receive control register 0 */
#define u2c0    (*(volatile union byte_def *)   (0x033c))       /* UART2 transmit/receive control register 0 */
#define u3c0    (*(volatile union byte_def *)   (0x032c))       /* UART3 transmit/receive control register 0 */
#define u4c0    (*(volatile union byte_def *)   (0x02fc))       /* UART4 transmit/receive control register 0 */
#define u5c0    (*(volatile union byte_def *)   (0x01c4))       /* UART5 transmit/receive control register 0 */
#define u6c0    (*(volatile union byte_def *)   (0x01cc))       /* UART6 transmit/receive control register 0 */

#define u0rb    (*(volatile union uarti_reg_def *) (0x036e))       /* UART0 receive buffer register */
#define u1rb    (*(volatile union uarti_reg_def *) (0x02ee))       /* UART1 receive buffer register */
#define u2rb    (*(volatile union uarti_reg_def *) (0x033e))       /* UART2 receive buffer register */
#define u3rb    (*(volatile union uarti_reg_def *) (0x032e))       /* UART3 receive buffer register */
#define u4rb    (*(volatile union uarti_reg_def *) (0x02fe))       /* UART4 receive buffer register */



#define u0smr   (*(volatile union byte_def *)   (0x0367))       /* UART0 special mode register */
#define u1smr   (*(volatile union byte_def *)   (0x02e7))       /* UART1 special mode register */
#define u2smr   (*(volatile union byte_def *)   (0x0337))       /* UART2 special mode register */
#define u3smr   (*(volatile union byte_def *)   (0x0327))       /* UART3 special mode register */
#define u4smr   (*(volatile union byte_def *)   (0x02f7))       /* UART4 special mode register */


#define u0smr2  (*(volatile union byte_def *)   (0x0366))       /* UART0 special mode register 2 */
#define u1smr2  (*(volatile union byte_def *)   (0x02e6))       /* UART1 special mode register 2 */
#define u2smr2  (*(volatile union byte_def *)   (0x0336))       /* UART2 special mode register 2 */
#define u3smr2  (*(volatile union byte_def *)   (0x0326))       /* UART3 special mode register 2 */
#define u4smr2  (*(volatile union byte_def *)   (0x02f6))       /* UART4 special mode register 2 */

#define u0smr3  (*(volatile union byte_def *)   (0x0365))       /* UART0 special mode register 3 */
#define u1smr3  (*(volatile union byte_def *)   (0x02e5))       /* UART1 special mode register 3 */
#define u2smr3  (*(volatile union byte_def *)   (0x0335))       /* UART2 special mode register 3 */
#define u3smr3  (*(volatile union byte_def *)   (0x0325))       /* UART3 special mode register 3 */
#define u4smr3  (*(volatile union byte_def *)   (0x02f5))       /* UART4 special mode register 3 */

#define u0smr4  (*(volatile union byte_def *)   (0x0364))       /* UART0 special mode register 4 */ 
#define u1smr4  (*(volatile union byte_def *)   (0x02e4))       /* UART1 special mode register 4 */ 
#define u2smr4  (*(volatile union byte_def *)   (0x0334))       /* UART2 special mode register 4 */ 
#define u3smr4  (*(volatile union byte_def *)   (0x0324))       /* UART3 special mode register 4 */ 
#define u4smr4  (*(volatile union byte_def *)   (0x02f4))       /* UART4 special mode register 4 */ 

#define dm0sl   (*(volatile union byte_def *)   (0x0378))       /* DMA0 cause select register */
#define dm1sl   (*(volatile union byte_def *)   (0x0379))       /* DMA1 cause select register */
#define dm2sl   (*(volatile union byte_def *)   (0x037a))       /* DMA2 cause select register */
#define dm3sl   (*(volatile union byte_def *)   (0x037b))       /* DMA3 cause select register */

#define c0ctlr0 (*(volatile union can01_cr0 *)  (0x0200))		/* CAN0 Control Register 0 */
#define c1ctlr0 (*(volatile union can01_cr0 *)  (0x0280))		/* CAN1 Control Register 0 */

#define c0ctlr1 (*(volatile union can01_cr1 *)  (0x0241))		/* CAN0 Control Register 1 */
#define c1ctlr1 (*(volatile union can01_cr1 *)  (0x0251))		/* CAN1 Control Register 1 */ 

#define c0slpr  (*(volatile union can01_scr *)   (0x0242))      /* CAN0 Sleep Control Register */
#define c1slpr  (*(volatile union can01_scr *)   (0x0252))      /* CAN1 Sleep Control Register */

#define c1str   (*(volatile union can01_sr *)   (0x0282))      /* CAN1 Status Register */
#define c0str   (*(volatile union can01_sr *)   (0x0202))      /* CAN0 Status Register */

#define c0simkr (*(volatile union can01_simr *) (0x0210))      /* CAN0 Slot Interrupt Mask Register */
#define c1simkr (*(volatile union can01_simr *) (0x0290))      /* CAN1 Slot Interrupt Mask Register */

#define c0idr   (*(volatile union can01_eir *)  (0x0204))      /* CAN0 Extended ID Register */
#define c1idr   (*(volatile union can01_eir *)   (0x0284))      /* CAN1 Extended ID Register */

#define c0conr  (*(volatile union can01_cr *)   (0x0206))      /* CAN0 Configuration Register */
#define c1conr  (*(volatile union can01_cr *)   (0x0286))      /* CAN1 Configuration Register */

#define c0tsr  (*(volatile union can01_stmpr *) (0x0208))      /* CAN0 Time Stamp Register */
#define c1tsr  (*(volatile union can01_stmpr *) (0x0288))      /* CAN1 Time Stamp Register */

#define c0tec  (*(volatile unsigned char *) (0x020a))      /* CAN0 Transmit Error Counter */
#define c1tec  (*(volatile unsigned char *) (0x028a))      /* CAN1 Transmit Error Counter */
#define c0rec  (*(volatile unsigned char *) (0x020b))      /* CAN0 Receive Error Counter */
#define c1rec  (*(volatile unsigned char *) (0x028b))      /* CAN1 Receive Error Counter */
#define c0brp  (*(volatile unsigned char *) (0x0217))      /* CAN0 Baud Rate Prescaler */
#define c1brp  (*(volatile unsigned char *) (0x0297))      /* CAN1 Baud Rate Prescaler */

#define c1eimkr (*(volatile union can01_eimr *) (0x0294))      /* CAN1 Error Interrupt Mask Register */
#define c1sistr (*(volatile union can01_sisr *) (0x028c))      /* CAN1 Slot Interrupt Status Register */

#define c0eimkr (*(volatile union can01_eimr *) (0x0214))      /* CAN0 Error Interrupt Mask Register */
#define c0sistr (*(volatile union can01_sisr *) (0x020c))      /* CAN0 Slot Interrupt Status Register */

#define c0eistr (*(volatile union can01_eisr *) (0x0215))      /* CAN0 Error Interrupt Status Register */
#define c0efr   (*(volatile union can01_efr *) (0x0216))      /* CAN0 Error Factor Register  */
#define c0mdr   (*(volatile union can01_mr *) (0x0219))      /* CAN0 Mode Register */

#define c1eistr (*(volatile union can01_eisr *) (0x0295))      /* CAN1 Error Interrupt Status Register */
#define c1efr   (*(volatile union can01_efr *)  (0x0296))      /* CAN1 Error Factor Register  */
#define c1mdr   (*(volatile union can01_mr *)   (0x0299))      /* CAN1 Mode Register */

#define c1ssctlr (*(volatile union can01_sscr *) (0x02A0))      /* (BANK0) CAN1 Single Shot Control Register */
#define c1ssstr (*(volatile union can01_sssr *) (0x02A4))      /* (BANK0) CAN1 Single Shot Status Register */

#define c0ssctlr (*(volatile union can01_sscr *) (0x0220))      /* (BANK0) CAN0 Single Shot Control Register */
#define c0ssstr (*(volatile union can01_sssr *) (0x0224))      /* (BANK0) CAN0 Single Shot Status Register */

#define c0gmr (*(volatile union can01_glmr *)   (0x0228))      /* (BANK1) CAN0 Global Mask Register */
#define c1gmr  (*(volatile union can01_glmr *)  (0x02a8))      /* (BANK1) CAN1 Global Mask Register */
#define c0lmar (*(volatile union can01_glmr *)  (0x0230))      /* (BANK1) CAN0 Local Mask A Register */
#define c1lmar (*(volatile union can01_glmr *)  (0x02b0))      /* (BANK1) CAN1 Local Mask A Register */
#define c0lmbr (*(volatile union can01_glmr *)  (0x0238))      /* (BANK1) CAN0 Local Mask B Register */
#define c1lmbr  (*(volatile union can01_glmr *)  (0x02b8))      /* (BANK1) CAN1 Local Mask B Register */

#define c1mctl0  (*(volatile union can01_mscr *)   (0x02B0))      /* (BANK0) CAN1 Message Slot0 Control Register */
#define c1mctl1  (*(volatile union can01_mscr *)   (0x02B1))      /* (BANK0) CAN1 Message Slot1 Control Register */
#define c1mctl2  (*(volatile union can01_mscr *)   (0x02B2))      /* (BANK0) CAN1 Message Slot2 Control Register */
#define c1mctl3  (*(volatile union can01_mscr *)   (0x02B3))      /* (BANK0) CAN1 Message Slot3 Control Register */
#define c1mctl4  (*(volatile union can01_mscr *)   (0x02B4))      /* (BANK0) CAN1 Message Slot4 Control Register */
#define c1mctl5  (*(volatile union can01_mscr *)   (0x02B5))      /* (BANK0) CAN1 Message Slot5 Control Register */
#define c1mctl6  (*(volatile union can01_mscr *)   (0x02B6))      /* (BANK0) CAN1 Message Slot6 Control Register */
#define c1mctl7  (*(volatile union can01_mscr *)   (0x02B7))      /* (BANK0) CAN1 Message Slot7 Control Register */
#define c1mctl8  (*(volatile union can01_mscr *)   (0x02B8))      /* (BANK0) CAN1 Message Slot8 Control Register */
#define c1mctl9  (*(volatile union can01_mscr *)   (0x02B9))      /* (BANK0) CAN1 Message Slot9 Control Register */
#define c1mctl10  (*(volatile union can01_mscr *)   (0x02ba))      /* (BANK0) CAN1 Message Slot10 Control Register */
#define c1mctl11  (*(volatile union can01_mscr *)   (0x02bb))      /* (BANK0) CAN1 Message Slot11 Control Register */
#define c1mctl12  (*(volatile union can01_mscr *)   (0x02bc))      /* (BANK0) CAN1 Message Slot12 Control Register */
#define c1mctl13  (*(volatile union can01_mscr *)   (0x02bd))      /* (BANK0) CAN1 Message Slot13 Control Register */
#define c1mctl14  (*(volatile union can01_mscr *)   (0x02be))      /* (BANK0) CAN1 Message Slot14 Control Register */
#define c1mctl15  (*(volatile union can01_mscr *)   (0x02bf))      /* (BANK0) CAN1 Message Slot15 Control Register */

#define c1gmr0  (*(volatile unsigned char *) (0x02a8))      /* (BANK1) CAN1 Global Mask Register 0 */
#define c1gmr1  (*(volatile unsigned char *) (0x02a9))      /* (BANK1) CAN1 Global Mask Register 1 */
#define c1gmr2  (*(volatile unsigned char *) (0x02aa))      /* (BANK1) CAN1 Global Mask Register 2 */
#define c1gmr3  (*(volatile unsigned char *) (0x02ab))      /* (BANK1) CAN1 Global Mask Register 3 */
#define c1gmr4  (*(volatile unsigned char *) (0x02ac))      /* (BANK1) CAN1 Global Mask Register 4 */
#define c1lmar0  (*(volatile unsigned char *) (0x02b0))      /* (BANK1) CAN1 Local Mask A Register 0 */
#define c1lmar1  (*(volatile unsigned char *) (0x02b1))      /* (BANK1) CAN1 Local Mask A Register 1 */
#define c1lmar2  (*(volatile unsigned char *) (0x02b2))      /* (BANK1) CAN1 Local Mask A Register 2 */
#define c1lmar3  (*(volatile unsigned char *) (0x02b3))      /* (BANK1) CAN1 Local Mask A Register 3 */
#define c1lmar4  (*(volatile unsigned char *) (0x02b4))      /* (BANK1) CAN1 Local Mask A Register 4 */

#define c1lmbr0  (*(volatile unsigned char *) (0x02b8))      /* (BANK1) CAN1 Local Mask B Register 0 */
#define c1lmbr1  (*(volatile unsigned char *) (0x02b9))      /* (BANK1) CAN1 Local Mask B Register 1 */
#define c1lmbr2  (*(volatile unsigned char *) (0x02ba))      /* (BANK1) CAN1 Local Mask B Register 2 */
#define c1lmbr3  (*(volatile unsigned char *) (0x02bb))      /* (BANK1) CAN1 Local Mask B Register 3 */
#define c1lmbr4  (*(volatile unsigned char *) (0x02bc))      /* (BANK1) CAN1 Local Mask B Register 4 */


/************************************************************************
*                                                                       *
************************************************************************/
#define     x0r    (*(volatile union uarti_reg_def*)	(0x02c0))       /* X0 register */
#define     y0r    (*(volatile union uarti_reg_def*)    (0x02c0))       /* Y0 register */
#define     x1r    (*(volatile union uarti_reg_def*)	(0x02c2))       /* X1 register */
#define     y1r    (*(volatile union uarti_reg_def*)	(0x02c2))       /* Y1 register */
#define     x2r    (*(volatile union uarti_reg_def*)	(0x02c4))       /* X2 register */
#define     y2r    (*(volatile union uarti_reg_def*)	(0x02c4))       /* Y2 register */
#define     x3r    (*(volatile union uarti_reg_def*)	(0x02c6))       /* X3 register */
#define     y3r    (*(volatile union uarti_reg_def*)	(0x02c6))       /* Y3 register */
#define     x4r    (*(volatile union uarti_reg_def*)	(0x02c8))       /* X4 register */
#define     y4r    (*(volatile union uarti_reg_def*)	(0x02c8))       /* Y4 register */
#define     x5r    (*(volatile union uarti_reg_def*)	(0x02ca))       /* X5 register */
#define     y5r    (*(volatile union uarti_reg_def*)	(0x02ca))       /* Y5 register */
#define     x6r    (*(volatile union uarti_reg_def*)	(0x02cc))       /* X6 register */
#define     y6r    (*(volatile union uarti_reg_def*)	(0x02cc))       /* Y6 register */
#define     x7r    (*(volatile union uarti_reg_def*)	(0x02ce))       /* X7 register */
#define     y7r    (*(volatile union uarti_reg_def*)	(0x02ce))       /* Y7 register */
#define     x8r    (*(volatile union uarti_reg_def*)	(0x02d0))       /* X8 register */
#define     y8r    (*(volatile union uarti_reg_def*)	(0x02d0))       /* Y8 register */
#define     x9r    (*(volatile union uarti_reg_def*)	(0x02d2))       /* X9 register */
#define     y9r    (*(volatile union uarti_reg_def*)	(0x02d2))       /* Y9 register */
#define     x10r   (*(volatile union uarti_reg_def*)	(0x02d4))       /* X10 register */
#define     y10r   (*(volatile union uarti_reg_def*)	(0x02d4))       /* Y10 register */
#define     x11r   (*(volatile union uarti_reg_def*)	(0x02d6))       /* X11 register */
#define     y11r   (*(volatile union uarti_reg_def*)	(0x02d6))       /* Y11 register */
#define     x12r   (*(volatile union uarti_reg_def*)	(0x02d8))       /* X12 register */
#define     y12r   (*(volatile union uarti_reg_def*)	(0x02d8))       /* Y12 register */
#define     x13r   (*(volatile union uarti_reg_def*)	(0x02da))       /* X13 register */
#define     y13r   (*(volatile union uarti_reg_def*)	(0x02da))       /* Y13 register */
#define     x14r   (*(volatile union uarti_reg_def*)	(0x02dc))       /* X14 register */
#define     y14r   (*(volatile union uarti_reg_def*)	(0x02dc))       /* Y14 register */
#define     x15r   (*(volatile union uarti_reg_def*)	(0x02de))       /* X15 register */
#define     y15r   (*(volatile union uarti_reg_def*)	(0x02de))       /* Y15 register */
#define     xyc    (*(volatile union byte_def *)	   (0x02e0))       /* X-Y control register */



#define     u1tb   (*(volatile union uarti_reg_def*)	(0x02ea))       /* UART1 transmit buffer register */

#define     u1c1   (*(volatile union uic1_def *)		(0x02ed))       /* UART1 transmit/receive control register 1 */




#define     u4tb   (*(volatile union uarti_reg_def*)	(0x02fa))       /* UART4 transmit buffer register */
#define     u4c1   (*(volatile union uic1_def *)	(0x02fd))       /* UART4 transmit/receive control register 1 */


#define     tbsr   (*(volatile union byte_def *)	(0x0300))       /* Timer B3,4,5 count start flag */

#define     ta11   (*(volatile unsigned short *)	(0x0302))       /* Timer A1-1 register */
#define     ta21   (*(volatile unsigned short *)	(0x0304))       /* Timer A2-1 register */
#define     ta41   (*(volatile unsigned short *)	(0x0306))       /* Timer A4-1 register */
#define     invc0  (*(volatile union byte_def *)	(0x0308))       /* Three-phase PWM control register 0 */
#define     invc1  (*(volatile union byte_def *)	(0x0309))       /* Three-phase PWM control register 1 */
#define     idb0   (*(volatile union byte_def *)	(0x030a))       /* Three-phase output buffer register 0 */
#define     idb1   (*(volatile union byte_def *)	(0x030b))       /* Three-phase output buffer register 1 */
#define     dtt    (*(volatile union byte_def *)	(0x030c))       /* Dead time timer */
#define     ictb2  (*(volatile union byte_def *)	(0x030d))       /* Timer B2 interrupt occurences frequency set counter */


#define     tb3    (*(volatile unsigned short *)	(0x0310))       /* Timer B3 register */
#define     tb4    (*(volatile unsigned short *)	(0x0312))       /* Timer B4 register */
#define     tb5    (*(volatile unsigned short *)	(0x0314))       /* Timer B5 register */



#define     ifsra  (*(volatile union byte_def *)	(0x031e))       /* External interrupt request cause select register 1 */
#define     ifsr   (*(volatile union byte_def *)	(0x031f))       /* External interrupt request cause select register */



#define     u3tb   (*(volatile union uarti_reg_def*)(0x032a))       /* UART3 transmit buffer register */
#define     u3c1   (*(volatile union uic1_def *)	(0x032d))       /* UART3 transmit/receive control register 1 */




#define     u2tb   (*(volatile union uarti_reg_def*)(0x033a))       /* UART2 transmit buffer register */
#define     u2c1   (*(volatile union uic1_def *)	(0x033d))       /* UART2 transmit/receive control register 1 */

#define     tabsr  (*(volatile union byte_def *)	(0x0340))       /* Count start flag */
#define     cpsrf  (*(volatile union byte_def *)	(0x0341))       /* Clock prescaler reset flag */
#define     onsf   (*(volatile union byte_def *)	(0x0342))       /* One-shot start flag */
#define     trgsr  (*(volatile union byte_def *)	(0x0343))       /* Trigger select register */
#define     udf    (*(volatile union byte_def *)	(0x0344))       /* Up/down flag */

#define     ta0    (*(volatile unsigned short *)	(0x0346))       /* Timer A0 register */
#define     ta1    (*(volatile unsigned short *)	(0x0348))       /* Timer A1 register */
#define     ta2    (*(volatile unsigned short *)	(0x034a))       /* Timer A2 register */
#define     ta3    (*(volatile unsigned short *)	(0x034c))       /* Timer A3 register */
#define     ta4    (*(volatile unsigned short *)	(0x034e))      /* Timer A4 register */
#define     tb0    (*(volatile unsigned short *)	(0x0350))      /* Timer B0 register */
#define     tb1    (*(volatile unsigned short *)	(0x0352))       /* Timer B1 register */
#define     tb2    (*(volatile unsigned short *)	(0x0354))       /* Timer B2 register */
#define ta0mr   (*(volatile union timer_byte_def *) (0x0356))       /* Timer A0 mode register */
#define ta1mr   (*(volatile union timer_byte_def *) (0x0357))       /* Timer A1 mode register */
#define ta2mr   (*(volatile union timer_byte_def *) (0x0358))       /* Timer A2 mode register */
#define ta3mr   (*(volatile union timer_byte_def *) (0x0359))       /* Timer A3 mode register */
#define ta4mr   (*(volatile union timer_byte_def *) (0x035a))       /* Timer A4 mode register */
#define tb0mr   (*(volatile union timer_byte_def *) (0x035b))       /* Timer B0 mode register */
#define tb1mr   (*(volatile union timer_byte_def *) (0x035c))       /* Timer B1 mode register */

#define     tb2sc  (*(volatile union byte_def *)	(0x035e))       /* Timer B2 special mode register */
#define     tcspr  (*(volatile union byte_def *)	(0x035f))       /* Count source prescaler register */



#define     u0tb   (*(volatile union uarti_reg_def*) (0x036a))       /* UART0 transmit buffer register */

#define     u0c1   (*(volatile union uic1_def *)	 (0x036d))       /* UART0 transmit/receive control register 1 */

#define     ircon  (*(volatile union byte_def *)	(0x0372))

#define     crcd   (*(volatile union uarti_reg_def*)	(0x037c))       /* CRC data register */
#define     crcin  (*(volatile union byte_def *)	    (0x037e))       /* CRC input register */

#define     ad00   (*(volatile union uarti_reg_def*)	(0x0380))       /* A/D0 register 0 */
#define     ad01   (*(volatile union uarti_reg_def*)	(0x0382))       /* A/D0 register 1 */
#define     ad02   (*(volatile union uarti_reg_def*)	(0x0384))       /* A/D0 register 2 */
#define     ad03   (*(volatile union uarti_reg_def*)	(0x0386))       /* A/D0 register 3 */
#define     ad04   (*(volatile union uarti_reg_def*)	(0x0388))      /* A/D0 register 4 */
#define     ad05   (*(volatile union uarti_reg_def*)	(0x038a))      /* A/D0 register 5 */
#define     ad06   (*(volatile union uarti_reg_def*)	(0x038c))      /* A/D0 register 6 */
#define     ad07   (*(volatile union uarti_reg_def*)	(0x038e))     /* A/D0 register 7 */


#define     ad0con4 (*(volatile union byte_def *)	(0x0392))      /* A/D0 control register 4 */
#define     ad0con2 (*(volatile union byte_def *)	(0x0394))      /* A/D0 control register 2 */
#define     ad0con3 (*(volatile union byte_def *)	(0x0395))      /* A/D0 control register 3 */
#define     ad0con0 (*(volatile union byte_def *)	(0x0396))      /* A/D0 control register 0 */
#define     ad0con1 (*(volatile union byte_def *)	(0x0397))      /* A/D0 control register 1 */

#define     da0     (*(volatile char *)				(0x0398))       /* D/A register 0 */
#define     da1     (*(volatile char *)				(0x039a))       /* D/A register 1 */

#define     dacon   (*(volatile union byte_def *)	(0x039c))       /* D/A control register */
#define     dacon1  (*(volatile union byte_def *)	(0x039d))       /* D/A control register 1 */


#define ps8    (*(volatile union byte_def *)     (0x03a0))      /* Function select register A8 */
#define ps9    (*(volatile union byte_def *)     (0x03a1))      /* Function select register A9 */

#define psl9   (*(volatile union byte_def *)     (0x03a3))       /* Function select register B9 */
#define pse2   (*(volatile union byte_def *)     (0x03a4))       /* Function select register E2 */

#define psd1   (*(volatile union byte_def *)     (0x03a7))       /* Function select register D1 */
#define psd2   (*(volatile union byte_def *)     (0x03a8))       /* Function select register D2 */

#define psc6   (*(volatile union byte_def *)     (0x03aa))       /* Function select register C6 */
#define pse1   (*(volatile union byte_def *)     (0x03ab))       /* Function select register E1 */
#define psc2   (*(volatile union byte_def *)     (0x03ac))       /* Function select register C2 */
#define psc3   (*(volatile union byte_def *)     (0x03ad))       /* Function select register C3 */

#define psc    (*(volatile union byte_def *)     (0x03af))       /* Function select register C */
#define ps0    (*(volatile union byte_def *)     (0x03b0))       /* Function select register A0 */
#define ps1    (*(volatile union byte_def *)     (0x03b1))       /* Function select register A1 */
#define psl0   (*(volatile union byte_def *)     (0x03b2))       /* Function select register B0 */
#define psl1   (*(volatile union byte_def *)     (0x03b3))       /* Function select register B1 */
#define ps2    (*(volatile union byte_def *)     (0x03b4))       /* Function select register A2 */
#define ps3    (*(volatile union byte_def *)     (0x03b5))       /* Function select register A3 */
#define psl2   (*(volatile union byte_def *)     (0x03b6))       /* Function select register B2 */
#define psl3   (*(volatile union byte_def *)	 (0x03b7))       /* Function select register B3 */
#define ps4    (*(volatile union byte_def *)     (0x03b8))       /* Function select register A4 */
#define ps5	   (*(volatile union byte_def *)     (0x03b9))       /* Function select register A5 */
#define	ps6	   (*(volatile union byte_def *)     (0x03bc))       /* Function select register A6 */
#define	ps7	   (*(volatile union byte_def *)     (0x03bd))       /* Function select register A7 */
#define psl6   (*(volatile union byte_def *)     (0x03be))       /* Function select register B6 */

#define     p6     (*(volatile union byte_def *)	(0x03c0))       /* Port P6 register */
#define     p7     (*(volatile union byte_def *)	(0x03c1))       /* Port P7 register */
#define     pd6    (*(volatile union byte_def *)	(0x03c2))       /* Port P6 direction register */
#define     pd7    (*(volatile union byte_def *)	(0x03c3))       /* Port P7 direction register */
#define     p8     (*(volatile union byte_def *)	(0x03c4))       /* Port P8 register */
#define     p9     (*(volatile union byte_def *)	(0x03c5))       /* Port P9 register */
#define     pd8    (*(volatile union byte_def *)	(0x03c6))       /* Port P8 direction register */
#define     pd9    (*(volatile union byte_def *)	(0x03c7))       /* Port P9 direction register */
#define     p10    (*(volatile union byte_def *)	(0x03c8))       /* Port P10 register */
#define     p11    (*(volatile union byte_def *)	(0x03c9))       /* Port P11 register */
#define     pd10   (*(volatile union byte_def *)	(0x03ca))       /* Port P10 direction register */
#define     pd11   (*(volatile union byte_def *)	(0x03cb))       /* Port P11 direction register */
#define     p12    (*(volatile union byte_def *)	(0x03cc))       /* Port P12 register */
#define     p13    (*(volatile union byte_def *)	(0x03cd))      /* Port P13 register */
#define     pd12   (*(volatile union byte_def *)	(0x03ce))       /* Port P12 direction register */
#define     pd13   (*(volatile union byte_def *)	(0x03cf))       /* Port P13 direction register */
#define     p14    (*(volatile union byte_def *)	(0x03d0))       /* Port P14 register */
#define     p15    (*(volatile union byte_def *)	(0x03d1))       /* Port P15 register */
#define     pd14   (*(volatile union byte_def *)	(0x03d2))       /* Port P14 direction register */
#define     pd15   (*(volatile union byte_def *)	(0x03d3))       /* Port P15 direction register */


#define     pur2   (*(volatile union byte_def *)	(0x03da))       /* Pull-up control register 2 */
#define     pur3   (*(volatile union byte_def *)	(0x03db))       /* Pull-up control register 3 */
#define     pur4   (*(volatile union byte_def *)	(0x03dc))       /* Pull-up control register 4 */


#define     p0     (*(volatile union byte_def *)	(0x03e0))       /* Port P0 register */
#define     p1     (*(volatile union byte_def *)	(0x03e1))       /* Port P1 register */
#define     pd0    (*(volatile union byte_def *)	(0x03e2))       /* Port P0 direction register */
#define     pd1    (*(volatile union byte_def *)	(0x03e3))       /* Port P1 direction register */
#define     p2     (*(volatile union byte_def *)	(0x03e4))       /* Port P2 register */
#define     p3     (*(volatile union byte_def *)	(0x03e5))       /* Port P3 register */
#define     pd2    (*(volatile union byte_def *)	(0x03e6))       /* Port P2 direction register */
#define     pd3    (*(volatile union byte_def *)	(0x03e7))       /* Port P3 direction register */
#define     p4     (*(volatile union byte_def *)	(0x03e8))       /* Port P4 register */
#define     p5     (*(volatile union byte_def *)	(0x03e9))       /* Port P5 register */
#define     pd4    (*(volatile union byte_def *)	(0x03ea))       /* Port P4 direction register */
#define     pd5    (*(volatile union byte_def *)	(0x03eb))       /* Port P5 direction register */


#define     pur0   (*(volatile union byte_def *)	(0x03f0))       /* Pull-up control register 0 */
#define     pur1   (*(volatile union byte_def *)	(0x03f1))       /* Pull-up control register 1 */


#define     pcr    (*(volatile union byte_def *)	(0x03ff))       /* Port control register */

/*---------------------------------------------------------------------
    IIO registers ; Read and write to this register in 16-bit units.
-----------------------------------------------------------------------*/

/********************************************************
*   group 0 and 1 and 2                                 *
********************************************************/
#define     g1btw        g1bt.word        /* Base Timer Register 1 */
#define     g1btl       g1bt.byte.low
#define     g1bth       g1bt.byte.high

#define     g1tm0w        g1tm0.word      /* Time Measurement Register 10 */
#define     g1tm0l       g1tm0.byte.low
#define     g1tm0h       g1tm0.byte.high

#define     g1tm1w        g1tm1.word      /* Time Measurement Register 11 */
#define     g1tm1l       g1tm1.byte.low
#define     g1tm1h       g1tm1.byte.high

#define     g1tm2w        g1tm2.word      /* Time Measurement Register 12 */
#define     g1tm2l       g1tm2.byte.low
#define     g1tm2h       g1tm2.byte.high

#define     g1tm3w        g1tm3.word      /* Time Measurement Register 13 */
#define     g1tm3l       g1tm3.byte.low
#define     g1tm3h       g1tm3.byte.high

#define     g1tm4w        g1tm4.word      /* Time Measurement Register 14 */
#define     g1tm4l       g1tm4.byte.low
#define     g1tm4h       g1tm4.byte.high

#define     g1tm5w        g1tm5.word      /* Time Measurement Register 15 */
#define     g1tm5l       g1tm5.byte.low
#define     g1tm5h       g1tm5.byte.high

#define     g1tm6w        g1tm6.word      /* Time Measurement Register 16 */
#define     g1tm6l       g1tm6.byte.low
#define     g1tm6h       g1tm6.byte.high

#define     g1tm7w        g1tm7.word      /* Time Measurement Register 17 */
#define     g1tm7l       g1tm7.byte.low
#define     g1tm7h       g1tm7.byte.high

#define     g1po0w        g1po0.word      /* Waveform Generate Register 10 */
#define     g1po0l       g1po0.byte.low
#define     g1po0h       g1po0.byte.high

#define     g1po1w        g1po1.word      /* Waveform Generate Register 11 */
#define     g1po1l       g1po1.byte.low
#define     g1po1h       g1po1.byte.high

#define     g1po2w        g1po2.word      /* Waveform Generate Register 12 */
#define     g1po2l       g1po2.byte.low
#define     g1po2h       g1po2.byte.high

#define     g1po3w        g1po3.word      /* Waveform Generate Register 13 */
#define     g1po3l       g1po3.byte.low
#define     g1po3h       g1po3.byte.high

#define     g1po4w        g1po4.word      /* Waveform Generate Register 14 */
#define     g1po4l       g1po4.byte.low
#define     g1po4h       g1po4.byte.high

#define     g1po5w        g1po5.word      /* Waveform Generate Register 15 */
#define     g1po5l       g1po5.byte.low
#define     g1po5h       g1po5.byte.high

#define     g1po6w        g1po6.word      /* Waveform Generate Register 16 */
#define     g1po6l       g1po6.byte.low
#define     g1po6h       g1po6.byte.high

#define     g1po7w        g1po7.word      /* Waveform Generate Register 17 */
#define     g1po7l       g1po7.byte.low
#define     g1po7h       g1po7.byte.high

#define     g2btw         g2bt.word        /* Base Timer Register 2 */
#define     g2btl        g2bt.byte.low
#define     g2bth        g2bt.byte.high

#define     g2po0w        g2po0.word      /* Waveform Generate Register 20 */
#define     g2po0l       g2po0.byte.low
#define     g2po0h       g2po0.byte.high

#define     g2po1w        g2po1.word      /* Waveform Generate Register 21 */
#define     g2po1l       g2po1.byte.low
#define     g2po1h       g2po1.byte.high

#define     g2po2w        g2po2.word      /* Waveform Generate Register 22 */
#define     g2po2l       g2po2.byte.low
#define     g2po2h       g2po2.byte.high

#define     g2po3w        g2po3.word      /* Waveform Generate Register 23 */
#define     g2po3l       g2po3.byte.low
#define     g2po3h       g2po3.byte.high

#define     g2po4w        g2po4.word      /* Waveform Generate Register 24 */
#define     g2po4l       g2po4.byte.low
#define     g2po4h       g2po4.byte.high

#define     g2po5w        g2po5.word      /* Waveform Generate Register 25 */
#define     g2po5l       g2po5.byte.low
#define     g2po5h       g2po5.byte.high

#define     g2po6w        g2po6.word      /* Waveform Generate Register 26 */
#define     g2po6l       g2po6.byte.low
#define     g2po6h       g2po6.byte.high

#define     g2po7w        g2po7.word      /* Waveform Generate Register 27 */
#define     g2po7l       g2po7.byte.low
#define     g2po7h       g2po7.byte.high

#define     g0tcrcw        g0tcrc.word      /* Transmit CRC Code Register 0 */
#define     g0tcrcl       g0tcrc.byte.low
#define     g0tcrch       g0tcrc.byte.high

#define     g1tcrcw        g1tcrc.word      /* Transmit CRC Code Register 1 */
#define     g1tcrcl       g1tcrc.byte.low
#define     g1tcrch       g1tcrc.byte.high

#define     g0rcrcw        g0rcrc.word      /* Receive CRC Code Register 0 */
#define     g0rcrcl       g0rcrc.byte.low
#define     g0rcrch       g0rcrc.byte.high

#define     g1rcrcw        g1rcrc.word      /* Receive CRC Code Register 1 */
#define     g1rcrcl       g1rcrc.byte.low
#define     g1rcrch       g1rcrc.byte.high


/*------------------------------------------------------
    External Space Wait Control Register 0
------------------------------------------------------*/

#define     ewcr0b      ewcr0.byte

#define     ewcr000    ewcr0.bit.b0    /* (b4-b0) Bus cycle select bit */
#define     ewcr001    ewcr0.bit.b1
#define     ewcr002    ewcr0.bit.b2
#define     ewcr003    ewcr0.bit.b3
#define     ewcr004    ewcr0.bit.b4
                                            /* (b5) Nothing is assigned */
#define     ewcr006    ewcr0.bit.b6    /* Recovery cycle addition select bit */
                                            /* (b7) Nothing is assigned */
/*------------------------------------------------------
    External Space Wait Control Register 2
------------------------------------------------------*/

#define     ewcr2b      ewcr2.byte

#define     ewcr200    ewcr2.bit.b0    /* (b4-b0) Bus cycle select bit */
#define     ewcr201    ewcr2.bit.b1
#define     ewcr202    ewcr2.bit.b2
#define     ewcr203    ewcr2.bit.b3
#define     ewcr204    ewcr2.bit.b4
                                            /* (b5) Nothing is assigned */
#define     ewcr206    ewcr2.bit.b6    /* Recovery cycle addition select bit */
                                            /* (b7) Nothing is assigned */

/*------------------------------------------------------
    External Space Wait Control Register 3
------------------------------------------------------*/

#define     ewcr3b      ewcr3.byte

#define     ewcr300    ewcr3.bit.b0    /* (b4-b0) Bus cycle select bit */
#define     ewcr301    ewcr3.bit.b1
#define     ewcr302    ewcr3.bit.b2
#define     ewcr303    ewcr3.bit.b3
#define     ewcr304    ewcr3.bit.b4
                                            /* (b5) Nothing is assigned */
#define     ewcr306    ewcr3.bit.b6    /* Recovery cycle addition select bit */
                                            /* (b7) Nothing is assigned */

/*------------------------------------------------------
    Page Mode Wait Control Register 0
------------------------------------------------------*/

#define     pwcr0b      pwcr0.byte

#define     pwcr000    pwcr0.bit.b0    /* (b2-b0) External space 0 consecutive wait select bit */
#define     pwcr001    pwcr0.bit.b1
#define     pwcr002    pwcr0.bit.b2
#define     pwcr003    pwcr0.bit.b3    /* External space 0 page mode control enable bit */
#define     pwcr004    pwcr0.bit.b4    /* (b6-b4) External space 1 consecutive wait select bit */
#define     pwcr005    pwcr0.bit.b5
#define     pwcr006    pwcr0.bit.b6
#define     pwcr007    pwcr0.bit.b7    /* External space 1 page mode control enable bit */

/*------------------------------------------------------
    Page Mode Wait Control Register 1
------------------------------------------------------*/

#define     pwcr1b      pwcr1.byte

#define     pwcr100    pwcr1.bit.b0    /* (b2-b0) External space 2 consecutive wait select bit */
#define     pwcr101    pwcr1.bit.b1
#define     pwcr102    pwcr1.bit.b2
#define     pwcr103    pwcr1.bit.b3    /* External space 2 page mode control enable bit */
#define     pwcr104    pwcr1.bit.b4    /* (b6-b4) External space 3 consecutive wait select bit */
#define     pwcr105    pwcr1.bit.b5
#define     pwcr106    pwcr1.bit.b6
#define     pwcr107    pwcr1.bit.b7    /* External space 3 page mode control enable bit */

/*------------------------------------------------------
    Flash Memory control register 1
------------------------------------------------------*/

#define     fmr1b      fmr1.byte
                                            /* (b0) Reserved bit */
#define     fmr11     fmr1.bit.b1      /* EW1 mode select bit */
                                            /* (b3-b2) Reserved bit */
                                            /* (b5-b4) Reserved bit */
#define     fmr16     fmr1.bit.b6      /* Lock bit status flag */
                                            /* (b7) Reserved bit (Set to 0) */

/*------------------------------------------------------
    Flash Memory control register 0
------------------------------------------------------*/
#define     fmrw       fmr.word


#define     fmr0b      fmr0.byte

#define     fmr00     fmr0.bit.b0      /* RY/BY status flag */
#define     fmr01     fmr0.bit.b1      /* CPU rewrite mode select bit */
#define     fmr02     fmr0.bit.b2      /* Lock bit disable select bit */
#define     fmstp     fmr0.bit.b3      /* Flash memory stop bit */
                                            /* (b4) Reserved bit (Set to 0) */
#define     fmr05     fmr0.bit.b5      /* User ROM area select bit (Available in boot mode only) */
#define     fmr06     fmr0.bit.b6      /* Program status flag */
#define     fmr07     fmr0.bit.b7      /* Erase status flag */


/*------------------------------------------------------
    Processor mode register 0
------------------------------------------------------*/
#define     pm0b         pm0.byte

#define     pm00        pm0.bit.b0     /* Processor mode bit */
#define     pm01        pm0.bit.b1     /* Processor mode bit */
#define     pm02        pm0.bit.b2     /* R/W mode select bit */
#define     pm03        pm0.bit.b3     /* Software reset bit */
#define     pm04        pm0.bit.b4     /* Multiplexed bus space select bit */
#define     pm05        pm0.bit.b5     /* Multiplexed bus space select bit */
                                            /* (b6) Reserved bit (Set to 0) */
#define     pm07        pm0.bit.b7     /* BCLK output function select bit */

/*------------------------------------------------------
    Processor mode register 1
------------------------------------------------------*/

#define     pm1b        pm1.byte

#define     pm10        pm1.bit.b0     /* External memory area mode bit */
#define     pm11        pm1.bit.b1     /* External memory area mode bit */
#define     pm12        pm1.bit.b2     /* Internal memory wait bit */
#define     pm13        pm1.bit.b3     /* SFR wait bit */
#define     pm14        pm1.bit.b4     /* ALE pin select bit */
#define     pm15        pm1.bit.b5     /* ALE pin select bit */
                                            /* (b7-b6) Reserved bit (Set to 0) */

/*------------------------------------------------------
    Processor mode register 2
------------------------------------------------------*/

#define     pm2b         pm2.byte
                                            /* (b0) Reserved bit (Set to 0) */
#define     pm21        pm2.bit.b1     /* System clock protect bit */
#define     pm22        pm2.bit.b2     /* WDT count source protect bit */
                                            /* (b5-b3) Reserved bit (Set to 0) */
#define     pm26        pm2.bit.b6     /* (b7-b6) f2n count source select bit */
#define     pm27        pm2.bit.b7

/*------------------------------------------------------
    System clock control register 0
------------------------------------------------------*/

#define     cm0b        cm0.byte

#define     cm00        cm0.bit.b0     /* Clock output function select bit */
#define     cm01        cm0.bit.b1     /* Clock output function select bit */
#define     cm02        cm0.bit.b2     /* WAIT peripheral function clock stop bit */
#define     cm03        cm0.bit.b3     /* Xcin-Xcout drive capacity select bit */
#define     cm04        cm0.bit.b4     /* Port Xc select bit */
#define     cm05        cm0.bit.b5     /* Main clock stop bit */
#define     cm06        cm0.bit.b6     /* WDT function select bit */
#define     cm07        cm0.bit.b7     /* CPU clock select bit0 */

/*------------------------------------------------------
    System clock control register 1
------------------------------------------------------*/

#define     cm1b        cm1.byte

#define     cm10        cm1.bit.b0     /* All clock stop control bit */
                                            /* (b4-b1) Reserved bit (Set to 0) */
                                            /* (b5) Reserved bit (Set to 1) */
                                            /* (b6) Reserved bit (Set to 0) */
#define     cm17        cm1.bit.b7     /* CPU clock select bit1 */

/*------------------------------------------------------
    Oscillation stop detect register
------------------------------------------------------*/

#define     cm2b     	cm2.byte

#define     cm20        cm2.bit.b0     /* Oscillation stop detect enable bit */
#define     cm21        cm2.bit.b1     /* CPU clock select bit2 */
#define     cm22        cm2.bit.b2     /* Oscillation stop detect flag */
#define     cm23        cm2.bit.b3     /* Main clock monitor flag */
                                            /* (b7-b4) Reserved bit (Set to 0) */


/*------------------------------------------------------
    Address match interrupt enable register
------------------------------------------------------*/

#define     aierb       aier.byte

#define     aier0       aier.bit.b0    /* Address match interrupt 0 enable bit */
#define     aier1       aier.bit.b1    /* Address match interrupt 1 enable bit */
#define     aier2       aier.bit.b2    /* Address match interrupt 2 enable bit */
#define     aier3       aier.bit.b3    /* Address match interrupt 3 enable bit */
#define     aier4       aier.bit.b4    /* Address match interrupt 4 enable bit */
#define     aier5       aier.bit.b5    /* Address match interrupt 5 enable bit */
#define     aier6       aier.bit.b6    /* Address match interrupt 6 enable bit */
#define     aier7       aier.bit.b7    /* Address match interrupt 7 enable bit */

/*------------------------------------------------------
    X-Y control register
------------------------------------------------------*/

#define     xycb    	xyc.byte

#define     xyc0        xyc.bit.b0     /* Read-mode set bit */
#define     xyc1        xyc.bit.b1     /* Write-mode set bit */
                                            /* (b7-b2) Nothing is assigned */

/*------------------------------------------------------
    Protect register
------------------------------------------------------*/

#define     prcrb       prcr.byte

#define     prc0        prcr.bit.b0    /* Protect bit0 */
#define     prc1        prcr.bit.b1    /* Protect bit1 */
#define     prc2        prcr.bit.b2    /* Protect bit2 */
#define     prc3        prcr.bit.b3    /* Protect bit3 */
                                            /* (b7-b4) Nothing is assigned */

/*------------------------------------------------------
    External data bus width control register
------------------------------------------------------*/

#define     dsb     ds.byte

#define     ds0     ds.bit.b0          /* External space 0 data bus width select bit */
#define     ds1     ds.bit.b1          /* External space 1 data bus width select bit */
#define     ds2     ds.bit.b2          /* External space 2 data bus width select bit */
#define     ds3     ds.bit.b3          /* External space 3 data bus width select bit */
                                            /* (b7-b4) Nothing is assigned */

/*------------------------------------------------------
    Main clock division register
------------------------------------------------------*/

#define     mcdb        mcd.byte

#define     mcd0        mcd.bit.b0     /* (b4-b0) Main clock division select bit */
#define     mcd1        mcd.bit.b1
#define     mcd2        mcd.bit.b2
#define     mcd3        mcd.bit.b3
#define     mcd4        mcd.bit.b4
                                            /* (b7-b5) Reserved bit (Set to 0) */

/*------------------------------------------------------
   Count source prescaler register
------------------------------------------------------*/

#define     tcsprb      tcspr.byte

#define     cnt0        tcspr.bit.b0   /* (b3-b0) Divide ratio select bit */
#define     cnt1        tcspr.bit.b1
#define     cnt2        tcspr.bit.b2
#define     cnt3        tcspr.bit.b3
                                            /* (b6-b4) Reserved bit (Set to 0) */
#define     cst         tcspr.bit.b7   /* Operation enable bit */

/*------------------------------------------------------
    Exit priority register
------------------------------------------------------*/

#define     rlvlb       rlvl.byte

#define     rlvl0       rlvl.bit.b0    /* (b2-b0) Interrupt priority set bits to exit STOP/WAIT mode */
#define     rlvl1       rlvl.bit.b1
#define     rlvl2       rlvl.bit.b2
#define     fsit        rlvl.bit.b3    /* High-speed interrupt set bit */
                                            /* (b4) Nothing is assigned */
#define     dmaii       rlvl.bit.b5    /* DMAC II select bit */
                                            /* (b7-b6) Nothing is assigned */

/*------------------------------------------------------
    External interrupt request cause select register 1
------------------------------------------------------*/

#define     ifsrab      ifsra.byte

#define     ifsr10      ifsra.bit.b0   /* INT6 interrupt polarity select bit */
#define     ifsr11      ifsra.bit.b1   /* INT7 interrupt polarity select bit */
#define     ifsr12      ifsra.bit.b2   /* INT8 interrupt polarity select bit */
                                            /* (b7-b3) Reserved bit (Set to 0) */

/*------------------------------------------------------
    External interrupt request cause select register
------------------------------------------------------*/

#define     ifsrb       ifsr.byte

#define     ifsr0       ifsr.bit.b0    /* INT0 interrupt polarity select bit */
#define     ifsr1       ifsr.bit.b1    /* INT1 interrupt polarity select bit */
#define     ifsr2       ifsr.bit.b2    /* INT2 interrupt polarity select bit */
#define     ifsr3       ifsr.bit.b3    /* INT3 interrupt polarity select bit */
#define     ifsr4       ifsr.bit.b4    /* INT4 interrupt polarity select bit */
#define     ifsr5       ifsr.bit.b5    /* INT5 interrupt polarity select bit */
#define     ifsr6       ifsr.bit.b6    /* UART0,3 interrupt cause select bit */
#define     ifsr7       ifsr.bit.b7    /* UART1,4 interrupt cause select bit */

/*------------------------------------------------------
    Timer B2 special mode register
------------------------------------------------------*/

#define     tb2scb     tb2sc.byte

#define     pwcon     tb2sc.bit.b0     /* Timer B2 reload timing switching bit */
                                            /* (b7-b1) Nothing is assigned */

/*------------------------------------------------------
    Watchdog timer start register
------------------------------------------------------*/

#define     wdtsb        wdts.byte

/*------------------------------------------------------
    CRC input register
------------------------------------------------------*/

#define     crcinb       crcin.byte

/*------------------------------------------------------
    Watchdog timer control register
------------------------------------------------------*/

#define     wdcb     wdc.byte

                                            /* (b4-b0) High-order bits of the watchdog timer */
#define     wdc5        wdc.bit.b5     /* Cold start/warm start detect flag */
                                            /* (b6) Reserved bit (Set to 0) */
#define     wdc7        wdc.bit.b7     /* Prescaler select bit */

/*------------------------------------------------------
    Voltage detection register 1
------------------------------------------------------*/

#define     vcr1b       vcr1.byte
                                            /* (b2-b0) Reserved bit (Set to 0) */
#define     vc13        vcr1.bit.b3    /* Voltage down monitor flag */
                                            /* (b7-b4) Reserved bit (Set to 0) */

/*------------------------------------------------------
    Voltage detection register 2
------------------------------------------------------*/

#define     vcr2b       vcr2.byte
                                            /* (b5-b0) Reserved bit (Set to 0) */
#define     vc26        vcr2.bit.b6    /* Reset level monitor bit */
#define     vc27        vcr2.bit.b7    /* Voltage down monitor bit */

/*------------------------------------------------------
    Count start flag
------------------------------------------------------*/

#define     tabsrb       tabsr.byte

#define     ta0s        tabsr.bit.b0   /* Timer A0 count start flag */
#define     ta1s        tabsr.bit.b1   /* Timer A1 count start flag */
#define     ta2s        tabsr.bit.b2   /* Timer A2 count start flag */
#define     ta3s        tabsr.bit.b3   /* Timer A3 count start flag */
#define     ta4s        tabsr.bit.b4   /* Timer A4 count start flag */
#define     tb0s        tabsr.bit.b5   /* Timer B0 count start flag */
#define     tb1s        tabsr.bit.b6   /* Timer B1 count start flag */
#define     tb2s        tabsr.bit.b7   /* Timer B2 count start flag */

/*------------------------------------------------------
    Timer B3,4,5 count start flag
------------------------------------------------------*/

#define     tbsrb        tbsr.byte
                                            /* (b4-b0) Nothing is assigned */
#define     tb3s        tbsr.bit.b5    /* Timer B3 count start flag */
#define     tb4s        tbsr.bit.b6    /* Timer B4 count start flag */
#define     tb5s        tbsr.bit.b7    /* Timer B5 count start flag */

/*------------------------------------------------------
    Three-phase PWM control register 0
------------------------------------------------------*/

#define     invc0b       invc0.byte

#define     inv00       invc0.bit.b0   /* Interrupt enable output polarity select bit */
#define     inv01       invc0.bit.b1   /* Interrupt enable output specification bit */
#define     inv02       invc0.bit.b2   /* Mode select bit */
#define     inv03       invc0.bit.b3   /* Output control bit */
#define     inv04       invc0.bit.b4   /* Positive & negative phases concurrent active disable function enable bit */
#define     inv05       invc0.bit.b5   /* Positive & negative phases concurrent active output detect flag */
#define     inv06       invc0.bit.b6   /* Modulation mode select bit */
#define     inv07       invc0.bit.b7   /* Software trigger select bit */

/*------------------------------------------------------
    Three-phase PWM control register 1
------------------------------------------------------*/

#define     invc1b      invc1.byte

#define     inv10       invc1.bit.b0   /* Timer A1,A2 and A4 start trigger select bit */
#define     inv11       invc1.bit.b1   /* Timer A1-1,A2-1,A4-1 control bit */
#define     inv12       invc1.bit.b2   /* Dead time timer count source select bit */
#define     inv13       invc1.bit.b3   /* Carrier wave detect flag */
#define     inv14       invc1.bit.b4   /* Output polarity control bit */
#define     inv15       invc1.bit.b5   /* Dead time disable bit */
#define     inv16       invc1.bit.b6   /* Dead time timer trigger select bit */
                                            /* (b7) Reserved bit (Set to 0) */

/*------------------------------------------------------
    Three-phase output buffer register 0
------------------------------------------------------*/

#define     idb0b       idb0.byte

#define     du0         idb0.bit.b0    /*  U-phase output buffer 0 */
#define     dub0        idb0.bit.b1    /* ~U-phase output buffer 0 */
#define     dv0         idb0.bit.b2    /*  V-phase output buffer 0 */
#define     dvb0        idb0.bit.b3    /* ~V-phase output buffer 0 */
#define     dw0         idb0.bit.b4    /*  W-phase output buffer 0 */
#define     dwb0        idb0.bit.b5    /* ~W-phase output buffer 0 */
                                            /* (b7-b6) Reserved bit (Set to 0) */

/*------------------------------------------------------
    Three-phase output buffer register 1
------------------------------------------------------*/

#define     idb1b       idb1.byte

#define     du1         idb1.bit.b0    /*  U-phase output buffer 1 */
#define     dub1        idb1.bit.b1    /* ~U-phase output buffer 1 */
#define     dv1         idb1.bit.b2    /*  V-phase output buffer 1 */
#define     dvb1        idb1.bit.b3    /* ~V-phase output buffer 1 */
#define     dw1         idb1.bit.b4    /*  W-phase output buffer 1 */
#define     dwb1        idb1.bit.b5    /* ~W-phase output buffer 1 */
                                            /* (b7-b6) Reserved bit (Set to 0) */


/*------------------------------------------------------
     Dead time timer 
        (1) The MOV instruction should be used to set the DTT register
------------------------------------------------------*/

#define     dttb     dtt.byte

/*------------------------------------------------------
    Timer B2 interrupt generation frequency set counter 
        (1) The MOV instruction should be used to the ICTB2 register
------------------------------------------------------*/

#define     ictb2b   ictb2.byte     /* (b3-b0) function */
                                            /* (b7-b4) Nothing is assigned */

/*------------------------------------------------------
    One-shot start flag
------------------------------------------------------*/

#define     onsfb       onsf.byte

#define     ta0os       onsf.bit.b0    /* Timer A0 one-shot start flag */
#define     ta1os       onsf.bit.b1    /* Timer A1 one-shot start flag */
#define     ta2os       onsf.bit.b2    /* Timer A2 one-shot start flag */
#define     ta3os       onsf.bit.b3    /* Timer A3 one-shot start flag */
#define     ta4os       onsf.bit.b4    /* Timer A4 one-shot start flag */
#define     tazie       onsf.bit.b5    /* Z-phase input enable bit */
#define     ta0tgl      onsf.bit.b6    /* Timer A0 event/trigger select bit */
#define     ta0tgh      onsf.bit.b7    /* Timer A0 event/trigger select bit */

/*------------------------------------------------------
    Clock prescaler reset flag
------------------------------------------------------*/

#define     cpsrfb      cpsrf.byte
                                            /* (b6-b0) Nothing is assigned */
#define     cpsr        cpsrf.bit.b7   /* Clock prescaler reset flag */

/*------------------------------------------------------
    Trigger select register
------------------------------------------------------*/

#define     trgsrb      trgsr.byte

#define     ta1tgl      trgsr.bit.b0   /* Timer A1 event/trigger select bit */
#define     ta1tgh      trgsr.bit.b1   /* Timer A1 event/trigger select bit */
#define     ta2tgl      trgsr.bit.b2   /* Timer A2 event/trigger select bit */
#define     ta2tgh      trgsr.bit.b3   /* Timer A2 event/trigger select bit */
#define     ta3tgl      trgsr.bit.b4   /* Timer A3 event/trigger select bit */
#define     ta3tgh      trgsr.bit.b5   /* Timer A3 event/trigger select bit */
#define     ta4tgl      trgsr.bit.b6   /* Timer A4 event/trigger select bit */
#define     ta4tgh      trgsr.bit.b7   /* Timer A4 event/trigger select bit */

/*------------------------------------------------------
    Up Down Flag
        (1) The MOV instruction should be used to set the UDF register
------------------------------------------------------*/
              /* Up/down flag */
#define     udfb    udf.byte

#define     ta0ud   udf.bit.b0     /* Timer A0 up/down flag */
#define     ta1ud   udf.bit.b1     /* Timer A1 up/down flag */
#define     ta2ud   udf.bit.b2     /* Timer A2 up/down flag */
#define     ta3ud   udf.bit.b3     /* Timer A3 up/down flag */
#define     ta4ud   udf.bit.b4     /* Timer A4 up/down flag */
#define     ta2p    udf.bit.b5     /* Timer A2 2-phase pulse signal processing function select bit */
#define     ta3p    udf.bit.b6     /* Timer A3 2-phase pulse signal processing function select bit */
#define     ta4p    udf.bit.b7     /* Timer A4 2-phase pulse signal processing function select bit */

/*------------------------------------------------------
    UARTi transmit/receive control register 1 (i=0,1,2,3,4) 
------------------------------------------------------*/

union uic1_def{
struct{
        char    te:1;               /* Transmit enable bit */
        char    ti:1;               /* Transmit buffer empty flag */
        char    re:1;               /* Receive enable bit */
        char    ri:1;               /* Receive complete flag */
        char    b4:1;
        char    b5:1;
        char    b6:1;
        char    b7:1;
    }bit;
    char    byte;
};

/*------------------------------------------------------
    u0c1
------------------------------------------------------*/

#define     u0c1b           u0c1.byte
#define     te_u0c1         u0c1.bit.te    /* Transmit enable bit */
#define     ti_u0c1         u0c1.bit.ti   /* Transmit buffer empty flag */
#define     re_u0c1         u0c1.bit.re    /* Receive enable bit */
#define     ri_u0c1         u0c1.bit.ri    /* Receive complete flag */
#define     u0irs_u0c1      u0c1.bit.b4    /* UARTi transmit interrupt cause select bit */
#define     u0rrm_u0c1      u0c1.bit.b5    /* UARTi continuous receive mode enable bit */
#define     u0lch_u0c1      u0c1.bit.b6    /* Data logic select bit */
#define     sclkstpb_u0c1   u0c1.bit.b7    /* Clock divide synchronizing stop bit */
#define     u0ere_u0c1      u0c1.bit.b7    /* Error signal output enable bit */


/*------------------------------------------------------
    u1c1
------------------------------------------------------*/

#define     u1c1b           u1c1.byte
#define     te_u1c1         u1c1.bit.te
#define     ti_u1c1         u1c1.bit.ti
#define     re_u1c1         u1c1.bit.re
#define     ri_u1c1         u1c1.bit.ri
#define     u1irs_u1c1      u1c1.bit.b4
#define     u1rrm_u1c1      u1c1.bit.b5
#define     u1lch_u1c1      u1c1.bit.b6
#define     sclkstpb_u1c1   u1c1.bit.b7
#define     u1ere_u1c1      u1c1.bit.b7

/*------------------------------------------------------
    u2c1
------------------------------------------------------*/

#define     u2c1b           u2c1.byte
#define     te_u2c1         u2c1.bit.te
#define     ti_u2c1         u2c1.bit.ti
#define     re_u2c1         u2c1.bit.re
#define     ri_u2c1         u2c1.bit.ri
#define     u2irs_u2c1      u2c1.bit.b4
#define     u2rrm_u2c1      u2c1.bit.b5
#define     u2lch_u2c1      u2c1.bit.b6
#define     sclkstpb_u2c1   u2c1.bit.b7
#define     u2ere_u2c1      u2c1.bit.b7

/*------------------------------------------------------
    u3c1
------------------------------------------------------*/

#define     u3c1b           u3c1.byte
#define     te_u3c1         u3c1.bit.te
#define     ti_u3c1         u3c1.bit.ti
#define     re_u3c1         u3c1.bit.re
#define     ri_u3c1         u3c1.bit.ri
#define     u3irs_u3c1      u3c1.bit.b4
#define     u3rrm_u3c1      u3c1.bit.b5
#define     u3lch_u3c1      u3c1.bit.b6
#define     sclkstpb_u3c1   u3c1.bit.b7
#define     u3ere_u3c1      u3c1.bit.b7

/*------------------------------------------------------
    u4c1
------------------------------------------------------*/

#define     u4c1b           u4c1.byte
#define     te_u4c1         u4c1.bit.te
#define     ti_u4c1         u4c1.bit.ti
#define     re_u4c1         u4c1.bit.re
#define     ri_u4c1         u4c1.bit.ri
#define     u4irs_u4c1      u4c1.bit.b4
#define     u4rrm_u4c1      u4c1.bit.b5
#define     u4lch_u4c1      u4c1.bit.b6
#define     sclkstpb_u4c1   u4c1.bit.b7
#define     u4ere_u4c1      u4c1.bit.b7

/*------------------------------------------------------
    u5c1
------------------------------------------------------*/

#define     u5c1b           u5c1.byte
#define     te_u5c1         u5c1.bit.te
#define     ti_u5c1         u5c1.bit.ti
#define     re_u5c1         u5c1.bit.re
#define     ri_u5c1         u5c1.bit.ri
                                                 /* (b7-b4) Nothing is assigned */

/*------------------------------------------------------
    u6c1
------------------------------------------------------*/

#define     u6c1b           u6c1.byte
#define     te_u6c1         u6c1.bit.te
#define     ti_u6c1         u6c1.bit.ti
#define     re_u6c1         u6c1.bit.re
#define     ri_u6c1         u6c1.bit.b3
                                                 /* (b7-b4) Nothing is assigned */
												 
/*------------------------------------------------------
	Ircon Register
------------------------------------------------------*/

#define     irconb           ircon.byte
#define     irsel           ircon.bit.b0
#define     plssel          ircon.bit.b1
#define     irtpol          ircon.bit.b2
#define     irrpol          ircon.bit.b3
#define     irpd0           ircon.bit.b4
#define     irpd1           ircon.bit.b5
#define     irck            ircon.bit.b6
                                                 /* (b7) Nothing is assigned */

/*------------------------------------------------------
	UART5, UART6 Transmit/Receive Control Register 2
------------------------------------------------------*/

#define     u56conb          u56con.byte
#define     u5irs           u56con.bit.b0
#define     u6irs           u56con.bit.b1
#define     u5rrm           u56con.bit.b2
#define     u6rrm           u56con.bit.b3
                                            /* (b7-b4) Reserved bit (Set to 0) */

/*------------------------------------------------------
	UART5, UART6 Input Pin Function Select Register
------------------------------------------------------*/

#define     u56isb           u56is.byte
#define     u5clk           u56is.bit.b0
#define     u5rxd           u56is.bit.b1
#define     u5cts           u56is.bit.b2
                                                 /* (b3) Nothing is assigned */
#define     u6clk           u56is.bit.b4
#define     u6rxd           u56is.bit.b5
#define     u6cts           u56is.bit.b6
                                                 /* (b7) Nothing is assigned */

/*------------------------------------------------------

------------------------------------------------------*/

#define     rtp0rb          rtp0r.byte
#define     rtp00           rtp0r.bit.b0
#define     rtp01           rtp0r.bit.b1
#define     rtp02           rtp0r.bit.b2
                                                 /* (b7-b3) Nothing is assigned */
/*------------------------------------------------------

------------------------------------------------------*/

#define     rtp1rb          rtp1r.byte
#define     rtp10           rtp1r.bit.b0
#define     rtp11           rtp1r.bit.b1
#define     rtp12           rtp1r.bit.b2
                                                 /* (b7-b3) Nothing is assigned */
/*------------------------------------------------------

------------------------------------------------------*/

#define     rtp2rb          rtp2r.byte
#define     rtp20           rtp2r.bit.b0
#define     rtp21           rtp2r.bit.b1
#define     rtp22           rtp2r.bit.b2
                                                 /* (b7-b3) Nothing is assigned */
/*------------------------------------------------------

------------------------------------------------------*/

#define     rtp3rb          rtp3r.byte
#define     rtp30           rtp3r.bit.b0
#define     rtp31           rtp3r.bit.b1
#define     rtp32           rtp3r.bit.b2
                                                 /* (b7-b3) Nothing is assigned */

/*------------------------------------------------------
    A/D0 control register 0
------------------------------------------------------*/

#define     ad0con0b        ad0con0.byte

#define     ch0_ad0con0     ad0con0.bit.b0  /* Analog input pin select bit */
#define     ch1_ad0con0     ad0con0.bit.b1  /* Analog input pin select bit */
#define     ch2_ad0con0     ad0con0.bit.b2  /* Analog input pin select bit */
#define     md0_ad0con0     ad0con0.bit.b3  /* A/D operation mode select bit 0 */
#define     md1_ad0con0     ad0con0.bit.b4  /* A/D operation mode select bit 0 */
#define     trg_ad0con0     ad0con0.bit.b5  /* Trigger select bit */
#define     adst_ad0con0    ad0con0.bit.b6  /* A/D conversion start flag */
#define     cks0_ad0con0    ad0con0.bit.b7  /* Frequency select bit 0 */

/*------------------------------------------------------
    A/D0 control  register 1
------------------------------------------------------*/

#define     ad0con1b        ad0con1.byte

#define     scan0_ad0con1   ad0con1.bit.b0  /* A/D sweep pin select bit */
#define     scan1_ad0con1   ad0con1.bit.b1  /* A/D sweep pin select bit */
#define     md2_ad0con1     ad0con1.bit.b2  /* A/D operation mode select bit 1 */
#define     bits_ad0con1    ad0con1.bit.b3  /* 8/10-bit mode select bit */
#define     cks1_ad0con1    ad0con1.bit.b4  /* Frequency select bit 1 */
#define     vcut_ad0con1    ad0con1.bit.b5  /* Vref connection bit */
#define     opa0_ad0con1    ad0con1.bit.b6  /* External op-amp connection mode bit */
#define     opa1_ad0con1    ad0con1.bit.b7  /* External op-amp connection mode bit */

/*------------------------------------------------------
    A/D0 control register 2
------------------------------------------------------*/

#define     ad0con2b        ad0con2.byte

#define     smp_ad0con2     ad0con2.bit.b0  /* A/D conversion method select bit */
#define     aps0_ad0con2    ad0con2.bit.b1  /* Analog input port select bit */
#define     aps1_ad0con2    ad0con2.bit.b2  /* Analog input port select bit */
                                                 /* (b4-b3) Nothing is assigned */
#define     trg0_ad0con2    ad0con2.bit.b5  /* External trigger request cause select bit */
                                                 /* (b7-b6) Reserved bit (Set to 0) */

/*------------------------------------------------------
    A/D0 Control Register 3
------------------------------------------------------*/

#define     ad0con3b        ad0con3.byte

#define     dus_ad0con3     ad0con3.bit.b0  /* DMAC operation select bit */
#define     mss_ad0con3     ad0con3.bit.b1  /* Multi-port sweep mode select bit */
#define     cks2_ad0con3    ad0con3.bit.b2  /* Frequency select bit */
#define     msf0_ad0con3    ad0con3.bit.b3  /* Multi-port sweep status flag */
#define     msf1_ad0con3    ad0con3.bit.b4  /* Multi-port sweep status flag */
                                                 /* (b7-b5):Reserved bit (Set to 0) */

/*------------------------------------------------------
    A/D0 Control Register 4
------------------------------------------------------*/

#define     ad0con4b        ad0con4.byte
                                                /* (b1-b0) Reserved bit (Set to 0) */
#define     mps10_ad0con4   ad0con4.bit.b2 /* Multi-port sweep port select bit */
#define     mps11_ad0con4   ad0con4.bit.b3 /* Multi-port sweep port select bit */
                                                /* (b7-b4) Reserved bit (Set to 0) */

/*------------------------------------------------------
    D/A control register
------------------------------------------------------*/

#define     daconb      dacon.byte

#define     da0e        dacon.bit.b0   /* D/A0 output enable bit */
#define     da1e        dacon.bit.b1   /* D/A1 output enable bit */
                                            /* (b7-b2) Nothing is assigned */

/*------------------------------------------------------
    D/A control register 1
------------------------------------------------------*/

#define     dacon1b     dacon1.byte

#define     dat00       dacon1.bit.b0
#define     dat01       dacon1.bit.b1
#define     dat10       dacon1.bit.b2
#define     dat11       dacon1.bit.b3
                                            /* (b7-b4) Nothing is assigned */
/*------------------------------------------------------
    SI/O Communication Mode Register 0
------------------------------------------------------*/

#define     g0mrbb       g0mr.byte

#define     gmd0_g0mr   g0mr.bit.b0    /* (b1-b0) Communication mode select bit */
#define     gmd1_g0mr   g0mr.bit.b1
#define     ckdir_g0mr  g0mr.bit.b2    /* Internal/external clock select bit */
                                            /* (b5-b3) Reserved bit (Set to 0) */
#define     uform_g0mr  g0mr.bit.b6    /* Transfer direction select bit */
#define     irs_g0mr    g0mr.bit.b7    /* Transmit interrupt cause select bit */

/*------------------------------------------------------
    SI/O Communication Control Register 0
------------------------------------------------------*/

#define     g0crb        g0cr.byte

#define     ti_g0cr     g0cr.bit.b0    /* Transmit buffer empty flag */
#define     txept_g0cr  g0cr.bit.b1    /* Transmit register empty flag */
#define     ri_g0cr     g0cr.bit.b2    /* Receive complete flag */
                                            /* (b3) Nothing is assigned */
#define     te_g0cr     g0cr.bit.b4    /* Transmit enable bit */
#define     re_g0cr     g0cr.bit.b5    /* Receive enable bit */
                                            /* (b7-b6) Reserved bit (Set to 0) */

/*------------------------------------------------------
    SI/O Expansion Mode Register 0
------------------------------------------------------*/

#define     g0emrb          g0emr.byte
                                                /* (b0) Reserved bit (Set to 0) */
#define     crcv_g0emr      g0emr.bit.b1   /* CRC default value select bit */
#define     acrc_g0emr      g0emr.bit.b2   /* CRC reset select bit */
#define     bsint_g0emr     g0emr.bit.b3   /* Bit stuffing error interrupt select bit */
#define     rxsl_g0emr      g0emr.bit.b4   /* Receive source switch bit */
#define     txsl_g0emr      g0emr.bit.b5   /* Transmit source switch bit */
#define     crc0_g0emr      g0emr.bit.b6   /* CRC generation polynomial select bit */
#define     crc1_g0emr      g0emr.bit.b7   /* CRC generation polynomial select bit */

/*------------------------------------------------------
    SI/O Expansion Transmit Control Register 0
------------------------------------------------------*/

#define     g0etcb          g0etc.byte
                                                /* (b2-b0) Reserved bit (Set to 0) */
                                                /* (b3) Reserved bit (Set to 0) */
#define     tcrce_g0etc     g0etc.bit.b4   /* Transmit CRC enable bit */
                                                /* (b5) Reserved bit (Set to 0) */
#define     tbsf0_g0etc     g0etc.bit.b6   /* Transmit bit stuffing "1" insert select bit */
#define     tbsf1_g0etc     g0etc.bit.b7   /* Transmit bit stuffing "0" insert select bit */

/*------------------------------------------------------
    SI/O Expansion Receive Control Register 0
------------------------------------------------------*/

#define     g0ercb          g0erc.byte
#define     cmp0e_g0erc     g0erc.bit.b0   /* Data compare function 0 select bit */
#define     cmp1e_g0erc     g0erc.bit.b1   /* Data compare function 1 select bit */
#define     cmp2e_g0erc     g0erc.bit.b2   /* Data compare function 2 select bit */
#define     cmp3e_g0erc     g0erc.bit.b3   /* Data compare function 3 select bit */
#define     rcrce_g0erc     g0erc.bit.b4   /* Receive CRC enable bit */
#define     rshte_g0erc     g0erc.bit.b5   /* Receive shift operation enable bit */
#define     rbsf0_g0erc     g0erc.bit.b6   /* Receive bit stuffing "1" delete select bit */
#define     rbsf1_g0erc     g0erc.bit.b7   /* Receive bit stuffing "0" delete select bit */

/*------------------------------------------------------
    SI/O Special Communication Interrupt Detect Register 0
------------------------------------------------------*/

#define     g0irfb          g0irf.byte
                                                /* (b1-b0) Reserved bit (Set to 0) */
#define     bserr_g0irf     g0irf.bit.b2   /* Bit stuffing error detect flag */
                                                /* (b3) Reserved bit (Set to 0) */
#define     irf0_g0irf      g0irf.bit.b4   /* Interrupt cause determination flag 0 */
#define     irf1_g0irf      g0irf.bit.b5   /* Interrupt cause determination flag 1 */
#define     irf2_g0irf      g0irf.bit.b6   /* Interrupt cause determination flag 2 */
#define     irf3_g0irf      g0irf.bit.b7   /* Interrupt cause determination flag 3 */

/*------------------------------------------------------
    Receive Data Register 0
------------------------------------------------------*/

#define     g0drb       g0dr.byte

/*------------------------------------------------------
    Transmit Buffer Register 0
------------------------------------------------------*/

#define     g0tbb       g0tb.byte

/*------------------------------------------------------
    Data Compare Register 00
------------------------------------------------------*/

#define     g0cmp0b     g0cmp0.byte

/*------------------------------------------------------
    Data Compare Register 01
------------------------------------------------------*/

#define     g0cmp1b     g0cmp1.byte

/*------------------------------------------------------
    Data Compare Register 02
------------------------------------------------------*/

#define     g0cmp2b     g0cmp2.byte

/*------------------------------------------------------
    Data Compare Register 03
------------------------------------------------------*/

#define     g0cmp3b     g0cmp3.byte

/*------------------------------------------------------
    Data Mask Register 00
------------------------------------------------------*/

#define     g0msk0b     g0msk0.byte

/*------------------------------------------------------
    Data Mask Register 01
------------------------------------------------------*/

#define     g0msk1b     g0msk1.byte

/*------------------------------------------------------
    Communication Clock Select Register
------------------------------------------------------*/

#define     ccsb      ccs.byte

#define     ccs0      ccs.bit.b0   /* Communication unit 0 clock select bit */
#define     ccs1      ccs.bit.b1   /* Communication unit 0 clock select bit */
#define     ccs2      ccs.bit.b2   /* Communication unit 1 clock select bit */
#define     ccs3      ccs.bit.b3   /* Communication unit 1 clock select bit */
                                        /* (b7-b4) Nothing is assigned */

/*------------------------------------------------------
    Transmit Output Register 0
------------------------------------------------------*/

#define     g0tob       g0to.byte

/*------------------------------------------------------
    Receive Input Register 0
------------------------------------------------------*/

#define     g0rib       g0ri.byte

/*------------------------------------------------------
    Base Timer Control Register 10
------------------------------------------------------*/

#define     g1bcr0b            g1bcr0.byte

#define     bck0_g1bcr0        g1bcr0.bit.b0   /* (b1-b0) Count source select bit */
#define     bck1_g1bcr0        g1bcr0.bit.b1
#define     div0_g1bcr0        g1bcr0.bit.b2   /* (b6-b2) Count source division ratio select bit */
#define     div1_g1bcr0        g1bcr0.bit.b3
#define     div2_g1bcr0        g1bcr0.bit.b4
#define     div3_g1bcr0        g1bcr0.bit.b5
#define     div4_g1bcr0        g1bcr0.bit.b6
#define     it_g1bcr0          g1bcr0.bit.b7   /* Base timer interrupt select bit */

/*------------------------------------------------------
    Base Timer Control Register 11
------------------------------------------------------*/

#define     g1bcr1b            g1bcr1.byte
                                                    /* (b0) Nothing is assigned */
#define     rst1_g1bcr1        g1bcr1.bit.b1   /* Base timer reset cause select bit 1 */
#define     rst2_g1bcr1        g1bcr1.bit.b2   /* Base timer reset cause select bit 2 */
                                                    /* (b3) Reserved bit (Set to 0) */
#define     bts_g1bcr1         g1bcr1.bit.b4   /* Base timer start bit */
#define     ud0_g1bcr1         g1bcr1.bit.b5   /* (b6-b5) Counter increment/decrement control bit */
#define     ud1_g1bcr1         g1bcr1.bit.b6
                                                    /* (b7) Nothing is assigned */
													
													
/*------------------------------------------------------
    Time Measurement Control Register 
------------------------------------------------------*/

struct tmcr_bit_def{
        char    cts0:1;             /* Timer measurement trigger select bit */
        char    cts1:1;             /* Timer measurement trigger select bit */
        char    b2:1;               /* Digital filter function select bit */
        char    b3:1;               /* Digital filter function select bit */
        char    gt:1;               /* Gate function select bit */
        char    goc:1;              /* Gate function clear select bit */
        char    gsc:1;              /* Gate function clear bit */
        char    pr:1;               /* Prescaler function select bit */
    };

    union tmcr_byte_def{
		struct tmcr_bit_def bit;
    char    byte;
};
/*------------------------------------------------------
    Time Measurement Control Register 10
------------------------------------------------------*/

#define     g1tmcr0b          g1tmcr0.byte
#define     cts0_g1tmcr0      g1tmcr0.bit.cts0   /* (b1b0) Time measurement trigger select bit */
#define     cts1_g1tmcr0      g1tmcr0.bit.cts1
#define     df0_g1tmcr0       g1tmcr0.bit.b2   /* (b3b2) Digital filter function select bit */
#define     df1_g1tmcr0       g1tmcr0.bit.b3
#define     gt_g1tmcr0        g1tmcr0.bit.gt   /* Gate function select bit */
#define     goc_g1tmcr0       g1tmcr0.bit.goc   /* Gate function clear select bit */
#define     gsc_g1tmcr0       g1tmcr0.bit.gsc   /* Gate function clear bit */
#define     pr_g1tmcr0        g1tmcr0.bit.pr   /* Prescaler function select bit */

/*------------------------------------------------------
    Time Measurement Control Register 11
------------------------------------------------------*/

#define     g1tmcr1b          g1tmcr1.byte
#define     cts0_g1tmcr1      g1tmcr1.bit.cts0
#define     cts1_g1tmcr1      g1tmcr1.bit.cts1
#define     df0_g1tmcr1       g1tmcr1.bit.b2
#define     df1_g1tmcr1       g1tmcr1.bit.b3
#define     gt_g1tmcr1        g1tmcr1.bit.gt
#define     goc_g1tmcr1       g1tmcr1.bit.goc
#define     gsc_g1tmcr1       g1tmcr1.bit.gsc
#define     pr_g1tmcr1        g1tmcr1.bit.pr

/*------------------------------------------------------
    Time Measurement Control Register 12
------------------------------------------------------*/

#define     g1tmcr2b          g1tmcr2.byte
#define     cts0_g1tmcr2      g1tmcr2.bit.cts0
#define     cts1_g1tmcr2      g1tmcr2.bit.cts1
#define     df0_g1tmcr2       g1tmcr2.bit.b2
#define     df1_g1tmcr2       g1tmcr2.bit.b3
#define     gt_g1tmcr2        g1tmcr2.bit.gt
#define     goc_g1tmcr2       g1tmcr2.bit.goc
#define     gsc_g1tmcr2       g1tmcr2.bit.gsc
#define     pr_g1tmcr2        g1tmcr2.bit.pr

/*------------------------------------------------------
    Time Measurement Control Register 13
------------------------------------------------------*/

#define     g1tmcr3b           g1tmcr3.byte
#define     cts0_g1tmcr3      g1tmcr3.bit.cts0
#define     cts1_g1tmcr3      g1tmcr3.bit.cts1
#define     df0_g1tmcr3       g1tmcr3.bit.b2
#define     df1_g1tmcr3       g1tmcr3.bit.b3
#define     gt_g1tmcr3        g1tmcr3.bit.gt
#define     goc_g1tmcr3       g1tmcr3.bit.goc
#define     gsc_g1tmcr3       g1tmcr3.bit.gsc
#define     pr_g1tmcr3        g1tmcr3.bit.pr

/*------------------------------------------------------
    Time Measurement Control Register 14
------------------------------------------------------*/

#define     g1tmcr4b           g1tmcr4.byte
#define     cts0_g1tmcr4      g1tmcr4.bit.cts0
#define     cts1_g1tmcr4      g1tmcr4.bit.cts1
#define     df0_g1tmcr4       g1tmcr4.bit.b2
#define     df1_g1tmcr4       g1tmcr4.bit.b3
#define     gt_g1tmcr4        g1tmcr4.bit.gt
#define     goc_g1tmcr4       g1tmcr4.bit.goc
#define     gsc_g1tmcr4       g1tmcr4.bit.gsc
#define     pr_g1tmcr4        g1tmcr4.bit.pr

/*------------------------------------------------------
    Time Measurement Control Register 15
------------------------------------------------------*/

#define     g1tmcr5b           g1tmcr5.byte
#define     cts0_g1tmcr5      g1tmcr5.bit.cts0
#define     cts1_g1tmcr5      g1tmcr5.bit.cts1
#define     df0_g1tmcr5       g1tmcr5.bit.b2
#define     df1_g1tmcr5       g1tmcr5.bit.b3
#define     gt_g1tmcr5        g1tmcr5.bit.gt
#define     goc_g1tmcr5       g1tmcr5.bit.goc
#define     gsc_g1tmcr5       g1tmcr5.bit.gsc
#define     pr_g1tmcr5        g1tmcr5.bit.pr

/*------------------------------------------------------
    Time Measurement Control Register 16
------------------------------------------------------*/

#define     g1tmcr6b           g1tmcr6.byte
#define     cts0_g1tmcr6      g1tmcr6.bit.cts0
#define     cts1_g1tmcr6      g1tmcr6.bit.cts1
#define     df0_g1tmcr6       g1tmcr6.bit.b2
#define     df1_g1tmcr6       g1tmcr6.bit.b3
#define     gt_g1tmcr6        g1tmcr6.bit.gt
#define     goc_g1tmcr6       g1tmcr6.bit.goc
#define     gsc_g1tmcr6       g1tmcr6.bit.gsc
#define     pr_g1tmcr6        g1tmcr6.bit.pr

/*------------------------------------------------------
    Time Measurement Control Register 17
------------------------------------------------------*/

#define     g1tmcr7b           g1tmcr7.byte
#define     cts0_g1tmcr7      g1tmcr7.bit.cts0
#define     cts1_g1tmcr7      g1tmcr7.bit.cts1
#define     df0_g1tmcr7       g1tmcr7.bit.b2
#define     df1_g1tmcr7       g1tmcr7.bit.b3
#define     gt_g1tmcr7        g1tmcr7.bit.gt
#define     goc_g1tmcr7       g1tmcr7.bit.goc
#define     gsc_g1tmcr7       g1tmcr7.bit.gsc
#define     pr_g1tmcr7        g1tmcr7.bit.pr

/*------------------------------------------------------
    Time Measurement Prescaler Register 16
------------------------------------------------------*/

#define     g1tpr6b       g1tpr6.byte

/*------------------------------------------------------
    Time Measurement Prescaler Register 17
------------------------------------------------------*/

#define     g1tpr7b       g1tpr7.byte


/*------------------------------------------------------
    Waveform Generation Control Register 
------------------------------------------------------*/
struct pocr_bit_def{
        char    mod0:1;             /* Operation mode select bit */
        char    mod1:1;             /* Operation mode select bit */
        char    mod2:1;             /* Operation mode select bit */
        char    b3:1;               /*  */
        char    ivl:1;              /* Output initial value select bit */
        char    rld:1;              /* g1poi register value reload timing select bit */
        char    b6:1;               /* Base timer reset enable bit */
        char    inv:1;              /* Inverse output function select bit */
    };

    union pocr_byte_def{
		struct pocr_bit_def bit;
    char    byte;
};
/*------------------------------------------------------
    Waveform Generation Control Register 10
------------------------------------------------------*/

#define     g1pocr0b       		g1pocr0.byte
#define     mod0_g1pocr0        g1pocr0.bit.mod0     /* (b2-b0) Operation mode select bit */
#define     mod1_g1pocr0        g1pocr0.bit.mod1
#define     mod2_g1pocr0        g1pocr0.bit.mod2
                                                   /* (b3) Nothing is assigned */
#define     ivl_g1pocr0         g1pocr0.bit.ivl   /* Output initial value select bit */
#define     rld_g1pocr0         g1pocr0.bit.rld     /* G1POj register value reload timing select bit */
#define     btre_g1pocr0        g1pocr0.bit.b6     /* Base timer reset enable bit */
#define     inv_g1pocr0         g1pocr0.bit.inv    /* Inverse output function select bit */

/*------------------------------------------------------
     Waveform Generation Control Register 11
------------------------------------------------------*/

#define     g1pocr1b       		g1pocr1.byte
#define     mod0_g1pocr1        g1pocr1.bit.mod0
#define     mod1_g1pocr1        g1pocr1.bit.mod1
#define     mod2_g1pocr1        g1pocr1.bit.mod2

#define     ivl_g1pocr1         g1pocr1.bit.ivl
#define     rld_g1pocr1         g1pocr1.bit.rld
#define     btre_g1pocr1        g1pocr1.bit.b6
#define     inv_g1pocr1         g1pocr1.bit.inv

/*------------------------------------------------------
     Waveform Generation Control Register 12
------------------------------------------------------*/

#define     g1pocr2b       		g1pocr2.byte
#define     mod0_g1pocr2        g1pocr2.bit.mod0
#define     mod1_g1pocr2        g1pocr2.bit.mod1
#define     mod2_g1pocr2        g1pocr2.bit.mod2

#define     ivl_g1pocr2         g1pocr2.bit.ivl
#define     rld_g1pocr2         g1pocr2.bit.rld
#define     btre_g1pocr2        g1pocr2.bit.b6
#define     inv_g1pocr2         g1pocr2.bit.inv

/*------------------------------------------------------
     Waveform Generation Control Register 13
------------------------------------------------------*/

#define     g1pocr3b       		g1pocr3.byte
#define     mod0_g1pocr3        g1pocr3.bit.mod0
#define     mod1_g1pocr3        g1pocr3.bit.mod1
#define     mod2_g1pocr3        g1pocr3.bit.mod2

#define     ivl_g1pocr3         g1pocr3.bit.ivl
#define     rld_g1pocr3         g1pocr3.bit.rld
#define     btre_g1pocr3        g1pocr3.bit.b6
#define     inv_g1pocr3         g1pocr3.bit.inv

/*------------------------------------------------------
     Waveform Generation Control Register 14
------------------------------------------------------*/

#define     g1pocr4b       		g1pocr4.byte
#define     mod0_g1pocr4        g1pocr4.bit.mod0
#define     mod1_g1pocr4        g1pocr4.bit.mod1
#define     mod2_g1pocr4        g1pocr4.bit.mod2

#define     ivl_g1pocr4         g1pocr4.bit.ivl
#define     rld_g1pocr4         g1pocr4.bit.rld
#define     btre_g1pocr4        g1pocr4.bit.b6
#define     inv_g1pocr4         g1pocr4.bit.inv

/*------------------------------------------------------
     Waveform Generation Control Register 15
------------------------------------------------------*/

#define     g1pocr5b       		g1pocr5.byte
#define     mod0_g1pocr5        g1pocr5.bit.mod0
#define     mod1_g1pocr5        g1pocr5.bit.mod1
#define     mod2_g1pocr5        g1pocr5.bit.mod2

#define     ivl_g1pocr5         g1pocr5.bit.ivl
#define     rld_g1pocr5         g1pocr5.bit.rld
#define     btre_g1pocr5        g1pocr5.bit.b6
#define     inv_g1pocr5         g1pocr5.bit.inv

/*------------------------------------------------------
     Waveform Generation Control Register 16
------------------------------------------------------*/

#define     g1pocr6b       		g1pocr6.byte
#define     mod0_g1pocr6        g1pocr6.bit.mod0
#define     mod1_g1pocr6        g1pocr6.bit.mod1
#define     mod2_g1pocr6        g1pocr6.bit.mod2

#define     ivl_g1pocr6         g1pocr6.bit.ivl
#define     rld_g1pocr6         g1pocr6.bit.rld
#define     btre_g1pocr6        g1pocr6.bit.b6
#define     inv_g1pocr6         g1pocr6.bit.inv

/*------------------------------------------------------
     Waveform Generation Control Register 17
------------------------------------------------------*/

#define     g1pocr7b       		g1pocr7.byte
#define     mod0_g1pocr7        g1pocr7.bit.mod0
#define     mod1_g1pocr7        g1pocr7.bit.mod1
#define     mod2_g1pocr7        g1pocr7.bit.mod2

#define     ivl_g1pocr7         g1pocr7.bit.ivl
#define     rld_g1pocr7         g1pocr7.bit.rld
#define     btre_g1pocr7        g1pocr7.bit.b6
#define     inv_g1pocr7         g1pocr7.bit.inv

/*------------------------------------------------------
    Waveform Generation Control Register 20
------------------------------------------------------*/

#define     g2pocr0b       		g2pocr0.byte
#define     mod0_g2pocr0        g2pocr0.bit.mod0    /* (b2-b0) Operation mode select bit */
#define     mod1_g2pocr0        g2pocr0.bit.mod1
#define     mod2_g2pocr0        g2pocr0.bit.mod2
                                                        /* (b3) Nothing is assigned */
#define     ivl_g2pocr0         g2pocr0.bit.ivl    /* Output initial value select bit */
#define     rld_g2pocr0         g2pocr0.bit.rld    /* G2POj register value reload timing select bit */
#define     btre_g2pocr0        g2pocr0.bit.b6     /* Base timer reset enable bit */
#define     inv_g2pocr0         g2pocr0.bit.inv     /* Inverse output function select bit */

/*------------------------------------------------------
     Waveform Generation Control Register 21
------------------------------------------------------*/

#define     g2pocr1b       		g2pocr1.byte
#define     mod0_g2pocr1        g2pocr1.bit.mod0
#define     mod1_g2pocr1        g2pocr1.bit.mod1
#define     mod2_g2pocr1        g2pocr1.bit.mod2

#define     ivl_g2pocr1         g2pocr1.bit.ivl
#define     rld_g2pocr1         g2pocr1.bit.rld
#define     btre_g2pocr1        g2pocr1.bit.b6
#define     inv_g2pocr1         g2pocr1.bit.inv

/*------------------------------------------------------
     Waveform Generation Control Register 22
------------------------------------------------------*/

#define     g2pocr2b       		g2pocr2.byte
#define     mod0_g2pocr2        g2pocr2.bit.mod0
#define     mod1_g2pocr2        g2pocr2.bit.mod1
#define     mod2_g2pocr2        g2pocr2.bit.mod2

#define     ivl_g2pocr2         g2pocr2.bit.ivl
#define     rld_g2pocr2         g2pocr2.bit.rld
#define     btre_g2pocr2        g2pocr2.bit.b6
#define     inv_g2pocr2         g2pocr2.bit.inv

/*------------------------------------------------------
     Waveform Generation Control Register 23
------------------------------------------------------*/

#define     g2pocr3b       		g2pocr3.byte
#define     mod0_g2pocr3        g2pocr3.bit.mod0
#define     mod1_g2pocr3        g2pocr3.bit.mod1
#define     mod2_g2pocr3        g2pocr3.bit.mod2

#define     ivl_g2pocr3         g2pocr3.bit.ivl
#define     rld_g2pocr3         g2pocr3.bit.rld
#define     btre_g2pocr3        g2pocr3.bit.b6
#define     inv_g2pocr3         g2pocr3.bit.inv

/*------------------------------------------------------
     Waveform Generation Control Register 24
------------------------------------------------------*/

#define     g2pocr4b       		g2pocr4.byte
#define     mod0_g2pocr4        g2pocr4.bit.mod0
#define     mod1_g2pocr4        g2pocr4.bit.mod1
#define     mod2_g2pocr4        g2pocr4.bit.mod2

#define     ivl_g2pocr4         g2pocr4.bit.ivl
#define     rld_g2pocr4         g2pocr4.bit.rld
#define     btre_g2pocr4        g2pocr4.bit.b6
#define     inv_g2pocr4         g2pocr4.bit.inv

/*------------------------------------------------------
     Waveform Generation Control Register 25
------------------------------------------------------*/

#define     g2pocr5b       		g2pocr5.byte
#define     mod0_g2pocr5        g2pocr5.bit.mod0
#define     mod1_g2pocr5        g2pocr5.bit.mod1
#define     mod2_g2pocr5        g2pocr5.bit.mod2

#define     ivl_g2pocr5         g2pocr5.bit.ivl
#define     rld_g2pocr5         g2pocr5.bit.rld
#define     btre_g2pocr5        g2pocr5.bit.b6
#define     inv_g2pocr5         g2pocr5.bit.inv

/*------------------------------------------------------
     Waveform Generation Control Register 26
------------------------------------------------------*/

#define     g2pocr6b       		g2pocr6.byte
#define     mod0_g2pocr6        g2pocr6.bit.mod0
#define     mod1_g2pocr6        g2pocr6.bit.mod1
#define     mod2_g2pocr6        g2pocr6.bit.mod2

#define     ivl_g2pocr6         g2pocr6.bit.ivl
#define     rld_g2pocr6         g2pocr6.bit.rld
#define     btre_g2pocr6        g2pocr6.bit.b6
#define     inv_g2pocr6         g2pocr6.bit.inv

/*------------------------------------------------------
     Waveform Generation Control Register 27
------------------------------------------------------*/

#define     g2pocr7b       		g2pocr7.byte
#define     mod0_g2pocr7        g2pocr7.bit.mod0
#define     mod1_g2pocr7        g2pocr7.bit.mod1
#define     mod2_g2pocr7        g2pocr7.bit.mod2

#define     ivl_g2pocr7         g2pocr7.bit.ivl
#define     rld_g2pocr7         g2pocr7.bit.rld
#define     btre_g2pocr7        g2pocr7.bit.b6
#define     inv_g2pocr7         g2pocr7.bit.inv

/*------------------------------------------------------
    Base Timer Control Register 20
------------------------------------------------------*/

#define     g2bcr0b       	   g2bcr0.byte
#define     bck0_g2bcr0        g2bcr0.bit.b0   /* (b1-b0) Count source select bit */
#define     bck1_g2bcr0        g2bcr0.bit.b1
#define     div0_g2bcr0        g2bcr0.bit.b2   /* (b6-b2) Count source division ratio select bit */
#define     div1_g2bcr0        g2bcr0.bit.b3
#define     div2_g2bcr0        g2bcr0.bit.b4
#define     div3_g2bcr0        g2bcr0.bit.b5
#define     div4_g2bcr0        g2bcr0.bit.b6
#define     it_g2bcr0          g2bcr0.bit.b7   /* Base timer interrupt select bit */

/*------------------------------------------------------
    Base Timer Control Register 21
------------------------------------------------------*/

#define     g2bcr1b		       g2bcr1.byte
                                                    /* (b0) Nothing is assigned */
#define     rst1_g2bcr1        g2bcr1.bit.b1   /* Base timer reset cause select bit 1 */
#define     rst2_g2bcr1        g2bcr1.bit.b2   /* Base timer reset cause select bit 2 */
                                                    /* (b3) Reserved bit (Set to 0) */
#define     bts_g2bcr1         g2bcr1.bit.b4   /* Base timer start bit */
#define     ud0_g2bcr1         g2bcr1.bit.b5   /* (b6-b5) Counter increment/decrement control bit */
#define     ud1_g2bcr1         g2bcr1.bit.b6
                                                    /* (b7) Nothing is assigned */

/*------------------------------------------------------
    Base Timer Start Register
------------------------------------------------------*/

#define     btsrb              btsr.byte
                                                    /* (b0) Reserved bit (Set to 0) */
#define     bt1s               btsr.bit.b1
#define     bt2s               btsr.bit.b2
                                                    /* (b3) Reserved bit (Set to 0) */
                                                    /* (b7-b4) Nothing is assigned */
/*------------------------------------------------------

------------------------------------------------------*/

#define     iecrb         	   iecr.byte

#define     ieb                iecr.bit.b0
#define     iets               iecr.bit.b1
#define     iebbs              iecr.bit.b2
                                                    /* (b5-b3) Nothing is assigned */
#define     df                 iecr.bit.b6
#define     iem                iecr.bit.b7

/*------------------------------------------------------

------------------------------------------------------*/

#define     ietifb        		ietif.byte

#define     ietnf_ietif        ietif.bit.b0
#define     ieack_ietif        ietif.bit.b1
#define     ietmb_ietif        ietif.bit.b2
#define     iett_ietif         ietif.bit.b3
#define     ieabl_ietif        ietif.bit.b4
                                                    /* (b7-b5) Nothing is assigned */

/*------------------------------------------------------

------------------------------------------------------*/

#define     ierifb        	   ierif.byte

#define     ietnf_ierif        ierif.bit.b0
#define     iepcr_ierif        ierif.bit.b1
#define     iermb_ierif        ierif.bit.b2
#define     iert_ierif         ierif.bit.b3
#define     ieretc_ierif       ierif.bit.b4
                                                    /* (b7-b5) Nothing is assigned */

/*------------------------------------------------------
    SI/O Communication Mode Register 2
------------------------------------------------------*/

#define     g2mrb        g2mr.byte
#define     gmd0_g2mr    g2mr.bit.b0   /* (b1-b0) Communication mode select bit */
#define     gmd1_g2mr    g2mr.bit.b1
#define     ckdir_g2mr   g2mr.bit.b2   /* Internal/external clock select bit */
                                                    /* (b5-b3) Nothing is assigned */
#define     uform_g2mr   g2mr.bit.b6   /* Transfer direction select bit */
#define     irs_g2mr     g2mr.bit.b7   /* Transmit interrupt cause select bit */

/*------------------------------------------------------
    SI/O Communication Control Register 2
------------------------------------------------------*/

#define     g2crb			    g2cr.byte
#define     te_g2cr             g2cr.bit.b0    /* Transmit enable bit */
#define     txept_g2cr          g2cr.bit.b1    /* Transmit register empty flag */
#define     ti_g2cr             g2cr.bit.b2    /* Transmit buffer empty flag */
                                                    /* (b3) Nothing is assigned */
#define     re_g2cr             g2cr.bit.b4    /* Receive enable bit */
#define     ri_g2cr             g2cr.bit.b5    /* Receive complete flag */
#define     opol_g2cr           g2cr.bit.b6    /* ISRxD input polarity switch bit */
#define     ipol_g2cr           g2cr.bit.b7    /* ISTxD output polarity switch bit */

/*------------------------------------------------------
    Function Enable Register 2
------------------------------------------------------*/

#define     g2feb        g2fe.byte
#define     ife0_g2fe    g2fe.bit.b0   /* Channel 0 function enable bit */
#define     ife1_g2fe    g2fe.bit.b1   /* Channel 1 function enable bit */
#define     ife2_g2fe    g2fe.bit.b2   /* Channel 2 function enable bit */
#define     ife3_g2fe    g2fe.bit.b3   /* Channel 3 function enable bit */
#define     ife4_g2fe    g2fe.bit.b4   /* Channel 4 function enable bit */
#define     ife5_g2fe    g2fe.bit.b5   /* Channel 5 function enable bit */
#define     ife6_g2fe    g2fe.bit.b6   /* Channel 6 function enable bit */
#define     ife7_g2fe    g2fe.bit.b7   /* Channel 7 function enable bit */

/*------------------------------------------------------

------------------------------------------------------*/

#define     g2rtpb      g2rtp.byte
#define     rtp0_g2rtp   g2rtp.bit.b0
#define     rtp1_g2rtp   g2rtp.bit.b1
#define     rtp2_g2rtp   g2rtp.bit.b2
#define     rtp3_g2rtp   g2rtp.bit.b3
#define     rtp4_g2rtp   g2rtp.bit.b4
#define     rtp5_g2rtp   g2rtp.bit.b5
#define     rtp6_g2rtp   g2rtp.bit.b6
#define     rtp7_g2rtp   g2rtp.bit.b7

/*------------------------------------------------------
    Function Select Register 1
------------------------------------------------------*/

#define     g1fsb        g1fs.byte
#define     fsc0_g1fs    g1fs.bit.b0   /* Channel 0 time measurement/waveform generation function select bit */
#define     fsc1_g1fs    g1fs.bit.b1   /* Channel 1 time measurement/waveform generation function select bit */
#define     fsc2_g1fs    g1fs.bit.b2   /* Channel 2 time measurement/waveform generation function select bit */
#define     fsc3_g1fs    g1fs.bit.b3   /* Channel 3 time measurement/waveform generation function select bit */
#define     fsc4_g1fs    g1fs.bit.b4   /* Channel 4 time measurement/waveform generation function select bit */
#define     fsc5_g1fs    g1fs.bit.b5   /* Channel 5 time measurement/waveform generation function select bit */
#define     fsc6_g1fs    g1fs.bit.b6   /* Channel 6 time measurement/waveform generation function select bit */
#define     fsc7_g1fs    g1fs.bit.b7   /* Channel 7 time measurement/waveform generation function select bit */

/*------------------------------------------------------
    Function Enable Register 1
------------------------------------------------------*/

#define     g1feb       g1fe.byte
#define     ife0_g1fe    g1fe.bit.b0   /* Channel 0 function enable bit */
#define     ife1_g1fe    g1fe.bit.b1   /* Channel 1 function enable bit */
#define     ife2_g1fe    g1fe.bit.b2   /* Channel 2 function enable bit */
#define     ife3_g1fe    g1fe.bit.b3   /* Channel 3 function enable bit */
#define     ife4_g1fe    g1fe.bit.b4   /* Channel 4 function enable bit */
#define     ife5_g1fe    g1fe.bit.b5   /* Channel 5 function enable bit */
#define     ife6_g1fe    g1fe.bit.b6   /* Channel 6 function enable bit */
#define     ife7_g1fe    g1fe.bit.b7   /* Channel 7 function enable bit */

/*------------------------------------------------------
    SI/O Communication Mode Register 1
------------------------------------------------------*/

#define     g1mrb        g1mr.byte
#define     gmd0_g1mr    g1mr.bit.b0   /* (b1-b0) Communication mode select bit */
#define     gmd1_g1mr    g1mr.bit.b1
#define     ckdir_g1mr   g1mr.bit.b2   /* Internal/external clock select bit */
#define     stps_g1mr    g1mr.bit.b3   /* Stop bit length select bit */
#define     pry_g1mr     g1mr.bit.b4   /* Odd/Even parity select bit */
#define     prye_g1mr    g1mr.bit.b5   /* Parity enable bit */
#define     uform_g1mr   g1mr.bit.b6   /* Transfer direction select bit */
#define     irs_g1mr     g1mr.bit.b7   /* Transmit interrupt cause select bit */

/*------------------------------------------------------
    SI/O Communication Control Register 1
------------------------------------------------------*/

#define     g1crb       g1cr.byte
#define     ti_g1cr             g1cr.bit.b0    /* Transmit buffer empty flag */
#define     txept_g1cr          g1cr.bit.b1    /* Transmit register empty flag */
#define     ri_g1cr             g1cr.bit.b2    /* Receive complete flag */
                                                    /* (b3) Nothing is assigned */
#define     te_g1cr             g1cr.bit.b4    /* Transmit enable bit */
#define     re_g1cr             g1cr.bit.b5    /* Receive enable bit */
#define     ipol_g1cr           g1cr.bit.b6    /* ISRxD input polarity switch bit */
#define     opol_g1cr           g1cr.bit.b7    /* ISTxD output polarity switch bit */

/*------------------------------------------------------
    SI/O Expansion Mode Register 1
------------------------------------------------------*/

#define     g1emrb       g1emr.byte
#define     smode_g1emr         g1emr.bit.b0   /* Synchronouse mode select bit */
#define     crcv_g1emr          g1emr.bit.b1   /* CRC initial value select bit */
#define     acrc_g1emr          g1emr.bit.b2   /* CRC initialization select bit */
#define     bsint_g1emr         g1emr.bit.b3   /* Bit stuffing error interrupt select bit */
#define     rxsl_g1emr          g1emr.bit.b4   /* Receive source switch bit */
#define     txsl_g1emr          g1emr.bit.b5   /* Transmit source switch bit */
#define     crc0_g1emr          g1emr.bit.b6   /* CRC generation polynomial select bit */
#define     crc1_g1emr          g1emr.bit.b7   /* CRC generation polynomial select bit */

/*------------------------------------------------------
    SI/O Expansion Transmit Control Register 1
------------------------------------------------------*/

#define     g1etcb       g1etc.byte
                                                    /* (b2-b0) Reserved bit (Set to 0) */
#define     sof_g1etc         g1etc.bit.b3     /* SOF transmit request bit */
#define     tcrce_g1etc       g1etc.bit.b4     /* Transmit CRC enable bit */
#define     abte_g1etc        g1etc.bit.b5     /* Arbitration enable bit */
#define     tbsf0_g1etc       g1etc.bit.b6     /* Transmit bit stuffing "1" insert select bit */
#define     tbsf1_g1etc       g1etc.bit.b7     /* Transmit bit stuffing "0" insert select bit */

/*------------------------------------------------------
    SI/O Expansion Receive Control Register 1
------------------------------------------------------*/

#define     g1ercb       g1erc.byte
#define     cmp0e_g1erc       g1erc.bit.b0     /* Data compare function 0 select bit */
#define     cmp1e_g1erc       g1erc.bit.b1     /* Data compare function 1 select bit */
#define     cmp2e_g1erc       g1erc.bit.b2     /* Data compare function 2 select bit */
#define     cmp3e_g1erc       g1erc.bit.b3     /* Data compare function 3 select bit */
#define     rcrce_g1erc       g1erc.bit.b4     /* Receive CRC enable bit */
#define     rshte_g1erc       g1erc.bit.b5     /* Receive shift operation enable bit */
#define     rbsf0_g1erc       g1erc.bit.b6     /* Receive bit stuffing "1" delete select bit */
#define     rbsf1_g1erc       g1erc.bit.b7     /* Receive bit stuffing "0" delete select bit */

/*------------------------------------------------------
    SI/O Special Communication Interrupt Detect Register 1
------------------------------------------------------*/

#define     g1irfb       	  g1irf.byte
                                                    /* (b1-b0) Reserved bit (Set to 0) */
#define     bserr_g1irf       g1irf.bit.b2     /* Bit stuffing error detect flag */
#define     abt_g1irf         g1irf.bit.b3     /* Arbitration lost detect flag */
#define     irf0_g1irf        g1irf.bit.b4     /* Interrupt cause determination flag 0 */
#define     irf1_g1irf        g1irf.bit.b5     /* Interrupt cause determination flag 1 */
#define     irf2_g1irf        g1irf.bit.b6     /* Interrupt cause determination flag 2 */
#define     irf3_g1irf        g1irf.bit.b7     /* Interrupt cause determination flag 3 */

/*------------------------------------------------------
     Receive Data Register 1
------------------------------------------------------*/

#define     g1drb       g1dr.byte


/*------------------------------------------------------
    Transmit Buffer Register 1
------------------------------------------------------*/

#define     g1tbb       g1tb.byte

/*------------------------------------------------------
    Data Compare Register 10
------------------------------------------------------*/

#define     g1cmp0b       g1cmp0.byte

/*------------------------------------------------------
    Data Compare Register 11
------------------------------------------------------*/

#define     g1cmp1b       g1cmp1.byte

/*------------------------------------------------------
    Data Compare Register 12
------------------------------------------------------*/

#define     g1cmp2b       g1cmp2.byte

/*------------------------------------------------------
    Data Compare Register 13
------------------------------------------------------*/

#define     g1cmp3b       g1cmp3.byte

/*------------------------------------------------------
    Data Mask Register 10
------------------------------------------------------*/

#define     g1msk0b       g1msk0.byte

/*------------------------------------------------------
    Data Mask Register 11
------------------------------------------------------*/

#define     g1msk1b       g1msk1.byte

/*------------------------------------------------------
    Transmit Output Register 1
------------------------------------------------------*/

#define     g1tob       g1to.byte

/*------------------------------------------------------
    Receive Input Register 0
------------------------------------------------------*/

#define     g1rib       g1ri.byte


/*------------------------------------------------------
    Input Function Select Register
------------------------------------------------------*/

#define     ips0b     ips.byte
#define     ips0     ips.bit.b0    /* Communication unit 0 input pin select bit 0 */
#define     ips1     ips.bit.b1    /* Communication unit 1 input pin select bit 1 */
#define     ips2     ips.bit.b2    /* Port P15 input peripheral function select bit */
#define     ips3     ips.bit.b3    /* CAN0in function pin select bit */
#define     ips4     ips.bit.b4
#define     ips5     ips.bit.b5
#define     ips6     ips.bit.b6
                                        /* (b7) Reserved bit (Set to 0) */

/*------------------------------------------------------
    Input Function Select Register A
------------------------------------------------------*/

#define     ipsab    ipsa.byte
#define     ipsa_0   ipsa.bit.b0   /* II/O 2-phase pulse input pin select bit */
                                        /* (b2-b1) Reserved bit (Set to 0) */
#define     ipsa_3   ipsa.bit.b3   /* CAN1in function pin select bit */
                                        /* (b7-b4) Reserved bit (Set to 0) */

/*------------------------------------------------------
    Input Function Select Register A
------------------------------------------------------*/

#define     ipsbb    ipsb.byte
#define     ipsb_0   ipsb.bit.b0   /* Port P15 input peripheral function select bit */
#define     ipsb_1   ipsb.bit.b1   /* Port P15 input peripheral function select bit */
#define     ipsb_2   ipsb.bit.b2   /* Port P15 input peripheral function select bit */
#define     ipsb_3   ipsb.bit.b3   /* Port P15 input peripheral function select bit */
#define     ipsb_4   ipsb.bit.b4   /* Port P15 input peripheral function select bit */
#define     ipsb_5   ipsb.bit.b5   /* Port P15 input peripheral function select bit */
#define     ipsb_6   ipsb.bit.b6   /* Port P15 input peripheral function select bit */
#define     ipsb_7   ipsb.bit.b7   /* Port P15 input peripheral function select bit */



/*------------------------------------------------------
    PLL Control Register
------------------------------------------------------*/
#define     plcw         plc.word

#define     plc0b    plc0.byte

#define     plc00   plc0.bit.b0    /* (b2-b0) Programmable counter select bit */
#define     plc01   plc0.bit.b1
#define     plc02   plc0.bit.b2
                                        /* (b3) Reserved bit (Set to 0) */
                                        /* (b4) Reserved bit (Set to 1) */
                                        /* (b5) Reserved bit (Set to 0) */
                                        /* (b6) Reserved bit (Set to 1) */
#define     plc07   plc0.bit.b7    /* Operation enable bit */

/*------------------------------------------------------
    PLL Control Register 1
------------------------------------------------------*/

#define     plc1b    plc1.byte
                                        /* (b0) Reserved bit (Set to 0) */
                                        /* (b1) Reserved bit (Set to 1) */
#define     plc12   plc1.bit.b2    /* PLL clock division switch bit */
                                        /* (b3) Reserved bit (Set to 0) */
                                        /* (b4) Reserved bit (Set to 0) */
                                        /* (b7-b5) Reserved bit (Set to 0) */

/*------------------------------------------------------
    Voltage Down Detection Interrupt Register
------------------------------------------------------*/

#define     d4intb   d4int.byte

#define     d40     d4int.bit.b0   /* Voltage down detection interrupt enable bit */
#define     d41     d4int.bit.b1   /* STOP-WAIT mode deactivation control bit */
#define     d42     d4int.bit.b2   /* Voltage change detection flag */
#define     d43     d4int.bit.b3   /* WDT overflow detect flag */
#define     df0     d4int.bit.b4   /* (b5-b4) Sampling clock select bit */
#define     df1     d4int.bit.b5
                                        /* (b7-b6) Reserved bit (Set to 0) */



/*------------------------------------------------------
    Port P0
------------------------------------------------------*/

#define     p0b      p0.byte

#define     p0_0        p0.bit.b0      /* Port P0  bit0 */
#define     p0_1        p0.bit.b1      /* Port P0  bit1 */
#define     p0_2        p0.bit.b2      /* Port P0  bit2 */
#define     p0_3        p0.bit.b3      /* Port P0  bit3 */
#define     p0_4        p0.bit.b4      /* Port P0  bit4 */
#define     p0_5        p0.bit.b5      /* Port P0  bit5 */
#define     p0_6        p0.bit.b6      /* Port P0  bit6 */
#define     p0_7        p0.bit.b7      /* Port P0  bit7 */

/*------------------------------------------------------
    Port P0 direction register
------------------------------------------------------*/

#define     pd0b     pd0.byte

#define     pd0_0       pd0.bit.b0     /* P0 direction register  bit0 */
#define     pd0_1       pd0.bit.b1     /* P0 direction register  bit1 */
#define     pd0_2       pd0.bit.b2     /* P0 direction register  bit2 */
#define     pd0_3       pd0.bit.b3     /* P0 direction register  bit3 */
#define     pd0_4       pd0.bit.b4     /* P0 direction register  bit4 */
#define     pd0_5       pd0.bit.b5     /* P0 direction register  bit5 */
#define     pd0_6       pd0.bit.b6     /* P0 direction register  bit6 */
#define     pd0_7       pd0.bit.b7     /* P0 direction register  bit7 */

/*------------------------------------------------------
    Port P1
------------------------------------------------------*/

#define     p1b      p1.byte

#define     p1_0        p1.bit.b0      /* Port P1  bit0 */
#define     p1_1        p1.bit.b1      /* Port P1  bit1 */
#define     p1_2        p1.bit.b2      /* Port P1  bit2 */
#define     p1_3        p1.bit.b3      /* Port P1  bit3 */
#define     p1_4        p1.bit.b4      /* Port P1  bit4 */
#define     p1_5        p1.bit.b5      /* Port P1  bit5 */
#define     p1_6        p1.bit.b6      /* Port P1  bit6 */
#define     p1_7        p1.bit.b7      /* Port P1  bit7 */

/*------------------------------------------------------
    Port P1 direction register
------------------------------------------------------*/

#define     pd1b     pd1.byte

#define     pd1_0       pd1.bit.b0     /* P1 direction register  bit0 */
#define     pd1_1       pd1.bit.b1     /* P1 direction register  bit1 */
#define     pd1_2       pd1.bit.b2     /* P1 direction register  bit2 */
#define     pd1_3       pd1.bit.b3     /* P1 direction register  bit3 */
#define     pd1_4       pd1.bit.b4     /* P1 direction register  bit4 */
#define     pd1_5       pd1.bit.b5     /* P1 direction register  bit5 */
#define     pd1_6       pd1.bit.b6     /* P1 direction register  bit6 */
#define     pd1_7       pd1.bit.b7     /* P1 direction register  bit7 */

/*------------------------------------------------------
    Port P2
------------------------------------------------------*/

#define     p2b      p2.byte

#define     p2_0        p2.bit.b0      /* Port P2  bit0 */
#define     p2_1        p2.bit.b1      /* Port P2  bit1 */
#define     p2_2        p2.bit.b2      /* Port P2  bit2 */
#define     p2_3        p2.bit.b3      /* Port P2  bit3 */
#define     p2_4        p2.bit.b4      /* Port P2  bit4 */
#define     p2_5        p2.bit.b5      /* Port P2  bit5 */
#define     p2_6        p2.bit.b6      /* Port P2  bit6 */
#define     p2_7        p2.bit.b7      /* Port P2  bit7 */

/*------------------------------------------------------
    Port P2 direction register
------------------------------------------------------*/

#define     pd2b     pd2.byte

#define     pd2_0       pd2.bit.b0     /* P2 direction register  bit0 */
#define     pd2_1       pd2.bit.b1     /* P2 direction register  bit1 */
#define     pd2_2       pd2.bit.b2     /* P2 direction register  bit2 */
#define     pd2_3       pd2.bit.b3     /* P2 direction register  bit3 */
#define     pd2_4       pd2.bit.b4     /* P2 direction register  bit4 */
#define     pd2_5       pd2.bit.b5     /* P2 direction register  bit5 */
#define     pd2_6       pd2.bit.b6     /* P2 direction register  bit6 */
#define     pd2_7       pd2.bit.b7     /* P2 direction register  bit7 */

/*------------------------------------------------------
    Port P3
------------------------------------------------------*/

#define     p3b      p3.byte

#define     p3_0        p3.bit.b0      /* Port P3  bit0 */
#define     p3_1        p3.bit.b1      /* Port P3  bit1 */
#define     p3_2        p3.bit.b2      /* Port P3  bit2 */
#define     p3_3        p3.bit.b3      /* Port P3  bit3 */
#define     p3_4        p3.bit.b4      /* Port P3  bit4 */
#define     p3_5        p3.bit.b5      /* Port P3  bit5 */
#define     p3_6        p3.bit.b6      /* Port P3  bit6 */
#define     p3_7        p3.bit.b7      /* Port P3  bit7 */

/*------------------------------------------------------
    Port P3 direction register
------------------------------------------------------*/

#define     pd3b     pd3.byte

#define     pd3_0       pd3.bit.b0     /* P3 direction register  bit0 */
#define     pd3_1       pd3.bit.b1     /* P3 direction register  bit1 */
#define     pd3_2       pd3.bit.b2     /* P3 direction register  bit2 */
#define     pd3_3       pd3.bit.b3     /* P3 direction register  bit3 */
#define     pd3_4       pd3.bit.b4     /* P3 direction register  bit4 */
#define     pd3_5       pd3.bit.b5     /* P3 direction register  bit5 */
#define     pd3_6       pd3.bit.b6     /* P3 direction register  bit6 */
#define     pd3_7       pd3.bit.b7     /* P3 direction register  bit7 */

/*------------------------------------------------------
    Port P4
------------------------------------------------------*/

#define     p4b      p4.byte

#define     p4_0        p4.bit.b0      /* Port P4  bit0 */
#define     p4_1        p4.bit.b1      /* Port P4  bit1 */
#define     p4_2        p4.bit.b2      /* Port P4  bit2 */
#define     p4_3        p4.bit.b3      /* Port P4  bit3 */
#define     p4_4        p4.bit.b4      /* Port P4  bit4 */
#define     p4_5        p4.bit.b5      /* Port P4  bit5 */
#define     p4_6        p4.bit.b6      /* Port P4  bit6 */
#define     p4_7        p4.bit.b7      /* Port P4  bit7 */

/*------------------------------------------------------
    Port P4 direction register
------------------------------------------------------*/

#define     pd4b     pd4.byte

#define     pd4_0       pd4.bit.b0     /* P4 direction register  bit0 */
#define     pd4_1       pd4.bit.b1     /* P4 direction register  bit1 */
#define     pd4_2       pd4.bit.b2     /* P4 direction register  bit2 */
#define     pd4_3       pd4.bit.b3     /* P4 direction register  bit3 */
#define     pd4_4       pd4.bit.b4     /* P4 direction register  bit4 */
#define     pd4_5       pd4.bit.b5     /* P4 direction register  bit5 */
#define     pd4_6       pd4.bit.b6     /* P4 direction register  bit6 */
#define     pd4_7       pd4.bit.b7     /* P4 direction register  bit7 */

/*------------------------------------------------------
    Port P5
------------------------------------------------------*/

#define     p5b      p5.byte

#define     p5_0        p5.bit.b0      /* Port P5  bit0 */
#define     p5_1        p5.bit.b1      /* Port P5  bit1 */
#define     p5_2        p5.bit.b2      /* Port P5  bit2 */
#define     p5_3        p5.bit.b3      /* Port P5  bit3 */
#define     p5_4        p5.bit.b4      /* Port P5  bit4 */
#define     p5_5        p5.bit.b5      /* Port P5  bit5 */
#define     p5_6        p5.bit.b6      /* Port P5  bit6 */
#define     p5_7        p5.bit.b7      /* Port P5  bit7 */

/*------------------------------------------------------
    Port P5 direction register
------------------------------------------------------*/

#define     pd5b     pd5.byte

#define     pd5_0       pd5.bit.b0     /* P5 direction register  bit0 */
#define     pd5_1       pd5.bit.b1     /* P5 direction register  bit1 */
#define     pd5_2       pd5.bit.b2     /* P5 direction register  bit2 */
#define     pd5_3       pd5.bit.b3     /* P5 direction register  bit3 */
#define     pd5_4       pd5.bit.b4     /* P5 direction register  bit4 */
#define     pd5_5       pd5.bit.b5     /* P5 direction register  bit5 */
#define     pd5_6       pd5.bit.b6     /* P5 direction register  bit6 */
#define     pd5_7       pd5.bit.b7     /* P5 direction register  bit7 */

/*------------------------------------------------------
    Port P6
------------------------------------------------------*/

#define     p6b      p6.byte

#define     p6_0        p6.bit.b0      /* Port P6  bit0 */
#define     p6_1        p6.bit.b1      /* Port P6  bit1 */
#define     p6_2        p6.bit.b2      /* Port P6  bit2 */
#define     p6_3        p6.bit.b3      /* Port P6  bit3 */
#define     p6_4        p6.bit.b4      /* Port P6  bit4 */
#define     p6_5        p6.bit.b5      /* Port P6  bit5 */
#define     p6_6        p6.bit.b6      /* Port P6  bit6 */
#define     p6_7        p6.bit.b7      /* Port P6  bit7 */

/*------------------------------------------------------
    Port P6 direction register
------------------------------------------------------*/

#define     pd6b     pd6.byte

#define     pd6_0       pd6.bit.b0     /* P6 direction register  bit0 */
#define     pd6_1       pd6.bit.b1     /* P6 direction register  bit1 */
#define     pd6_2       pd6.bit.b2     /* P6 direction register  bit2 */
#define     pd6_3       pd6.bit.b3     /* P6 direction register  bit3 */
#define     pd6_4       pd6.bit.b4     /* P6 direction register  bit4 */
#define     pd6_5       pd6.bit.b5     /* P6 direction register  bit5 */
#define     pd6_6       pd6.bit.b6     /* P6 direction register  bit6 */
#define     pd6_7       pd6.bit.b7     /* P6 direction register  bit7 */

/*------------------------------------------------------
    Port P7
------------------------------------------------------*/

#define     p7b      p7.byte

#define     p7_0        p7.bit.b0      /* Port P7  bit0 */
#define     p7_1        p7.bit.b1      /* Port P7  bit1 */
#define     p7_2        p7.bit.b2      /* Port P7  bit2 */
#define     p7_3        p7.bit.b3      /* Port P7  bit3 */
#define     p7_4        p7.bit.b4      /* Port P7  bit4 */
#define     p7_5        p7.bit.b5      /* Port P7  bit5 */
#define     p7_6        p7.bit.b6      /* Port P7  bit6 */
#define     p7_7        p7.bit.b7      /* Port P7  bit7 */

/*------------------------------------------------------
    Port P7 direction register
------------------------------------------------------*/

#define     pd7b     pd7.byte

#define     pd7_0       pd7.bit.b0     /* P7 direction register  bit0 */
#define     pd7_1       pd7.bit.b1     /* P7 direction register  bit1 */
#define     pd7_2       pd7.bit.b2     /* P7 direction register  bit2 */
#define     pd7_3       pd7.bit.b3     /* P7 direction register  bit3 */
#define     pd7_4       pd7.bit.b4     /* P7 direction register  bit4 */
#define     pd7_5       pd7.bit.b5     /* P7 direction register  bit5 */
#define     pd7_6       pd7.bit.b6     /* P7 direction register  bit6 */
#define     pd7_7       pd7.bit.b7     /* P7 direction register  bit7 */

/*------------------------------------------------------
    Port P8
------------------------------------------------------*/

#define     p8b      p8.byte

#define     p8_0        p8.bit.b0      /* Port P8  bit0 */
#define     p8_1        p8.bit.b1      /* Port P8  bit1 */
#define     p8_2        p8.bit.b2      /* Port P8  bit2 */
#define     p8_3        p8.bit.b3      /* Port P8  bit3 */
#define     p8_4        p8.bit.b4      /* Port P8  bit4 */
#define     p8_5        p8.bit.b5      /* Port P8  bit5 */
#define     p8_6        p8.bit.b6      /* Port P8  bit6 */
#define     p8_7        p8.bit.b7      /* Port P8  bit7 */

/*------------------------------------------------------
    Port P8 direction register
------------------------------------------------------*/

#define     pd8b     pd8.byte

#define     pd8_0       pd8.bit.b0     /* P8 direction register  bit0 */
#define     pd8_1       pd8.bit.b1     /* P8 direction register  bit1 */
#define     pd8_2       pd8.bit.b2     /* P8 direction register  bit2 */
#define     pd8_3       pd8.bit.b3     /* P8 direction register  bit3 */
#define     pd8_4       pd8.bit.b4     /* P8 direction register  bit4 */
                                            /* (b5) Nothing is assigned */
#define     pd8_6       pd8.bit.b6     /* P8 direction register  bit6 */
#define     pd8_7       pd8.bit.b7     /* P8 direction register  bit7 */

/*------------------------------------------------------
    Port P9
------------------------------------------------------*/

#define     p9b      p9.byte

#define     p9_0        p9.bit.b0      /* Port P9  bit0 */
#define     p9_1        p9.bit.b1      /* Port P9  bit1 */
#define     p9_2        p9.bit.b2      /* Port P9  bit2 */
#define     p9_3        p9.bit.b3      /* Port P9  bit3 */
#define     p9_4        p9.bit.b4      /* Port P9  bit4 */
#define     p9_5        p9.bit.b5      /* Port P9  bit5 */
#define     p9_6        p9.bit.b6      /* Port P9  bit6 */
#define     p9_7        p9.bit.b7      /* Port P9  bit7 */

/*------------------------------------------------------
    Port P9 direction register
------------------------------------------------------*/

#define     pd9b     pd9.byte

#define     pd9_0       pd9.bit.b0     /* P9 direction register  bit0 */
#define     pd9_1       pd9.bit.b1     /* P9 direction register  bit1 */
#define     pd9_2       pd9.bit.b2     /* P9 direction register  bit2 */
#define     pd9_3       pd9.bit.b3     /* P9 direction register  bit3 */
#define     pd9_4       pd9.bit.b4     /* P9 direction register  bit4 */
#define     pd9_5       pd9.bit.b5     /* P9 direction register  bit5 */
#define     pd9_6       pd9.bit.b6     /* P9 direction register  bit6 */
#define     pd9_7       pd9.bit.b7     /* P9 direction register  bit7 */

/*------------------------------------------------------
    Port P10
------------------------------------------------------*/

#define     p10b     p10.byte

#define     p10_0       p10.bit.b0     /* Port P10  bit0 */
#define     p10_1       p10.bit.b1     /* Port P10  bit1 */
#define     p10_2       p10.bit.b2     /* Port P10  bit2 */
#define     p10_3       p10.bit.b3     /* Port P10  bit3 */
#define     p10_4       p10.bit.b4     /* Port P10  bit4 */
#define     p10_5       p10.bit.b5     /* Port P10  bit5 */
#define     p10_6       p10.bit.b6     /* Port P10  bit6 */
#define     p10_7       p10.bit.b7     /* Port P10  bit7 */

/*------------------------------------------------------
    Port P10 direction register
------------------------------------------------------*/

#define     pd10b        pd10.byte

#define     pd10_0      pd10.bit.b0    /* P10 direction register  bit0 */
#define     pd10_1      pd10.bit.b1    /* P10 direction register  bit1 */
#define     pd10_2      pd10.bit.b2    /* P10 direction register  bit2 */
#define     pd10_3      pd10.bit.b3    /* P10 direction register  bit3 */
#define     pd10_4      pd10.bit.b4    /* P10 direction register  bit4 */
#define     pd10_5      pd10.bit.b5    /* P10 direction register  bit5 */
#define     pd10_6      pd10.bit.b6    /* P10 direction register  bit6 */
#define     pd10_7      pd10.bit.b7    /* P10 direction register  bit7 */

/*------------------------------------------------------
    Port P11
------------------------------------------------------*/

#define     p11b       p11.byte

#define     p11_0       p11.bit.b0     /* Port P11  bit0 */
#define     p11_1       p11.bit.b1     /* Port P11  bit1 */
#define     p11_2       p11.bit.b2     /* Port P11  bit2 */
#define     p11_3       p11.bit.b3     /* Port P11  bit3 */
#define     p11_4       p11.bit.b4     /* Port P11  bit4 */
                                            /* (b7-b5) Nothing is assigned */

/*------------------------------------------------------
    Port P11 direction register
------------------------------------------------------*/

#define     pd11b       pd11.byte

#define     pd11_0      pd11.bit.b0    /* P11 direction register  bit0 */
#define     pd11_1      pd11.bit.b1    /* P11 direction register  bit1 */
#define     pd11_2      pd11.bit.b2    /* P11 direction register  bit2 */
#define     pd11_3      pd11.bit.b3    /* P11 direction register  bit3 */
#define     pd11_4      pd11.bit.b4    /* P11 direction register  bit4 */
                                            /* (b7-b5) Nothing is assigned */

/*------------------------------------------------------
    Port P12
------------------------------------------------------*/

#define     p12b        p12.byte

#define     p12_0       p12.bit.b0     /* Port P12  bit0 */
#define     p12_1       p12.bit.b1     /* Port P12  bit1 */
#define     p12_2       p12.bit.b2     /* Port P12  bit2 */
#define     p12_3       p12.bit.b3     /* Port P12  bit3 */
#define     p12_4       p12.bit.b4     /* Port P12  bit4 */
#define     p12_5       p12.bit.b5     /* Port P12  bit5 */
#define     p12_6       p12.bit.b6     /* Port P12  bit6 */
#define     p12_7       p12.bit.b7     /* Port P12  bit7 */

/*------------------------------------------------------
    Port P12 direction register
------------------------------------------------------*/

#define     pd12b       pd12.byte

#define     pd12_0      pd12.bit.b0    /* P12 direction register  bit0 */
#define     pd12_1      pd12.bit.b1    /* P12 direction register  bit1 */
#define     pd12_2      pd12.bit.b2    /* P12 direction register  bit2 */
#define     pd12_3      pd12.bit.b3    /* P12 direction register  bit3 */
#define     pd12_4      pd12.bit.b4    /* P12 direction register  bit4 */
#define     pd12_5      pd12.bit.b5    /* P12 direction register  bit5 */
#define     pd12_6      pd12.bit.b6    /* P12 direction register  bit6 */
#define     pd12_7      pd12.bit.b7    /* P12 direction register  bit7 */

/*------------------------------------------------------
    Port P13
------------------------------------------------------*/

#define     p13b        p13.byte

#define     p13_0       p13.bit.b0     /* Port P13  bit0 */
#define     p13_1       p13.bit.b1     /* Port P13  bit1 */
#define     p13_2       p13.bit.b2     /* Port P13  bit2 */
#define     p13_3       p13.bit.b3     /* Port P13  bit3 */
#define     p13_4       p13.bit.b4     /* Port P13  bit4 */
#define     p13_5       p13.bit.b5     /* Port P13  bit5 */
#define     p13_6       p13.bit.b6     /* Port P13  bit6 */
#define     p13_7       p13.bit.b7     /* Port P13  bit7 */

/*------------------------------------------------------
    Port P13 direction register
------------------------------------------------------*/

#define     pd13b       pd13.byte

#define     pd13_0      pd13.bit.b0    /* P13 direction register  bit0 */
#define     pd13_1      pd13.bit.b1    /* P13 direction register  bit1 */
#define     pd13_2      pd13.bit.b2    /* P13 direction register  bit2 */
#define     pd13_3      pd13.bit.b3    /* P13 direction register  bit3 */
#define     pd13_4      pd13.bit.b4    /* P13 direction register  bit4 */
#define     pd13_5      pd13.bit.b5    /* P13 direction register  bit5 */
#define     pd13_6      pd13.bit.b6    /* P13 direction register  bit6 */
#define     pd13_7      pd13.bit.b7    /* P13 direction register  bit7 */

/*------------------------------------------------------
    Port P14
------------------------------------------------------*/

#define     p14b        p14.byte

#define     p14_0       p14.bit.b0     /* Port P14  bit0 */
#define     p14_1       p14.bit.b1     /* Port P14  bit1 */
#define     p14_2       p14.bit.b2     /* Port P14  bit2 */
#define     p14_3       p14.bit.b3     /* Port P14  bit3 */
#define     p14_4       p14.bit.b4     /* Port P14  bit4 */
#define     p14_5       p14.bit.b5     /* Port P14  bit5 */
#define     p14_6       p14.bit.b6     /* Port P14  bit6 */
                                            /* (b7) Nothing is assigned */

/*------------------------------------------------------
    Port P14 direction register
------------------------------------------------------*/

#define     pd14b       pd14.byte

#define     pd14_0      pd14.bit.b0    /* P14 direction register  bit0 */
#define     pd14_1      pd14.bit.b1    /* P14 direction register  bit1 */
#define     pd14_2      pd14.bit.b2    /* P14 direction register  bit2 */
#define     pd14_3      pd14.bit.b3    /* P14 direction register  bit3 */
#define     pd14_4      pd14.bit.b4    /* P14 direction register  bit4 */
#define     pd14_5      pd14.bit.b5    /* P14 direction register  bit5 */
#define     pd14_6      pd14.bit.b6    /* P14 direction register  bit6 */
                                            /* (b7) Nothing is assigned */

/*------------------------------------------------------
    Port P15
------------------------------------------------------*/

#define     p15b        p15.byte

#define     p15_0       p15.bit.b0     /* Port P15  bit0 */
#define     p15_1       p15.bit.b1     /* Port P15  bit1 */
#define     p15_2       p15.bit.b2     /* Port P15  bit2 */
#define     p15_3       p15.bit.b3     /* Port P15  bit3 */
#define     p15_4       p15.bit.b4     /* Port P15  bit4 */
#define     p15_5       p15.bit.b5     /* Port P15  bit5 */
#define     p15_6       p15.bit.b6     /* Port P15  bit6 */
#define     p15_7       p15.bit.b7     /* Port P15  bit7 */

/*------------------------------------------------------
    Port P15 direction register
------------------------------------------------------*/

#define     pd15b        pd15.byte

#define     pd15_0      pd15.bit.b0    /* P15 direction register  bit0 */
#define     pd15_1      pd15.bit.b1    /* P15 direction register  bit1 */
#define     pd15_2      pd15.bit.b2    /* P15 direction register  bit2 */
#define     pd15_3      pd15.bit.b3    /* P15 direction register  bit3 */
#define     pd15_4      pd15.bit.b4    /* P15 direction register  bit4 */
#define     pd15_5      pd15.bit.b5    /* P15 direction register  bit5 */
#define     pd15_6      pd15.bit.b6    /* P15 direction register  bit6 */
#define     pd15_7      pd15.bit.b7    /* P15 direction register  bit7 */

/*------------------------------------------------------
    Pull-up control register 0
------------------------------------------------------*/

#define     pur0b       pur0.byte

#define     pu00        pur0.bit.b0    /* Pull-up P00 to P03 */
#define     pu01        pur0.bit.b1    /* Pull-up P04 to P07 */
#define     pu02        pur0.bit.b2    /* Pull-up P10 to P13 */
#define     pu03        pur0.bit.b3    /* Pull-up P14 to P17 */
#define     pu04        pur0.bit.b4    /* Pull-up P20 to P23 */
#define     pu05        pur0.bit.b5    /* Pull-up P24 to P27 */
#define     pu06        pur0.bit.b6    /* Pull-up P30 to P33 */
#define     pu07        pur0.bit.b7    /* Pull-up P34 to P37 */

/*------------------------------------------------------
    Pull-up control register 1
------------------------------------------------------*/

#define     pur1b       pur1.byte

#define     pu10        pur1.bit.b0    /* Pull-up P40 to P43 */
#define     pu11        pur1.bit.b1    /* Pull-up P44 to P47 */
#define     pu12        pur1.bit.b2    /* Pull-up P50 to P53 */
#define     pu13        pur1.bit.b3    /* Pull-up P54 to P57 */
                                            /* (b7-b4) Nothing is assigned */

/*------------------------------------------------------
    Pull-up control register 2
------------------------------------------------------*/

#define     pur2b       pur2.byte

#define     pu20        pur2.bit.b0    /* Pull-up P60 to P63 */
#define     pu21        pur2.bit.b1    /* Pull-up P64 to P67 */
#define     pu22        pur2.bit.b2    /* Pull-up P70 to P73 ; Except P70,P71 */
#define     pu23        pur2.bit.b3    /* Pull-up P74 to P77 */
#define     pu24        pur2.bit.b4    /* Pull-up P80 to P83 */
#define     pu25        pur2.bit.b5    /* Pull-up P84 to P87 ; Except P85 */
#define     pu26        pur2.bit.b6    /* Pull-up P90 to P93 */
#define     pu27        pur2.bit.b7    /* Pull-up P94 to P97 */

/*------------------------------------------------------
    Pull-up control register 3
------------------------------------------------------*/

#define     pur3b       pur3.byte

#define     pu30        pur3.bit.b0    /* Pull-up P100 to P103 */
#define     pu31        pur3.bit.b1    /* Pull-up P104 to P107 */
#define     pu32        pur3.bit.b2    /* Pull-up P110 to P113 */
#define     pu33        pur3.bit.b3    /* Pull-up P114 */
#define     pu34        pur3.bit.b4    /* Pull-up P120 to P123 */
#define     pu35        pur3.bit.b5    /* Pull-up P124 to P127 */
#define     pu36        pur3.bit.b6    /* Pull-up P130 to P133 */
#define     pu37        pur3.bit.b7    /* Pull-up P134 to P137 */

/*------------------------------------------------------
    Pull-up control register 4
------------------------------------------------------*/

#define     pur4b        pur4.byte

#define     pu40        pur4.bit.b0    /* Pull-up P140 to P143 */
#define     pu41        pur4.bit.b1    /* Pull-up P144 to P146 */
#define     pu42        pur4.bit.b2    /* Pull-up P150 to P153 */
#define     pu43        pur4.bit.b3    /* Pull-up P154 to P157 */
                                            /* (b7-b4) Nothing is assigned */

/*------------------------------------------------------
    Port control register
------------------------------------------------------*/

#define     pcrb     pcr.byte

#define     pcr0        pcr.bit.b0     /* Port P1 control bit */
                                            /* (b2-b1) Reserved bit (Set to 0) */
                                            /* (b7-b3) Nothing is assigned */

/*------------------------------------------------------
    Function select register A0
------------------------------------------------------*/
#define  ps0b  ps0.byte

#define  ps0_0	ps0.bit.b0	/* Port P100 output function select bit */
#define  ps0_1  ps0.bit.b1	/* Port P101 output function select bit */
#define  ps0_2	ps0.bit.b2	/* Port P102 output function select bit */
#define  ps0_3	ps0.bit.b3	/* Port P103 output function select bit */
#define  ps0_4	ps0.bit.b4	/* Port P104 output function select bit */
#define  ps0_5	ps0.bit.b5	/* Port P105 output function select bit */
#define  ps0_6	ps0.bit.b6	/* Port P106 output function select bit */
#define  ps0_7	ps0.bit.b7	/* Port P107 output function select bit */

/*------------------------------------------------------
    Function select register A1
------------------------------------------------------*/
#define  ps1b  ps1.byte

#define  ps1_0	ps1.bit.b0	/* Port P100 output function select bit */
#define  ps1_1  ps1.bit.b1	/* Port P101 output function select bit */
#define  ps1_2	ps1.bit.b2	/* Port P102 output function select bit */
#define  ps1_3	ps1.bit.b3	/* Port P103 output function select bit */
#define  ps1_4	ps1.bit.b4	/* Port P104 output function select bit */
#define  ps1_5	ps1.bit.b5	/* Port P105 output function select bit */
#define  ps1_6	ps1.bit.b6	/* Port P106 output function select bit */
#define  ps1_7	ps1.bit.b7	/* Port P107 output function select bit */

/*------------------------------------------------------
    Function select register A2
------------------------------------------------------*/
#define     ps2b     ps2.byte

#define     ps2_0       ps2.bit.b0 /* Port P80 output function select bit */
#define     ps2_1       ps2.bit.b1 /* Port P81 output function select bit */
#define     ps2_2       ps2.bit.b2 /* Port P82 output function select bit */
                                        /* (b4-b3) Reserved bit (Set to 0) */
                                        /* (b5) Nothing is assigned */
                                        /* (b7-b6) Reserved bit (Set to 0) */
										
/*------------------------------------------------------
    Function select register A3
------------------------------------------------------*/
#define     ps3b     ps3.byte

#define     ps3_0       ps3.bit.b0 /* Port P90 output function select bit */
#define     ps3_1       ps3.bit.b1 /* Port P91 output function select bit */
#define     ps3_2       ps3.bit.b2 /* Port P92 output function select bit */
#define     ps3_3       ps3.bit.b3 /* Port P93 output function select bit */
#define     ps3_4       ps3.bit.b4 /* Port P94 output function select bit */
#define     ps3_5       ps3.bit.b5 /* Port P95 output function select bit */
#define     ps3_6       ps3.bit.b6 /* Port P96 output function select bit */
#define     ps3_7       ps3.bit.b7 /* Port P97 output function select bit */


/*------------------------------------------------------
    Function select register A4
------------------------------------------------------*/
#define  ps4b  ps4.byte

#define  ps4_0	ps4.bit.b0	/* Port P100 output function select bit */
#define  ps4_1  ps4.bit.b1	/* Port P101 output function select bit */
#define  ps4_2	ps4.bit.b2	/* Port P102 output function select bit */
#define  ps4_3	ps4.bit.b3	/* Port P103 output function select bit */
#define  ps4_4	ps4.bit.b4	/* Port P104 output function select bit */
#define  ps4_5	ps4.bit.b5	/* Port P105 output function select bit */
#define  ps4_6	ps4.bit.b6	/* Port P106 output function select bit */
#define  ps4_7	ps4.bit.b7	/* Port P107 output function select bit */
/*------------------------------------------------------
    Function select register A5
------------------------------------------------------*/
#define  ps5b  ps5.byte

#define  ps5_0	ps5.bit.b0	/* Port P110 output function select bit */
#define  ps5_1  ps5.bit.b1  /* Port P111 output function select bit */
#define  ps5_2	ps5.bit.b2	/* Port P112 output function select bit */
#define  ps5_3	ps5.bit.b3	/* Port P113 output function select bit */
							/* (b4) Reserved bit (Set to 0) */
                            /* (b7-b5) Nothing is assigned */
/*------------------------------------------------------
    Function select register A6
------------------------------------------------------*/
#define  ps6b  ps6.byte

#define  ps6_0	ps6.bit.b0	/* Port P120 output function select bit */
#define  ps6_1  ps6.bit.b1	/* Port P121 output function select bit */
#define  ps6_2	ps6.bit.b2	/* Port P122 output function select bit */
#define  ps6_3	ps6.bit.b3	/* Port P123 output function select bit */
#define  ps6_4	ps6.bit.b4	/* Port P124 output function select bit */
#define  ps6_5	ps6.bit.b5	/* Port P125 output function select bit */
#define  ps6_6	ps6.bit.b6	/* Port P126 output function select bit */
#define  ps6_7	ps6.bit.b7	/* Port P127 output function select bit */

/*------------------------------------------------------
    Function select register A7
------------------------------------------------------*/
#define  ps7b  ps7.byte

#define  ps7_0	ps7.bit.b0	/* Port P130 output function select bit */
#define  ps7_1  ps7.bit.b1	/* Port P131 output function select bit */
#define  ps7_2	ps7.bit.b2	/* Port P132 output function select bit */
#define  ps7_3	ps7.bit.b3	/* Port P133 output function select bit */
#define  ps7_4	ps7.bit.b4	/* Port P134 output function select bit */
#define  ps7_5	ps7.bit.b5	/* Port P135 output function select bit */
#define  ps7_6	ps7.bit.b6	/* Port P136 output function select bit */
#define  ps7_7	ps7.bit.b7	/* Port P137 output function select bit */

/*------------------------------------------------------
    Function select register A8
------------------------------------------------------*/
#define  ps8b  ps8.byte

#define  ps8_0	ps8.bit.b0	/* Port P140 output function select bit */
#define  ps8_1  ps8.bit.b1	/* Port P141 output function select bit */
#define  ps8_2	ps8.bit.b2	/* Port P142 output function select bit */
#define  ps8_3	ps8.bit.b3	/* Port P143 output function select bit */
							/* (b6-b4) Reserved bit (Set to 0) */
                            /* (b7) Nothing is assigned */

/*------------------------------------------------------
    Function select register A9
------------------------------------------------------*/
#define  ps9b  ps9.byte

#define  ps9_0	ps9.bit.b0	/* Port P150 output function select bit */
#define  ps9_1  ps9.bit.b1	/* Port P151 output function select bit */
							/* (b2) Reserved bit (Set to 0) */
#define  ps9_3	ps9.bit.b3	/* Port P153 output function select bit */
#define  ps9_4	ps9.bit.b4	/* Port P154 output function select bit */
							/* (b5) Reserved bit (Set to 0) */
#define  ps9_6	ps9.bit.b6	/* Port P156 output function select bit */
#define  ps9_7	ps9.bit.b7	/* Port P157 output function select bit */


/*------------------------------------------------------
    Function select register B0
------------------------------------------------------*/
#define  psl0b  psl0.byte

#define  psl0_0  psl0.bit.b0 /* Port P60 output peripheral function select bit */
#define  psl0_1  psl0.bit.b1 /* Port P61 output peripheral function select bit */
#define  psl0_2  psl0.bit.b2 /* Port P62 output peripheral function select bit */
                                 /* (b3) Reserved bit (Set to 0) */
#define  psl0_4  psl0.bit.b4 /* Port P64 output peripheral function select bit */
                                 /* (b5) Reserved bit (Set to 0) */
#define  psl0_6  psl0.bit.b6 /* Port P66 output peripheral function select bit */
                                 /* (b7) Reserved bit (Set to 0) */


/*------------------------------------------------------
    Function select register B1
------------------------------------------------------*/
#define  psl1b    psl1.byte

#define  psl1_0      psl1.bit.b0 /* Port P70 output peripheral function select bit */
#define  psl1_1      psl1.bit.b1 /* Port P71 output peripheral function select bit */
#define  psl1_2      psl1.bit.b2 /* Port P72 output peripheral function select bit */
#define  psl1_3      psl1.bit.b3 /* Port P73 output peripheral function select bit */
#define  psl1_4      psl1.bit.b4 /* Port P74 output peripheral function select bit */
#define  psl1_5      psl1.bit.b5 /* Port P75 output peripheral function select bit */
#define  psl1_6      psl1.bit.b6 /* Port P76 output peripheral function select bit */
#define  psl1_7      psl1.bit.b7 /* Port P77 output peripheral function select bit */

/*------------------------------------------------------
    Function select register B2
------------------------------------------------------*/
#define     psl2b    psl2.byte

#define     psl2_0      psl2.bit.b0 /* Port P80 output peripheral function select bit */
#define     psl2_1      psl2.bit.b1 /* Port P81 output peripheral function select bit */
#define     psl2_2      psl2.bit.b2 /* Port P82 output peripheral function select bit */
                                    /* (b4-b3) Reserved bit (Set to 0) */
                                    /* (b5) Nothing is assigned */
                                    /* (b7-b6) Reserved bit (Set to 0) */

/*------------------------------------------------------
    Function select register B3
------------------------------------------------------*/
#define     psl3b   psl3.byte
                                         /* (b0) Reserved bit (Set to 0) */
#define     psl3_1      psl3.bit.b1 /* Port P91 output peripheral function select bit */
#define     psl3_2      psl3.bit.b2 /* Port P92 output peripheral function select bit */
#define     psl3_3      psl3.bit.b3 /* Port P93 output peripheral function select bit */
#define     psl3_4      psl3.bit.b4 /* Port P94 output peripheral function select bit */
#define     psl3_5      psl3.bit.b5 /* Port P95 output peripheral function select bit */
#define     psl3_6      psl3.bit.b6 /* Port P96 output peripheral function select bit */
#define     psl3_7      psl3.bit.b7 /* Port P97 output peripheral function select bit */


/*------------------------------------------------------
    Function Select Register B6
------------------------------------------------------*/
#define     psl6b    psl6.byte
#define     psl6_0   psl6.bit.b0 /* Port P120 output peripheral function select bit */
#define     psl6_1      psl6.bit.b1 /* Port P121 output peripheral function select bit */
                                    /* (b2) Reserved bit (Set to 0) */
#define     psl6_3      psl6.bit.b3 /* Port P123 output peripheral function select bit */
                                    /* (b7-b4) Reserved bit (Set to 0) */
									
/*------------------------------------------------------
    Function select register B9
------------------------------------------------------*/
#define     psl9b    psl9.byte

#define     psl9_0      psl9.bit.b0 /* Port P152 output peripheral function select bit */
#define     psl9_1      psl9.bit.b1 /* Port P151 output peripheral function select bit */
                                    /* (b3-b2) Nothing is assigned */
#define     psl9_4      psl9.bit.b4 /* Port P154 output peripheral function select bit */
                                    /* (b7-b5) Nothing is assigned */
							
/*------------------------------------------------------
    Function select register C
------------------------------------------------------*/
#define     pscb     psc.byte

#define     psc_0       psc.bit.b0 /* Port P70 output peripheral function select bit */
#define     psc_1       psc.bit.b1 /* Port P71 output peripheral function select bit */
#define     psc_2       psc.bit.b2 /* Port P72 output peripheral function select bit */
#define     psc_3       psc.bit.b3 /* Port P73 output peripheral function select bit */
#define     psc_4       psc.bit.b4 /* Port P74 output peripheral function select bit */
#define     psc_5       psc.bit.b5 /* Port P75 output peripheral function select bit */
#define     psc_6       psc.bit.b6 /* Port P76 output peripheral function select bit */
#define     psc_7       psc.bit.b7 /* Port Key input interrupt disable bit */

/*------------------------------------------------------
    Function Select Register C2
------------------------------------------------------*/
#define     psc2b     psc2.byte
                                         /* (b0) Nothing is assigned */
#define     psc2_1      psc2.bit.b1 /* Port P81 output peripheral function select bit */
#define     psc2_2      psc2.bit.b2 /* Port P82 output peripheral function select bit */
                                         /* (b7-b3) Nothing is assigned */

/*------------------------------------------------------
    Function Select Register C3
------------------------------------------------------*/
#define     psc3b     psc3.byte
                                         /* (b5-b0) Nothing is assigned */
#define     psc3_6      psc3.bit.b6 /* Port P96 output peripheral function select bit */
                                         /* (b7) Nothing is assigned */

/*------------------------------------------------------
    Function Select Register C6
------------------------------------------------------*/
#define     psc6b     psc6.byte

#define     psc6_0      psc6.bit.b0 /* Port P120 output peripheral function select bit */
#define     psc6_1      psc6.bit.b1 /* Port P121 output peripheral function select bit */
                                         /* (b2) Nothing is assigned */
#define     psc6_3      psc6.bit.b3 /* Port P123 output peripheral function select bit */
                                         /* (b7-b4) Nothing is assigned */

/*------------------------------------------------------
    Function Select Register D1
------------------------------------------------------*/
#define     psd1b     psd1.byte

#define     psd1_0      psd1.bit.b0    /* Port P70 output peripheral function select bit */
#define     psd1_1      psd1.bit.b1    /* Port P71 output peripheral function select bit */
                                            /* (b3-b2) Nothing is assigned */
#define     psd1_4      psd1.bit.b4    /* Port P74 output peripheral function select bit */
                                            /* (b5) Nothing is assigned */
#define     psd1_6      psd1.bit.b6    /* Port P76 output peripheral function select bit */
#define     psd1_7      psd1.bit.b7    /* Port P77 output peripheral function select bit */

/*------------------------------------------------------
    Function select register D2
------------------------------------------------------*/
#define     psd2b    psd2.byte
                                         /* (b0) Nothing is assigned */
#define     psd2_1      psd2.bit.b1 /* Port P81 output peripheral function select bit */
                                         /* (b7-b2) Nothing is assigned */

/*------------------------------------------------------
    Function select register E1
------------------------------------------------------*/
#define     pse1b    pse1.byte
#define     pse1_0      pse1.bit.b0 /* Port P70 output peripheral function select bit */
#define     pse1_1      pse1.bit.b1 /* Port P71 output peripheral function select bit */
                                         /* (b5-b2) Nothing is assigned */
#define     pse1_6      pse1.bit.b6 /* Port P76 output peripheral function select bit */
#define     pse1_7      pse1.bit.b7 /* Port P77 output peripheral function select bit */

/*------------------------------------------------------
    Function select register E2
------------------------------------------------------*/
#define     pse2b    pse2.byte
                                         /* (b0) Nothing is assigned */
#define     pse2_1      pse2.bit.b1 /* Port P81 output peripheral function select bit */

		

/*------------------------------------------------------
    UARTi boud rate register (i=0,1,2,3,4)
        (1) The MOV instruction should be used to set UiBRG register
        (2) The UiBRG register should be set while stop data transmitting and receiveing
------------------------------------------------------*/				
#define     u0brgb       u0brg.byte
#define     u1brgb       u1brg.byte
#define     u2brgb       u2brg.byte
#define     u3brgb       u3brg.byte
#define     u4brgb       u4brg.byte
#define     u5brgb       u5brg.byte
#define     u6brgb       u6brg.byte                                     /* (b7-b2) Nothing is assigned */							
										 
/********************************************************
*   UARTi Contol Register 0
********************************************************/
struct uic0_bit_def 
{
        char    clk0:1;
        char    clk1:1;
        char    crs:1;
        char    txept:1;
        char    crd:1;
        char    nch:1;
        char    ckpol:1;
        char    uform:1;
};
union uic0_byte_def{
    struct uic0_bit_def bit;
    char    byte;
};										 


/*------------------------------------------------------
    Interrupt control registers 1
------------------------------------------------------*/
struct icr1_bit_def 
{
        char    ilvl0:1;
        char    ilvl1:1;
        char    ilvl2:1;
        char    ir:1;
        char    nd1:1;
        char    nd2:1;
        char    nd3:1;
        char    nd4:1;
};
union icr1_byte_def
{
    struct icr1_bit_def bit;
    char    byte;
};										 

/*------------------------------------------------------
     ad0ic
------------------------------------------------------*/
#define     ad0icb        ad0ic.byte

#define     ilvl0_ad0ic  ad0ic.bit.ilvl0
#define     ilvl1_ad0ic  ad0ic.bit.ilvl1
#define     ilvl2_ad0ic  ad0ic.bit.ilvl2
#define     ir_ad0ic     ad0ic.bit.ir

/*------------------------------------------------------
     bcn0ic
------------------------------------------------------*/
#define     bcn0icb      bcn0ic.byte

#define     ilvl0_bcn0ic    bcn0ic.bit.ilvl0
#define     ilvl1_bcn0ic    bcn0ic.bit.ilvl1
#define     ilvl2_bcn0ic    bcn0ic.bit.ilvl2
#define     ir_bcn0ic       bcn0ic.bit.ir

/*------------------------------------------------------
     bcn1ic
------------------------------------------------------*/
#define     bcn1icb      bcn1ic.byte

#define     ilvl0_bcn1ic    bcn1ic.bit.ilvl0
#define     ilvl1_bcn1ic    bcn1ic.bit.ilvl1
#define     ilvl2_bcn1ic    bcn1ic.bit.ilvl2
#define     ir_bcn1ic       bcn1ic.bit.ir

/*------------------------------------------------------
     bcn2ic
------------------------------------------------------*/
#define     bcn2icb      bcn2ic.byte

#define     ilvl0_bcn2ic    bcn2ic.bit.ilvl0
#define     ilvl1_bcn2ic    bcn2ic.bit.ilvl1
#define     ilvl2_bcn2ic    bcn2ic.bit.ilvl2
#define     ir_bcn2ic       bcn2ic.bit.ir

/*------------------------------------------------------
     bcn3ic
------------------------------------------------------*/
#define     bcn3icb      bcn3ic.byte

#define     ilvl0_bcn3ic    bcn3ic.bit.ilvl0
#define     ilvl1_bcn3ic    bcn3ic.bit.ilvl1
#define     ilvl2_bcn3ic    bcn3ic.bit.ilvl2
#define     ir_bcn3ic       bcn3ic.bit.ir

/*------------------------------------------------------
     bcn4ic
------------------------------------------------------*/
#define     bcn4icb      bcn4ic.byte

#define     ilvl0_bcn4ic    bcn4ic.bit.ilvl0
#define     ilvl1_bcn4ic    bcn4ic.bit.ilvl1
#define     ilvl2_bcn4ic    bcn4ic.bit.ilvl2
#define     ir_bcn4ic       bcn4ic.bit.ir

/*------------------------------------------------------
     dm0ic
------------------------------------------------------*/
#define     dm0icb       dm0ic.byte

#define     ilvl0_dm0ic dm0ic.bit.ilvl0
#define     ilvl1_dm0ic dm0ic.bit.ilvl1
#define     ilvl2_dm0ic dm0ic.bit.ilvl2
#define     ir_dm0ic    dm0ic.bit.ir

/*------------------------------------------------------
     dm1ic
------------------------------------------------------*/
#define     dm1icb       dm1ic.byte

#define     ilvl0_dm1ic dm1ic.bit.ilvl0
#define     ilvl1_dm1ic dm1ic.bit.ilvl1
#define     ilvl2_dm1ic dm1ic.bit.ilvl2
#define     ir_dm1ic    dm1ic.bit.ir

/*------------------------------------------------------
     dm2ic
------------------------------------------------------*/
#define     dm2icb       dm2ic.byte

#define     ilvl0_dm2ic dm2ic.bit.ilvl0
#define     ilvl1_dm2ic dm2ic.bit.ilvl1
#define     ilvl2_dm2ic dm2ic.bit.ilvl2
#define     ir_dm2ic    dm2ic.bit.ir

/*------------------------------------------------------
     dm3ic
------------------------------------------------------*/
#define     dm3icb       dm3ic.byte

#define     ilvl0_dm3ic dm3ic.bit.ilvl0
#define     ilvl1_dm3ic dm3ic.bit.ilvl1
#define     ilvl2_dm3ic dm3ic.bit.ilvl2
#define     ir_dm3ic    dm3ic.bit.ir


/*------------------------------------------------------
     kupic
------------------------------------------------------*/
#define     kupicb       kupic.byte

#define     ilvl0_kupic kupic.bit.ilvl0
#define     ilvl1_kupic kupic.bit.ilvl1
#define     ilvl2_kupic kupic.bit.ilvl2
#define     ir_kupic    kupic.bit.ir

/*------------------------------------------------------
     ta0ic
------------------------------------------------------*/
#define     ta0icb       ta0ic.byte

#define     ilvl0_ta0ic ta0ic.bit.ilvl0
#define     ilvl1_ta0ic ta0ic.bit.ilvl1
#define     ilvl2_ta0ic ta0ic.bit.ilvl2
#define     ir_ta0ic    ta0ic.bit.ir

/*------------------------------------------------------
     ta1ic
------------------------------------------------------*/
#define     ta1icb       ta1ic.byte

#define     ilvl0_ta1ic ta1ic.bit.ilvl0
#define     ilvl1_ta1ic ta1ic.bit.ilvl1
#define     ilvl2_ta1ic ta1ic.bit.ilvl2
#define     ir_ta1ic    ta1ic.bit.ir

/*------------------------------------------------------
     ta2ic
------------------------------------------------------*/
#define     ta2icb       ta2ic.byte

#define     ilvl0_ta2ic ta2ic.bit.ilvl0
#define     ilvl1_ta2ic ta2ic.bit.ilvl1
#define     ilvl2_ta2ic ta2ic.bit.ilvl2
#define     ir_ta2ic    ta2ic.bit.ir

/*------------------------------------------------------
     ta3ic
------------------------------------------------------*/
#define     ta3icb       ta3ic.byte

#define     ilvl0_ta3ic ta3ic.bit.ilvl0
#define     ilvl1_ta3ic ta3ic.bit.ilvl1
#define     ilvl2_ta3ic ta3ic.bit.ilvl2
#define     ir_ta3ic    ta3ic.bit.ir

/*------------------------------------------------------
     ta4ic
------------------------------------------------------*/
#define     ta4icb       ta4ic.byte

#define     ilvl0_ta4ic ta4ic.bit.ilvl0
#define     ilvl1_ta4ic ta4ic.bit.ilvl1
#define     ilvl2_ta4ic ta4ic.bit.ilvl2
#define     ir_ta4ic    ta4ic.bit.ir

/*------------------------------------------------------
     tb0ic
------------------------------------------------------*/
#define     tb0icb       tb0ic.byte

#define     ilvl0_tb0ic tb0ic.bit.ilvl0
#define     ilvl1_tb0ic tb0ic.bit.ilvl1
#define     ilvl2_tb0ic tb0ic.bit.ilvl2
#define     ir_tb0ic    tb0ic.bit.ir

/*------------------------------------------------------
     tb1ic
------------------------------------------------------*/
#define     tb1icb       tb1ic.byte

#define     ilvl0_tb1ic tb1ic.bit.ilvl0
#define     ilvl1_tb1ic tb1ic.bit.ilvl1
#define     ilvl2_tb1ic tb1ic.bit.ilvl2
#define     ir_tb1ic    tb1ic.bit.ir

/*------------------------------------------------------
     tb2ic
------------------------------------------------------*/
#define     tb2icb       tb2ic.byte

#define     ilvl0_tb2ic tb2ic.bit.ilvl0
#define     ilvl1_tb2ic tb2ic.bit.ilvl1
#define     ilvl2_tb2ic tb2ic.bit.ilvl2
#define     ir_tb2ic    tb2ic.bit.ir

/*------------------------------------------------------
     tb3ic
------------------------------------------------------*/
#define     tb3icb       tb3ic.byte

#define     ilvl0_tb3ic tb3ic.bit.ilvl0
#define     ilvl1_tb3ic tb3ic.bit.ilvl1
#define     ilvl2_tb3ic tb3ic.bit.ilvl2
#define     ir_tb3ic    tb3ic.bit.ir

/*------------------------------------------------------
     tb4ic
------------------------------------------------------*/
#define     tb4icb       tb4ic.byte

#define     ilvl0_tb4ic tb4ic.bit.ilvl0
#define     ilvl1_tb4ic tb4ic.bit.ilvl1
#define     ilvl2_tb4ic tb4ic.bit.ilvl2
#define     ir_tb4ic    tb4ic.bit.ir

/*------------------------------------------------------
     tb5ic
------------------------------------------------------*/
#define     tb5icb       tb5ic.byte

#define     ilvl0_tb5ic tb5ic.bit.ilvl0
#define     ilvl1_tb5ic tb5ic.bit.ilvl1
#define     ilvl2_tb5ic tb5ic.bit.ilvl2
#define     ir_tb5ic    tb5ic.bit.ir

/*------------------------------------------------------
     s0tic
------------------------------------------------------*/
#define     s0ticb       s0tic.byte

#define     ilvl0_s0tic s0tic.bit.ilvl0
#define     ilvl1_s0tic s0tic.bit.ilvl1
#define     ilvl2_s0tic s0tic.bit.ilvl2
#define     ir_s0tic    s0tic.bit.ir

/*------------------------------------------------------
     s1tic
------------------------------------------------------*/
#define     s1ticb       s1tic.byte

#define     ilvl0_s1tic s1tic.bit.ilvl0
#define     ilvl1_s1tic s1tic.bit.ilvl1
#define     ilvl2_s1tic s1tic.bit.ilvl2
#define     ir_s1tic    s1tic.bit.ir

/*------------------------------------------------------
     s2tic
------------------------------------------------------*/
#define     s2ticb       s2tic.byte

#define     ilvl0_s2tic s2tic.bit.ilvl0
#define     ilvl1_s2tic s2tic.bit.ilvl1
#define     ilvl2_s2tic s2tic.bit.ilvl2
#define     ir_s2tic    s2tic.bit.ir

/*------------------------------------------------------
     s3tic
------------------------------------------------------*/
#define     s3ticb       s3tic.byte

#define     ilvl0_s3tic s3tic.bit.ilvl0
#define     ilvl1_s3tic s3tic.bit.ilvl1
#define     ilvl2_s3tic s3tic.bit.ilvl2
#define     ir_s3tic    s3tic.bit.ir

/*------------------------------------------------------
     s4tic
------------------------------------------------------*/
#define     s4ticb       s4tic.byte

#define     ilvl0_s4tic s4tic.bit.ilvl0
#define     ilvl1_s4tic s4tic.bit.ilvl1
#define     ilvl2_s4tic s4tic.bit.ilvl2
#define     ir_s4tic    s4tic.bit.ir

/*------------------------------------------------------
     s0ric
------------------------------------------------------*/
#define     s0ricb       s0ric.byte

#define     ilvl0_s0ric s0ric.bit.ilvl0
#define     ilvl1_s0ric s0ric.bit.ilvl1
#define     ilvl2_s0ric s0ric.bit.ilvl2
#define     ir_s0ric    s0ric.bit.ir

/*------------------------------------------------------
     s1ric
------------------------------------------------------*/
#define     s1ricb       s1ric.byte

#define     ilvl0_s1ric s1ric.bit.ilvl0
#define     ilvl1_s1ric s1ric.bit.ilvl1
#define     ilvl2_s1ric s1ric.bit.ilvl2
#define     ir_s1ric    s1ric.bit.ir

/*------------------------------------------------------
     s2ric
------------------------------------------------------*/
#define     s2ricb       s2ric.byte

#define     ilvl0_s2ric s2ric.bit.ilvl0
#define     ilvl1_s2ric s2ric.bit.ilvl1
#define     ilvl2_s2ric s2ric.bit.ilvl2
#define     ir_s2ric    s2ric.bit.ir

/*------------------------------------------------------
     s3ric
------------------------------------------------------*/
#define     s3ricb       s3ric.byte

#define     ilvl0_s3ric s3ric.bit.ilvl0
#define     ilvl1_s3ric s3ric.bit.ilvl1
#define     ilvl2_s3ric s3ric.bit.ilvl2
#define     ir_s3ric    s3ric.bit.ir
/*------------------------------------------------------
     s4ric
------------------------------------------------------*/
#define     s4ricb       s4ric.byte

#define     ilvl0_s4ric s4ric.bit.ilvl0
#define     ilvl1_s4ric s4ric.bit.ilvl1
#define     ilvl2_s4ric s4ric.bit.ilvl2
#define     ir_s4ric    s4ric.bit.ir

/*------------------------------------------------------
     iio0ic
------------------------------------------------------*/
#define     iio0icb      iio0ic.byte

#define     ilvl0_iio0ic iio0ic.bit.ilvl0
#define     ilvl1_iio0ic iio0ic.bit.ilvl1
#define     ilvl2_iio0ic iio0ic.bit.ilvl2
#define     ir_iio0ic    iio0ic.bit.ir

/*------------------------------------------------------
     iio1ic
------------------------------------------------------*/
#define     iio1icb      iio1ic.byte

#define     ilvl0_iio1ic iio1ic.bit.ilvl0
#define     ilvl1_iio1ic iio1ic.bit.ilvl1
#define     ilvl2_iio1ic iio1ic.bit.ilvl2
#define     ir_iio1ic    iio1ic.bit.ir

/*------------------------------------------------------
     iio2ic
------------------------------------------------------*/
#define     iio2icb      iio2ic.byte

#define     ilvl0_iio2ic iio2ic.bit.ilvl0
#define     ilvl1_iio2ic iio2ic.bit.ilvl1
#define     ilvl2_iio2ic iio2ic.bit.ilvl2
#define     ir_iio2ic    iio2ic.bit.ir

/*------------------------------------------------------
     iio3ic
------------------------------------------------------*/
#define     iio3icb      iio3ic.byte

#define     ilvl0_iio3ic iio3ic.bit.ilvl0
#define     ilvl1_iio3ic iio3ic.bit.ilvl1
#define     ilvl2_iio3ic iio3ic.bit.ilvl2
#define     ir_iio3ic    iio3ic.bit.ir

/*------------------------------------------------------
     iio4ic
------------------------------------------------------*/
#define     iio4icb      iio4ic.byte

#define     ilvl0_iio4ic iio4ic.bit.ilvl0
#define     ilvl1_iio4ic iio4ic.bit.ilvl1
#define     ilvl2_iio4ic iio4ic.bit.ilvl2
#define     ir_iio4ic    iio4ic.bit.ir

/*------------------------------------------------------
     iio5ic
------------------------------------------------------*/
#define     iio5icb      iio5ic.byte

#define     ilvl0_iio5ic iio5ic.bit.ilvl0
#define     ilvl1_iio5ic iio5ic.bit.ilvl1
#define     ilvl2_iio5ic iio5ic.bit.ilvl2
#define     ir_iio5ic    iio5ic.bit.ir

/*------------------------------------------------------
     iio6ic
------------------------------------------------------*/
#define     iio6icb      iio6ic.byte

#define     ilvl0_iio6ic iio6ic.bit.ilvl0
#define     ilvl1_iio6ic iio6ic.bit.ilvl1
#define     ilvl2_iio6ic iio6ic.bit.ilvl2
#define     ir_iio6ic    iio6ic.bit.ir

/*------------------------------------------------------
     iio7ic
------------------------------------------------------*/
#define     iio7icb      iio7ic.byte

#define     ilvl0_iio7ic iio7ic.bit.ilvl0
#define     ilvl1_iio7ic iio7ic.bit.ilvl1
#define     ilvl2_iio7ic iio7ic.bit.ilvl2
#define     ir_iio7ic    iio7ic.bit.ir

/*------------------------------------------------------
     iio8ic
------------------------------------------------------*/
#define     iio8icb      iio8ic.byte

#define     ilvl0_iio8ic iio8ic.bit.ilvl0
#define     ilvl1_iio8ic iio8ic.bit.ilvl1
#define     ilvl2_iio8ic iio8ic.bit.ilvl2
#define     ir_iio8ic    iio8ic.bit.ir

/*------------------------------------------------------
     iio9ic
------------------------------------------------------*/
#define     iio9icb      iio9ic.byte

#define     ilvl0_iio9ic iio9ic.bit.ilvl0
#define     ilvl1_iio9ic iio9ic.bit.ilvl1
#define     ilvl2_iio9ic iio9ic.bit.ilvl2
#define     ir_iio9ic    iio9ic.bit.ir

/*------------------------------------------------------
     iio10ic
------------------------------------------------------*/
#define     iio10icb      iio10ic.byte

#define     ilvl0_iio10ic iio10ic.bit.ilvl0
#define     ilvl1_iio10ic iio10ic.bit.ilvl1
#define     ilvl2_iio10ic iio10ic.bit.ilvl2
#define     ir_iio10ic    iio10ic.bit.ir
									

/*------------------------------------------------------
     CAN0 Interrupt control register
------------------------------------------------------*/
#define     can0icb      can0ic.byte

#define     ilvl0_can0ic    can0ic.bit.ilvl0   /* Interrupt priority level select bit */
#define     ilvl1_can0ic    can0ic.bit.ilvl1   /* Interrupt priority level select bit */
#define     ilvl2_can0ic    can0ic.bit.ilvl2   /* Interrupt priority level select bit */
#define     ir_can0ic       can0ic.bit.ir      /* Interrupt request bit */

/*------------------------------------------------------
     CAN1 Interrupt control register
------------------------------------------------------*/
#define     can1icb      can1ic.byte

#define     ilvl0_can1ic    can1ic.bit.ilvl0   /* Interrupt priority level select bit */
#define     ilvl1_can1ic    can1ic.bit.ilvl1   /* Interrupt priority level select bit */
#define     ilvl2_can1ic    can1ic.bit.ilvl2   /* Interrupt priority level select bit */
#define     ir_can1ic       can1ic.bit.ir      /* Interrupt request bit */


/*------------------------------------------------------
     CAN2 Interrupt control register
------------------------------------------------------*/
#define     can2icb      can2ic.byte

#define     ilvl0_can2ic    can2ic.bit.ilvl0   /* Interrupt priority level select bit */
#define     ilvl1_can2ic    can2ic.bit.ilvl1   /* Interrupt priority level select bit */
#define     ilvl2_can2ic    can2ic.bit.ilvl2   /* Interrupt priority level select bit */
#define     ir_can2ic       can2ic.bit.ir      /* Interrupt request bit */


/*------------------------------------------------------
     CAN3 Interrupt control register
------------------------------------------------------*/
#define     can3icb      can3ic.byte

#define     ilvl0_can3ic    can3ic.bit.ilvl0   /* Interrupt priority level select bit */
#define     ilvl1_can3ic    can3ic.bit.ilvl1   /* Interrupt priority level select bit */
#define     ilvl2_can3ic    can3ic.bit.ilvl2   /* Interrupt priority level select bit */
#define     ir_can3ic       can3ic.bit.ir      /* Interrupt request bit */


/*------------------------------------------------------
     CAN4 Interrupt control register
------------------------------------------------------*/
#define     can4icb      can4ic.byte

#define     ilvl0_can4ic    can4ic.bit.ilvl0   /* Interrupt priority level select bit */
#define     ilvl1_can4ic    can4ic.bit.ilvl1   /* Interrupt priority level select bit */
#define     ilvl2_can4ic    can4ic.bit.ilvl2   /* Interrupt priority level select bit */
#define     ir_can4ic       can4ic.bit.ir      /* Interrupt request bit */


/*------------------------------------------------------
     CAN5 Interrupt control register
------------------------------------------------------*/
#define     can5icb      can5ic.byte

#define     ilvl0_can5ic    can5ic.bit.ilvl0   /* Interrupt priority level select bit */
#define     ilvl1_can5ic    can5ic.bit.ilvl1   /* Interrupt priority level select bit */
#define     ilvl2_can5ic    can5ic.bit.ilvl2   /* Interrupt priority level select bit */
#define     ir_can5ic       can5ic.bit.ir      /* Interrupt request bit */


/*------------------------------------------------------
    Interrupt control registers 2
------------------------------------------------------*/
struct icr2_bit_def 
{
        char    ilvl0:1;
        char    ilvl1:1;
        char    ilvl2:1;
        char    ir:1;
        char    pol:1;
        char    lvs:1;
        char    nd1:1;
        char    nd2:1;
};
union icr2_byte_def
{
    struct icr1_bit_def bit;
    char    byte;
};		

/*------------------------------------------------------
     int0ic
------------------------------------------------------*/
#define     int0icb      int0ic.byte

#define     ilvl0_int0ic    int0ic.bit.ilvl0
#define     ilvl1_int0ic    int0ic.bit.ilvl1
#define     ilvl2_int0ic    int0ic.bit.ilvl2
#define     ir_int0ic       int0ic.bit.ir
#define     pol_int0ic      int0ic.bit.pol
#define     lvs_int0ic      int0ic.bit.lvs

/*------------------------------------------------------
     int1ic
------------------------------------------------------*/
#define     int1icb      int1ic.byte

#define     ilvl0_int1ic    int1ic.bit.ilvl0
#define     ilvl1_int1ic    int1ic.bit.ilvl1
#define     ilvl2_int1ic    int1ic.bit.ilvl2
#define     ir_int1ic       int1ic.bit.ir
#define     pol_int1ic      int1ic.bit.pol
#define     lvs_int1ic      int1ic.bit.lvs

/*------------------------------------------------------
     int2ic
------------------------------------------------------*/
#define     int2icb      int2ic.byte

#define     ilvl0_int2ic    int2ic.bit.ilvl0
#define     ilvl1_int2ic    int2ic.bit.ilvl1
#define     ilvl2_int2ic    int2ic.bit.ilvl2
#define     ir_int2ic       int2ic.bit.ir
#define     pol_int2ic      int2ic.bit.pol
#define     lvs_int2ic      int2ic.bit.lvs

/*------------------------------------------------------
     int3ic
------------------------------------------------------*/
#define     int3icb      int3ic.byte

#define     ilvl0_int3ic    int3ic.bit.ilvl0
#define     ilvl1_int3ic    int3ic.bit.ilvl1
#define     ilvl2_int3ic    int3ic.bit.ilvl2
#define     ir_int3ic       int3ic.bit.ir
#define     pol_int3ic      int3ic.bit.pol
#define     lvs_int3ic      int3ic.bit.lvs

/*------------------------------------------------------
     int4ic
------------------------------------------------------*/
#define     int4icb      int4ic.byte

#define     ilvl0_int4ic    int4ic.bit.ilvl0
#define     ilvl1_int4ic    int4ic.bit.ilvl1
#define     ilvl2_int4ic    int4ic.bit.ilvl2
#define     ir_int4ic       int4ic.bit.ir
#define     pol_int4ic      int4ic.bit.pol
#define     lvs_int4ic      int4ic.bit.lvs

/*------------------------------------------------------
     int5ic
------------------------------------------------------*/
#define     int5icb      int5ic.byte

#define     ilvl0_int5ic    int5ic.bit.ilvl0
#define     ilvl1_int5ic    int5ic.bit.ilvl1
#define     ilvl2_int5ic    int5ic.bit.ilvl2
#define     ir_int5ic       int5ic.bit.ir
#define     pol_int5ic      int5ic.bit.pol
#define     lvs_int5ic      int5ic.bit.lvs
			

/*------------------------------------------------------
     Interrupt Request Register
------------------------------------------------------*/								 

/*------------------------------------------------------
     iio0ir
------------------------------------------------------*/
#define    iio0irb   iio0ir.byte
                                            /* (b0) - */
                                            /* (b1) - */
#define    tm13r    iio0ir.bit.b2    /* II/O time measurement 3 interrupt */
#define    po13r    iio0ir.bit.b2    /* II/O waveform generation function 3 interrupt */
                                            /* (b3) - */
#define    g0rir    iio0ir.bit.b4    /* II/O communication unit 0 HDLC data processing function interrupt */
#define    sio0rr   iio0ir.bit.b5    /* II/O communication unit 0 receive interrupt */
#define    u5rr     iio0ir.bit.b6    /*  */
#define    can10r   iio0ir.bit.b7    /* CAN1 communication function interrupt */

/*------------------------------------------------------
     iio1ir
------------------------------------------------------*/
#define    iio1irb   iio1ir.byte
                                            /* (b0) - */
                                            /* (b1) - */
#define    tm14r    iio1ir.bit.b2    /* II/O time measurement 4 interrupt */
#define    po14r    iio1ir.bit.b2    /* II/O waveform generation function 4 interrupt */
                                            /* (b3) - */
#define    g0tor    iio1ir.bit.b4    /* II/O communication unit 0 HDLC data processing function interrupt */
#define    sio0tr   iio1ir.bit.b5    /* II/O communication unit 0 transmit interrupt */
#define    u5tr     iio1ir.bit.b6    /*  */
#define    can11r   iio1ir.bit.b7    /* CAN1 communication function interrupt */

/*------------------------------------------------------
     iio2ir
------------------------------------------------------*/
#define    iio2irb   iio2ir.byte
                                            /* (b0) - */
                                            /* (b1) - */
#define    tm12r    iio2ir.bit.b2    /* II/O time measurement 2 interrupt */
#define    po12r    iio2ir.bit.b2    /* II/O waveform generation function 2 interrupt */
                                            /* (b3) - */
#define    g1rir    iio2ir.bit.b4    /* II/O communication unit 1 HDLC data processing function interrupt */
#define    sio1rr   iio2ir.bit.b5    /* II/O communication unit 1 receive interrupt */
                                            /* (b6) - */
                                            /* (b7) - */

/*------------------------------------------------------
     iio3ir
------------------------------------------------------*/
#define    iio3irb   iio3ir.byte
                                            /* (b0) - */
                                            /* (b1) - */
#define    tm10r    iio3ir.bit.b2    /* II/O time measurement 0 interrupt */
#define    po10r    iio3ir.bit.b2    /* II/O waveform generation function 0 interrupt */
#define    po27r    iio3ir.bit.b3    /* II/O waveform generation function 7 interrupt */
#define    g1tor    iio3ir.bit.b4    /* II/O communication unit 1 HDLC data processing function interrupt */
#define    sio1tr   iio3ir.bit.b5    /* II/O communication unit 0 transmit interrupt */
                                            /* (b6) - */
                                            /* (b7) - */

/*------------------------------------------------------
     iio4ir
------------------------------------------------------*/
#define    iio4irb   iio4ir.byte
                                            /* (b0) - */
                                            /* (b1) - */
#define    tm17r    iio4ir.bit.b2    /* II/O time measurement 7 interrupt */
#define    po17r    iio4ir.bit.b2    /* II/O waveform generation function 7 interrupt */
                                            /* (b3) - */
#define    bt1r     iio4ir.bit.b4    /* II/O communication base timer interrupt */
                                            /* (b5) - */
#define    srt1r    iio4ir.bit.b6    /* II/O special communication function interrupt */
#define    srt0r    iio4ir.bit.b7    /* II/O special communication function interrupt */

/*------------------------------------------------------
     iio5ir
------------------------------------------------------*/
#define    iio5irb   iio5ir.byte
                                            /* (b1-b0) - */
#define    po21r    iio5ir.bit.b2    /* II/O waveform generation function 1 interrupt */
                                            /* (b3) - */
#define    sio2rr   iio5ir.bit.b4    /* II/O communication unit 2 receive interrupt */
                                            /* (b5) - */
#define    can1wur  iio5ir.bit.b6    /* CAN1 wake-up interrupt */
#define    can12r   iio5ir.bit.b7    /* CAN1 communication function interrupt */

/*------------------------------------------------------
     iio6ir
------------------------------------------------------*/
#define    iio6irb   iio6ir.byte
                                            /* (b1-b0) - */
#define    po20r    iio6ir.bit.b2    /* II/O waveform generation function 0 interrupt */
                                            /* (b3) - */
#define    sio2tr   iio6ir.bit.b4    /* II/O communication unit 2 transmit interrupt */
                                            /* (b5) - */

/*------------------------------------------------------
     iio7ir
------------------------------------------------------*/
#define    iio7irb   iio7ir.byte
                                            /* (b1-b0) - */
#define    po22r    iio7ir.bit.b2    /* II/O waveform generation function 2 interrupt */
                                            /* (b6-b3) - */
#define    ie0r     iio7ir.bit.b7

/*------------------------------------------------------
     iio8ir
------------------------------------------------------*/
#define    iio8irb   iio8ir.byte
                                            /* (b0) - */
#define    tm11r    iio8ir.bit.b1    /* II/O time measurement 1 interrupt */
#define    po11r    iio8ir.bit.b1    /* II/O waveform generation function 1 interrupt */
#define    po23r    iio8ir.bit.b2    /* II/O waveform generation function 3 interrupt */
                                            /* (b3) - */
#define    bt2r     iio8ir.bit.b1    /* II/O communication base timer 2 interrupt */
                                            /* (b5) - */
#define    ie2r     iio7ir.bit.b6
#define    ie1r     iio7ir.bit.b7

/*------------------------------------------------------
     iio9ir
------------------------------------------------------*/
#define    iio9irb   iio9ir.byte
                                            /* (b0) - */
#define    tm15r    iio9ir.bit.b1    /* II/O time measurement 5 interrupt */
#define    po15r    iio9ir.bit.b1    /* II/O waveform generation function 5 interrupt */
#define    po24r    iio9ir.bit.b2    /* II/O waveform generation function 4 interrupt */
                                            /* (b4-b3) - */
#define    u6rr     iio9ir.bit.b5
#define    int6r    iio9ir.bit.b6
#define    can00r   iio9ir.bit.b7    /* CAN0 communication function interrupt */

/*------------------------------------------------------
     iio10ir
------------------------------------------------------*/
#define    iio10irb  iio10ir.byte
                                            /* (b0) - */
#define    tm16r    iio10ir.bit.b1   /* II/O time measurement 6 interrupt */
#define    po16r    iio10ir.bit.b1   /* II/O waveform generation function 6 interrupt */
#define    po25r    iio10ir.bit.b2    /* II/O waveform generation function 5 interrupt */
                                            /* (b4-b3) - */
#define    u6tr     iio10ir.bit.b5
#define    int7r    iio10ir.bit.b6
#define    can01r   iio10ir.bit.b7   /* CAN0 communication function interrupt */

/*------------------------------------------------------
     iio11ir
------------------------------------------------------*/
#define    iio11irb  iio11ir.byte
                                            /* (b0) - */
                                            /* (b6-b1) - */
#define    po26r    iio11ir.bit.b2    /* II/O waveform generation function 6 interrupt */
                                            /* (b5-b3) - */
#define    int8r    iio11ir.bit.b6
#define    can02r   iio11ir.bit.b7   /* CAN0 communication function interrupt */


/*------------------------------------------------------
        Interrupt Enable Register
------------------------------------------------------*/

/*------------------------------------------------------
     iio0ie
------------------------------------------------------*/
#define    iio0ieb   iio0ie.byte
#define    irlt_iio0ie  iio0ie.bit.b0    /* Interrupt request select bit */
                                                /* (b1) - */
#define    tm13e        iio0ie.bit.b2    /* II/O time measurement 3 interrupt */
#define    po13e        iio0ie.bit.b2    /* II/O waveform generation function 3 interrupt */
                                                /* (b3) - */
#define    g0rie        iio0ie.bit.b4    /* II/O communication unit 0 HDLC data processing function interrupt */
#define    sio0re       iio0ie.bit.b5    /* II/O communication unit 0 receive interrupt */
#define    u5re         iio0ie.bit.b6
#define    can10e       iio0ie.bit.b7    /* CAN1 communication function interrupt */

/*------------------------------------------------------
     iio1ie
------------------------------------------------------*/
#define    iio1ieb   iio1ie.byte
#define    irlt_iio1ie  iio1ie.bit.b0    /* Interrupt request select bit */
                                                /* (b1) - */
#define    tm14e        iio1ie.bit.b2    /* II/O time measurement 3 interrupt */
#define    po14e        iio1ie.bit.b2    /* II/O waveform generation function 3 interrupt */
                                               /* (b3) - */
#define    g0toe        iio1ie.bit.b4    /* II/O communication unit 0 HDLC data processing function interrupt */
#define    sio0te       iio1ie.bit.b5    /* II/O communication unit 0 receive interrupt */
#define    u5te         iio1ie.bit.b6
#define    can11e       iio1ie.bit.b7    /* CAN1 communication function interrupt */

/*------------------------------------------------------
     iio2ie
------------------------------------------------------*/
#define    iio2ieb       iio2ie.byte
#define    irlt_iio2ie  iio2ie.bit.b0    /* Interrupt request select bit */
                                                /* (b1) - */
#define    tm12e        iio2ie.bit.b2    /* II/O time measurement 2 interrupt */
#define    po12e        iio2ie.bit.b2    /* II/O waveform generation function 2 interrupt */
                                              /* (b3) - */
#define    g1rie        iio2ie.bit.b4    /* II/O communication unit 1 HDLC data processing function interrupt */
#define    sio1re       iio2ie.bit.b5    /* II/O communication unit 1 receive interrupt */
                                                /* (b6) - */
                                                /* (b7) - */

/*------------------------------------------------------
     iio3ie
------------------------------------------------------*/
#define    iio3ieb       iio3ie.byte
#define    irlt_iio3ie  iio3ie.bit.b0    /* Interrupt request select bit */
                                                /* (b1) - */
#define    tm10e        iio3ie.bit.b2    /* II/O time measurement 0 interrupt */
#define    po10e        iio3ie.bit.b2    /* II/O waveform generation function 0 interrupt */
#define    po27e        iio3ie.bit.b3    /* II/O waveform generation function 7 interrupt */
#define    g1toe        iio3ie.bit.b4    /* II/O communication unit 1 HDLC data processing function interrupt */
#define    sio1te       iio3ie.bit.b5    /* II/O communication unit 0 transmit interrupt */
                                                /* (b6) - */
                                                /* (b7) - */

/*------------------------------------------------------
     iio4ie
------------------------------------------------------*/
#define    iio4ieb       iio4ie.byte
#define    irlt_iio4ie  iio4ie.bit.b0    /* Interrupt request select bit */
                                                /* (b1) - */
#define    tm17e        iio4ie.bit.b2    /* II/O time measurement 7 interrupt */
#define    po17e        iio4ie.bit.b2    /* II/O waveform generation function 7 interrupt */
                                              /* (b3) - */
#define    bt1e         iio4ie.bit.b4    /* II/O communication base timer interrupt */
                                              /* (b5) - */
#define    srt1e        iio4ie.bit.b6    /* II/O special communication function interrupt */
#define    srt0e        iio4ie.bit.b7    /* II/O special communication function interrupt */

/*------------------------------------------------------
     iio5ie
------------------------------------------------------*/
#define    iio5ieb       iio5ie.byte

#define    irlt_iio5ie  iio5ie.bit.b0    /* Interrupt request select bit */
                                                /* (b1) - */
#define    po21e        iio5ie.bit.b2    /* II/O waveform generation function 1 interrupt */
                                                /* (b3) - */
#define    sio2re       iio5ie.bit.b4    /* II/O communication unit 2 receive interrupt */
                                                /* (b5-b1) - */
#define    can1wue      iio5ie.bit.b6    /* CAN1 wake-up interrupt */
#define    can12e       iio5ie.bit.b7    /* CAN1 communication function interrupt */

/*------------------------------------------------------
     iio6ie
------------------------------------------------------*/
#define    iio6ieb       iio6ie.byte

#define    irlt_iio6ie  iio6ie.bit.b0    /* Interrupt request select bit */
                                                /* (b1) - */
#define    po20e        iio6ie.bit.b2    /* II/O waveform generation function 0 interrupt */
                                                /* (b3) - */
#define    sio2te       iio6ie.bit.b4    /* II/O communication unit 2 transmit interrupt */
                                                /* (b7-b5) - */

/*------------------------------------------------------
     iio7ie
------------------------------------------------------*/
#define    iio7ieb       iio7ie.byte

#define    irlt_iio7ie  iio7ie.bit.b0    /* Interrupt request select bit */
                                                /* (b1) - */
#define    po22e        iio7ie.bit.b2    /* II/O waveform generation function 2 interrupt */
                                                /* (b6-b3) - */
#define    ie0e         iio7ie.bit.b7

/*------------------------------------------------------
     iio8ie
------------------------------------------------------*/
#define    iio8ieb       iio8ie.byte
#define    irlt_iio8ie  iio8ie.bit.b0    /* Interrupt request select bit */
#define    tm11e        iio8ie.bit.b1    /* II/O time measurement 1 interrupt */
#define    po11e        iio8ie.bit.b1    /* II/O waveform generation function 1 interrupt */
#define    po23e        iio8ie.bit.b2    /* II/O waveform generation function 3 interrupt */
                                                /* (b3) - */
#define    bt2e         iio8ie.bit.b4    /* II/O communication base timer 2 interrupt */
                                                /* (b5) - */
#define    ie2e         iio8ie.bit.b6
#define    ie1e         iio8ie.bit.b7

/*------------------------------------------------------
     iio9ie
------------------------------------------------------*/
#define    iio9ieb       iio9ie.byte
#define    irlt_iio9ie  iio9ie.bit.b0    /* Interrupt request select bit */
#define    tm15e        iio9ie.bit.b1    /* II/O time measurement 5 interrupt */
#define    po15e        iio9ie.bit.b1    /* II/O waveform generation function 5 interrupt */
#define    po24e        iio9ie.bit.b2    /* II/O waveform generation function 4 interrupt */
                                              /* (b4-b3) - */
#define    u6re         iio9ie.bit.b5
#define    int6e        iio9ie.bit.b6
#define    can00e       iio9ie.bit.b7    /* CAN0 communication function interrupt */

/*------------------------------------------------------
     iio10ie
------------------------------------------------------*/
#define    iio10ieb      iio10ie.byte
#define    irlt_iio10ie iio10ie.bit.b0   /* Interrupt request select bit */
#define    tm16e        iio10ie.bit.b1   /* II/O time measurement 6 interrupt */
#define    po16e        iio10ie.bit.b1   /* II/O waveform generation function 6 interrupt */
#define    po25e        iio10ie.bit.b2   /* II/O waveform generation function 5 interrupt */
                                                /* (b4-b3) - */
#define    u6te         iio10ie.bit.b5
#define    int7e        iio10ie.bit.b6
#define    can01e       iio10ie.bit.b7   /* CAN0 communication function interrupt */

/*------------------------------------------------------
     iio11ie
------------------------------------------------------*/
#define    iio11ieb      iio11ie.byte
#define    irlt_iio11ie iio11ie.bit.b0   /* Interrupt request select bit */
#define    po26e        iio11ie.bit.b2   /* II/O waveform generation function 6 interrupt */
                                                /* (b5-b3) - */
#define    int8e        iio11ie.bit.b6
#define    can02e       iio11ie.bit.b7   /* CAN0 communication function interrupt */


/*------------------------------------------------------
    Timer mode registers
------------------------------------------------------*/
struct timer_bit_def {
        char    tmod0:1;
        char    tmod1:1;
        char    mr0:1;
        char    mr1:1;
        char    mr2:1;
        char    mr3:1;
        char    tck0:1;
        char    tck1:1;
};
union timer_byte_def{
    struct timer_bit_def bit;
    char    byte;
};
/*------------------------------------------------------
     ta0mr
------------------------------------------------------*/
#define     ta0mrb       ta0mr.byte

#define     tmod0_ta0mr     ta0mr.bit.tmod0
#define     tmod1_ta0mr     ta0mr.bit.tmod1
#define     mr1_ta0mr       ta0mr.bit.mr1
#define     mr2_ta0mr       ta0mr.bit.mr2
#define     mr3_ta0mr       ta0mr.bit.mr3
#define     tck0_ta0mr      ta0mr.bit.tck0
#define     tck1_ta0mr      ta0mr.bit.tck1

/*------------------------------------------------------
     ta1mr
------------------------------------------------------*/
#define     ta1mrb       ta1mr.byte

#define     tmod0_ta1mr     ta1mr.bit.tmod0
#define     tmod1_ta1mr     ta1mr.bit.tmod1
#define     mr1_ta1mr       ta1mr.bit.mr1
#define     mr2_ta1mr       ta1mr.bit.mr2
#define     mr3_ta1mr       ta1mr.bit.mr3
#define     tck0_ta1mr      ta1mr.bit.tck0
#define     tck1_ta1mr      ta1mr.bit.tck1

/*------------------------------------------------------
     ta2mr
------------------------------------------------------*/
#define     ta2mrb       ta2mr.byte

#define     tmod0_ta2mr     ta2mr.bit.tmod0
#define     tmod1_ta2mr     ta2mr.bit.tmod1
#define     mr1_ta2mr       ta2mr.bit.mr1
#define     mr2_ta2mr       ta2mr.bit.mr2
#define     mr3_ta2mr       ta2mr.bit.mr3
#define     tck0_ta2mr      ta2mr.bit.tck0
#define     tck1_ta2mr      ta2mr.bit.tck1

/*------------------------------------------------------
     ta3mr
------------------------------------------------------*/
#define     ta3mrb       ta3mr.byte

#define     tmod0_ta3mr     ta3mr.bit.tmod0
#define     tmod1_ta3mr     ta3mr.bit.tmod1
#define     mr1_ta3mr       ta3mr.bit.mr1
#define     mr2_ta3mr       ta3mr.bit.mr2
#define     mr3_ta3mr       ta3mr.bit.mr3
#define     tck0_ta3mr      ta3mr.bit.tck0
#define     tck1_ta3mr      ta3mr.bit.tck1

/*------------------------------------------------------
     ta4mr
------------------------------------------------------*/
#define     ta4mrb       ta4mr.byte

#define     tmod0_ta4mr     ta4mr.bit.tmod0
#define     tmod1_ta4mr     ta4mr.bit.tmod1
#define     mr1_ta4mr       ta4mr.bit.mr1
#define     mr2_ta4mr       ta4mr.bit.mr2
#define     mr3_ta4mr       ta4mr.bit.mr3
#define     tck0_ta4mr      ta4mr.bit.tck0
#define     tck1_ta4mr      ta4mr.bit.tck1

/*------------------------------------------------------
     tb0mr
 ------------------------------------------------------*/
#define     tb0mrb       tb0mr.byte

#define     tmod0_tb0mr     tb0mr.bit.tmod0
#define     tmod1_tb0mr     tb0mr.bit.tmod1
#define     mr0_tb0mr       tb0mr.bit.mr0
#define     mr1_tb0mr       tb0mr.bit.mr1
#define     mr2_tb0mr       tb0mr.bit.mr2
#define     mr3_tb0mr       tb0mr.bit.mr3
#define     tck0_tb0mr      tb0mr.bit.tck0
#define     tck1_tb0mr      tb0mr.bit.tck1

/*------------------------------------------------------
     tb1mr
------------------------------------------------------*/
#define     tb1mrb       tb1mr.byte

#define     tmod0_tb1mr     tb1mr.bit.tmod0
#define     tmod1_tb1mr     tb1mr.bit.tmod1
#define     mr0_tb1mr       tb1mr.bit.mr0
#define     mr1_tb1mr       tb1mr.bit.mr1
#define     mr2_tb1mr       tb1mr.bit.mr2
#define     mr3_tb1mr       tb1mr.bit.mr3
#define     tck0_tb1mr      tb1mr.bit.tck0
#define     tck1_tb1mr      tb1mr.bit.tck1

/*------------------------------------------------------
     tb2mr
------------------------------------------------------*/
#define     tb2mrb       tb2mr.byte

#define     tmod0_tb2mr     tb2mr.bit.tmod0
#define     tmod1_tb2mr     tb2mr.bit.tmod1
#define     mr0_tb2mr       tb2mr.bit.mr0
#define     mr1_tb2mr       tb2mr.bit.mr1
#define     mr2_tb2mr       tb2mr.bit.mr2
#define     mr3_tb2mr       tb2mr.bit.mr3
#define     tck0_tb2mr      tb2mr.bit.tck0
#define     tck1_tb2mr      tb2mr.bit.tck1

/*------------------------------------------------------
     tb3mr
------------------------------------------------------*/
#define     tb3mrb       tb3mr.byte

#define     tmod0_tb3mr     tb3mr.bit.tmod0
#define     tmod1_tb3mr     tb3mr.bit.tmod1
#define     mr0_tb3mr       tb3mr.bit.mr0
#define     mr1_tb3mr       tb3mr.bit.mr1
#define     mr2_tb3mr       tb3mr.bit.mr2
#define     mr3_tb3mr       tb3mr.bit.mr3
#define     tck0_tb3mr      tb3mr.bit.tck0
#define     tck1_tb3mr      tb3mr.bit.tck1

/*------------------------------------------------------
     tb4mr
------------------------------------------------------*/
#define     tb4mrb       tb4mr.byte

#define     tmod0_tb4mr     tb4mr.bit.tmod0
#define     tmod1_tb4mr     tb4mr.bit.tmod1
#define     mr0_tb4mr       tb4mr.bit.mr0
#define     mr1_tb4mr       tb4mr.bit.mr1
#define     mr2_tb4mr       tb4mr.bit.mr2
#define     mr3_tb4mr       tb4mr.bit.mr3
#define     tck0_tb4mr      tb4mr.bit.tck0
#define     tck1_tb4mr      tb4mr.bit.tck1

/*------------------------------------------------------
     tb5mr
------------------------------------------------------*/
#define     tb5mrb       tb5mr.byte

#define     tmod0_tb5mr     tb5mr.bit.tmod0
#define     tmod1_tb5mr     tb5mr.bit.tmod1
#define     mr0_tb5mr       tb5mr.bit.mr0
#define     mr1_tb5mr       tb5mr.bit.mr1
#define     mr2_tb5mr       tb5mr.bit.mr2
#define     mr3_tb5mr       tb5mr.bit.mr3
#define     tck0_tb5mr      tb5mr.bit.tck0
#define     tck1_tb5mr      tb5mr.bit.tck1

/*------------------------------------------------------
    UARTi transmit/receive mode registers
------------------------------------------------------*/
struct uimr_bit_def {
        char    smd0:1;
        char    smd1:1;
        char    smd2:1;
        char    ckdir:1;
        char    stps:1;
        char    pry:1;
        char    prye:1;
        char    iopol:1;
};
union uimr_tr_byte_def{
    struct uimr_bit_def bit;
    char    byte;
};

/*------------------------------------------------------
     u0mr
------------------------------------------------------*/
#define     u0mrb        u0mr.byte

#define     smd0_u0mr   u0mr.bit.smd0  /* Serial I/O mode select bit */
#define     smd1_u0mr   u0mr.bit.smd1  /* Serial I/O mode select bit */
#define     smd2_u0mr   u0mr.bit.smd2  /* Serial I/O mode select bit */
#define     ckdir_u0mr  u0mr.bit.ckdir  /* Internal/external clock select bit */
#define     stps_u0mr   u0mr.bit.stps  /* Stop bit length select bit */
#define     pry_u0mr    u0mr.bit.pry  /* Odd/even parity select bit */
#define     prye_u0mr   u0mr.bit.prye  /* Parity enable bit */
#define     iopol_u0mr  u0mr.bit.iopol  /* TxD RxD I/O polarity switch bit */

/*------------------------------------------------------
     u1mr
------------------------------------------------------*/
#define     u1mrb        u1mr.byte

#define     smd0_u1mr   u1mr.bit.smd0  /* Serial I/O mode select bit */
#define     smd1_u1mr   u1mr.bit.smd1  /* Serial I/O mode select bit */
#define     smd2_u1mr   u1mr.bit.smd2  /* Serial I/O mode select bit */
#define     ckdir_u1mr  u1mr.bit.ckdir  /* Internal/external clock select bit */
#define     stps_u1mr   u1mr.bit.stps  /* Stop bit length select bit */
#define     pry_u1mr    u1mr.bit.pry  /* Odd/even parity select bit */
#define     prye_u1mr   u1mr.bit.prye  /* Parity enable bit */
#define     iopol_u1mr  u1mr.bit.iopol  /* TxD RxD I/O polarity switch bit */

/*------------------------------------------------------
     u2mr
------------------------------------------------------*/
#define     u2mrb        u2mr.byte

#define     smd0_u2mr   u2mr.bit.smd0  /* Serial I/O mode select bit */
#define     smd1_u2mr   u2mr.bit.smd1  /* Serial I/O mode select bit */
#define     smd2_u2mr   u2mr.bit.smd2  /* Serial I/O mode select bit */
#define     ckdir_u2mr  u2mr.bit.ckdir  /* Internal/external clock select bit */
#define     stps_u2mr   u2mr.bit.stps  /* Stop bit length select bit */
#define     pry_u2mr    u2mr.bit.pry  /* Odd/even parity select bit */
#define     prye_u2mr   u2mr.bit.prye  /* Parity enable bit */
#define     iopol_u2mr  u2mr.bit.iopol  /* TxD RxD I/O polarity switch bit */
/*------------------------------------------------------
     u3mr
------------------------------------------------------*/
#define     u3mrb        u3mr.byte

#define     smd0_u3mr   u3mr.bit.smd0  /* Serial I/O mode select bit */
#define     smd1_u3mr   u3mr.bit.smd1  /* Serial I/O mode select bit */
#define     smd2_u3mr   u3mr.bit.smd2  /* Serial I/O mode select bit */
#define     ckdir_u3mr  u3mr.bit.ckdir  /* Internal/external clock select bit */
#define     stps_u3mr   u3mr.bit.stps  /* Stop bit length select bit */
#define     pry_u3mr    u3mr.bit.pry  /* Odd/even parity select bit */
#define     prye_u3mr   u3mr.bit.prye  /* Parity enable bit */
#define     iopol_u3mr  u3mr.bit.iopol  /* TxD RxD I/O polarity switch bit */

/*------------------------------------------------------
     u4mr
------------------------------------------------------*/
#define     u4mrb        u4mr.byte

#define     smd0_u4mr   u4mr.bit.smd0  /* Serial I/O mode select bit */
#define     smd1_u4mr   u4mr.bit.smd1  /* Serial I/O mode select bit */
#define     smd2_u4mr   u4mr.bit.smd2  /* Serial I/O mode select bit */
#define     ckdir_u4mr  u4mr.bit.ckdir  /* Internal/external clock select bit */
#define     stps_u4mr   u4mr.bit.stps  /* Stop bit length select bit */
#define     pry_u4mr    u4mr.bit.pry  /* Odd/even parity select bit */
#define     prye_u4mr   u4mr.bit.prye  /* Parity enable bit */
#define     iopol_u4mr  u4mr.bit.iopol  /* TxD RxD I/O polarity switch bit */

/*------------------------------------------------------
     u5mr
------------------------------------------------------*/
#define     u5mrb        u5mr.byte

#define     smd0_u5mr   u5mr.bit.smd0  /* Serial I/O mode select bit */
#define     smd1_u5mr   u5mr.bit.smd1  /* Serial I/O mode select bit */
#define     smd2_u5mr   u5mr.bit.smd2  /* Serial I/O mode select bit */
#define     ckdir_u5mr  u5mr.bit.ckdir  /* Internal/external clock select bit */
#define     stps_u5mr   u5mr.bit.stps  /* Stop bit length select bit */
#define     pry_u5mr    u5mr.bit.pry  /* Odd/even parity select bit */
#define     prye_u5mr   u5mr.bit.prye  /* Parity enable bit */

/*------------------------------------------------------
     u6mr
------------------------------------------------------*/
#define     u6mrb        u6mr.byte

#define     smd0_u6mr   u6mr.bit.smd0  /* Serial I/O mode select bit */
#define     smd1_u6mr   u6mr.bit.smd1  /* Serial I/O mode select bit */
#define     smd2_u6mr   u6mr.bit.smd2  /* Serial I/O mode select bit */
#define     ckdir_u6mr  u6mr.bit.ckdir  /* Internal/external clock select bit */
#define     stps_u6mr   u6mr.bit.stps  /* Stop bit length select bit */
#define     pry_u6mr    u6mr.bit.pry  /* Odd/even parity select bit */
#define     prye_u6mr   u6mr.bit.prye  /* Parity enable bit */

/*------------------------------------------------------
    UARTi transmit/receive control register 0 (i=0,1,2,3,4)
------------------------------------------------------*/
struct uici_bit_def {
        char    b0:1;
        char    b1:1;
        char    b2:1;
        char    b3:1;
        char    b4:1;
        char    b5:1;
        char    b6:1;
        char    b7:1;
};
union uici_byte_def{
    struct uici_bit_def bit;
    char    byte;
};
/*------------------------------------------------------
     u0c0
------------------------------------------------------*/
#define     u0c0b        u0c0.byte

#define     clk0_u0c0   u0c0.bit.b0     /* BRG count source select bit */
#define     clk1_u0c0   u0c0.bit.b1     /* BRG count source select bit */
#define     crs_u0c0    u0c0.bit.b2     /* CTS~/RTS~ function select bit */
#define     txept_u0c0  u0c0.bit.b3     /* Transmit register empty flag */
#define     crd_u0c0    u0c0.bit.b4     /* CTS~/RTS~ disable bit */
#define     nch_u0c0    u0c0.bit.b5     /* Data output select bit */
#define     ckpol_u0c0  u0c0.bit.b6     /* CLK polarity select bit */
#define     uform_u0c0  u0c0.bit.b7     /* Transfer format select bit */

/*------------------------------------------------------
     u1c0
------------------------------------------------------*/
#define     u1c0b        u1c0.byte

#define     clk0_u1c0   u1c0.bit.b0
#define     clk1_u1c0   u1c0.bit.b1
#define     crs_u1c0    u1c0.bit.b2
#define     txept_u1c0  u1c0.bit.b3
#define     crd_u1c0    u1c0.bit.b4
#define     nch_u1c0    u1c0.bit.b5
#define     ckpol_u1c0  u1c0.bit.b6
#define     uform_u1c0  u1c0.bit.b7

/*------------------------------------------------------
     u2c0
------------------------------------------------------*/
#define     u2c0b        u2c0.byte

#define     clk0_u2c0   u2c0.bit.b0
#define     clk1_u2c0   u2c0.bit.b1
#define     crs_u2c0    u2c0.bit.b2
#define     txept_u2c0  u2c0.bit.b3
#define     crd_u2c0    u2c0.bit.b4
#define     ckpol_u2c0  u2c0.bit.b6
#define     uform_u2c0  u2c0.bit.b7

/*------------------------------------------------------
     u3c0
------------------------------------------------------*/
#define     u3c0b        u3c0.byte

#define     clk0_u3c0   u3c0.bit.b0
#define     clk1_u3c0   u3c0.bit.b1
#define     crs_u3c0    u3c0.bit.b2
#define     txept_u3c0  u3c0.bit.b3
#define     crd_u3c0    u3c0.bit.b4
#define     nch_u3c0    u3c0.bit.b5
#define     ckpol_u3c0  u3c0.bit.b6
#define     uform_u3c0  u3c0.bit.b7

/*------------------------------------------------------
     u4c0
------------------------------------------------------*/
#define     u4c0b        u4c0.byte

#define     clk0_u4c0   u4c0.bit.b0
#define     clk1_u4c0   u4c0.bit.b1
#define     crs_u4c0    u4c0.bit.b2
#define     txept_u4c0  u4c0.bit.b3
#define     crd_u4c0    u4c0.bit.b4
#define     nch_u4c0    u4c0.bit.b5
#define     ckpol_u4c0  u4c0.bit.b6
#define     uform_u4c0  u4c0.bit.b7

/*------------------------------------------------------
     u5c0
------------------------------------------------------*/
#define     u5c0b        u5c0.byte

#define     clk0_u5c0   u5c0.bit.b0
#define     clk1_u5c0   u5c0.bit.b1
#define     crs_u5c0    u5c0.bit.b2
#define     txept_u5c0  u5c0.bit.b3
#define     crd_u5c0    u5c0.bit.b4
#define     nch_u5c0    u5c0.bit.b5
#define     ckpol_u5c0  u5c0.bit.b6
#define     uform_u5c0  u5c0.bit.b7

/*------------------------------------------------------
     u6c0
------------------------------------------------------*/
#define     u6c0b        u6c0.byte

#define     clk0_u6c0   u6c0.bit.b0
#define     clk1_u6c0   u6c0.bit.b1
#define     crs_u6c0    u6c0.bit.b2
#define     txept_u6c0  u6c0.bit.b3
#define     crd_u6c0    u6c0.bit.b4
#define     nch_u6c0    u6c0.bit.b5
#define     ckpol_u6c0  u6c0.bit.b6
#define     uform_u6c0  u6c0.bit.b7

		
/*------------------------------------------------------
    UARTi receive buffer register (i=0,1,2,3,4)
------------------------------------------------------*/

/*------------------------------------------------------
     u0rb
------------------------------------------------------*/
#define     u0rbw       u0rb.word
#define     u0rbl       u0rb.byte.low
#define     u0rbh       u0rb.byte.high

#define     abt_u0rb    u0rb.bit.b11           /* Arbitration lost detect flag */
#define     oer_u0rb    u0rb.bit.b12           /* Overrun error flag */
#define     fer_u0rb    u0rb.bit.b13           /* Framing error flag */
#define     per_u0rb    u0rb.bit.b14           /* Parity error flag */
#define     sum_u0rb    u0rb.bit.b15           /* Error sum flag */

/*------------------------------------------------------
     u1rb
------------------------------------------------------*/
#define     u1rbw       u1rb.word
#define     u1rbl       u1rb.byte.low
#define     u1rbh       u1rb.byte.high

#define     abt_u1rb    u1rb.bit.b11           /* Arbitration lost detect flag */
#define     oer_u1rb    u1rb.bit.b12           /* Overrun error flag */
#define     fer_u1rb    u1rb.bit.b13           /* Framing error flag */
#define     per_u1rb    u1rb.bit.b14           /* Parity error flag */
#define     sum_u1rb    u1rb.bit.b15           /* Error sum flag */

/*------------------------------------------------------
     u2rb
------------------------------------------------------*/
#define     u2rbw       u2rb.word
#define     u2rbl       u2rb.byte.low
#define     u2rbh       u2rb.byte.high

#define     abt_u2rb    u2rb.bit.b11           /* Arbitration lost detect flag */
#define     oer_u2rb    u2rb.bit.b12           /* Overrun error flag */
#define     fer_u2rb    u2rb.bit.b13           /* Framing error flag */
#define     per_u2rb    u2rb.bit.b14           /* Parity error flag */
#define     sum_u2rb    u2rb.bit.b15           /* Error sum flag */

/*------------------------------------------------------
     u3rb
------------------------------------------------------*/
#define     u3rbw       u3rb.word
#define     u3rbl       u3rb.byte.low
#define     u3rbh       u3rb.byte.high

#define     abt_u3rb    u3rb.bit.b11           /* Arbitration lost detect flag */
#define     oer_u3rb    u3rb.bit.b12           /* Overrun error flag */
#define     fer_u3rb    u3rb.bit.b13           /* Framing error flag */
#define     per_u3rb    u3rb.bit.b14           /* Parity error flag */
#define     sum_u3rb    u3rb.bit.b15           /* Error sum flag */

/*------------------------------------------------------
     u4rb
------------------------------------------------------*/
#define     u4rbw       u4rb.word
#define     u4rbl       u4rb.byte.low
#define     u4rbh       u4rb.byte.high

#define     abt_u4rb    u4rb.bit.b11           /* Arbitration lost detect flag */
#define     oer_u4rb    u4rb.bit.b12           /* Overrun error flag */
#define     fer_u4rb    u4rb.bit.b13           /* Framing error flag */
#define     per_u4rb    u4rb.bit.b14           /* Parity error flag */
#define     sum_u4rb    u4rb.bit.b15           /* Error sum flag */

/*------------------------------------------------------
     u5rb
------------------------------------------------------*/
#define     u5rbw       u5rb.word
#define     u5rbl       u5rb.byte.low
#define     u5rbh       u5rb.byte.high

#define     abt_u5rb    u5rb.bit.b11           /* Arbitration lost detect flag */
#define     oer_u5rb    u5rb.bit.b12           /* Overrun error flag */
#define     fer_u5rb    u5rb.bit.b13           /* Framing error flag */
#define     per_u5rb    u5rb.bit.b14           /* Parity error flag */
#define     sum_u5rb    u5rb.bit.b15           /* Error sum flag */

/*------------------------------------------------------
     u6rb
------------------------------------------------------*/
#define     u6rbw       u6rb.word
#define     u6rbl       u6rb.byte.low
#define     u6rbh       u6rb.byte.high

#define     abt_u6rb    u6rb.bit.b11           /* Arbitration lost detect flag */
#define     oer_u6rb    u6rb.bit.b12           /* Overrun error flag */
#define     fer_u6rb    u6rb.bit.b13           /* Framing error flag */
#define     per_u6rb    u6rb.bit.b14           /* Parity error flag */
#define     sum_u6rb    u6rb.bit.b15           /* Error sum flag */

/*------------------------------------------------------
    UARTi (i= 0,1,2,3,4) special mode registers
------------------------------------------------------*/

/*------------------------------------------------------
     u0smr
------------------------------------------------------*/
#define     u0smrb       u0smr.byte

#define     iicm_u0smr      u0smr.bit.b0    /* IIC mode select bit */
#define     abc_u0smr       u0smr.bit.b1    /* Arbitration lost detect flag control bit */
#define     bbs_u0smr       u0smr.bit.b2    /* Bus busy flag */
#define     lsyn_u0smr      u0smr.bit.b3    /* SCLL sync output enable bit */
#define     abscs_u0smr     u0smr.bit.b4    /* Bus conflict detect sampling clock select bit */
#define     acse_u0smr      u0smr.bit.b5    /* Auto clear function select bit for transmit enable bit */
#define     sss_u0smr       u0smr.bit.b6    /* Transmit start condition select bit */
#define     sclkdiv_u0smr   u0smr.bit.b7    /* Clock divide synchronous bit */

/*------------------------------------------------------
     u1smr
------------------------------------------------------*/
#define     u1smrb       u1smr.byte

#define     iicm_u1smr      u1smr.bit.b0    /* IIC mode select bit */
#define     abc_u1smr       u1smr.bit.b1    /* Arbitration lost detect flag control bit */
#define     bbs_u1smr       u1smr.bit.b2    /* Bus busy flag */
#define     lsyn_u1smr      u1smr.bit.b3    /* SCLL sync output enable bit */
#define     abscs_u1smr     u1smr.bit.b4    /* Bus conflict detect sampling clock select bit */
#define     acse_u1smr      u1smr.bit.b5    /* Auto clear function select bit for transmit enable bit */
#define     sss_u1smr       u1smr.bit.b6    /* Transmit start condition select bit */
#define     sclkdiv_u1smr   u1smr.bit.b7    /* Clock divide synchronous bit */

/*------------------------------------------------------
     u2smr
------------------------------------------------------*/
#define     u2smrb       u2smr.byte

#define     iicm_u2smr      u2smr.bit.b0    /* IIC mode select bit */
#define     abc_u2smr       u2smr.bit.b1    /* Arbitration lost detect flag control bit */
#define     bbs_u2smr       u2smr.bit.b2    /* Bus busy flag */
#define     lsyn_u2smr      u2smr.bit.b3    /* SCLL sync output enable bit */
#define     abscs_u2smr     u2smr.bit.b4    /* Bus conflict detect sampling clock select bit */
#define     acse_u2smr      u2smr.bit.b5    /* Auto clear function select bit for transmit enable bit */
#define     sss_u2smr       u2smr.bit.b6    /* Transmit start condition select bit */
#define     sclkdiv_u2smr   u2smr.bit.b7    /* Clock divide synchronous bit */

/*------------------------------------------------------
     u3smr
------------------------------------------------------*/
#define     u3smrb       u3smr.byte

#define     iicm_u3smr      u3smr.bit.b0    /* IIC mode select bit */
#define     abc_u3smr       u3smr.bit.b1    /* Arbitration lost detect flag control bit */
#define     bbs_u3smr       u3smr.bit.b2    /* Bus busy flag */
#define     lsyn_u3smr      u3smr.bit.b3    /* SCLL sync output enable bit */
#define     abscs_u3smr     u3smr.bit.b4    /* Bus conflict detect sampling clock select bit */
#define     acse_u3smr      u3smr.bit.b5    /* Auto clear function select bit for transmit enable bit */
#define     sss_u3smr       u3smr.bit.b6    /* Transmit start condition select bit */
#define     sclkdiv_u3smr   u3smr.bit.b7    /* Clock divide synchronous bit */

/*------------------------------------------------------
     u4smr
------------------------------------------------------*/
#define     u4smrb       u4smr.byte

#define     iicm_u4smr      u4smr.bit.b0    /* IIC mode select bit */
#define     abc_u4smr       u4smr.bit.b1    /* Arbitration lost detect flag control bit */
#define     bbs_u4smr       u4smr.bit.b2    /* Bus busy flag */
#define     lsyn_u4smr      u4smr.bit.b3    /* SCLL sync output enable bit */
#define     abscs_u4smr     u4smr.bit.b4    /* Bus conflict detect sampling clock select bit */
#define     acse_u4smr      u4smr.bit.b5    /* Auto clear function select bit for transmit enable bit */
#define     sss_u4smr       u4smr.bit.b6    /* Transmit start condition select bit */
#define     sclkdiv_u4smr   u4smr.bit.b7    /* Clock divide synchronous bit */

/*------------------------------------------------------
    UARTi (i=0,1,2,3,4) special mode register 2
------------------------------------------------------*/

/*------------------------------------------------------
     u0smr2
------------------------------------------------------*/
#define     u0smr2b      u0smr2.byte

#define     iicm2_u0smr2    u0smr2.bit.b0   /* IIC mode select bit2 */
#define     csc_u0smr2      u0smr2.bit.b1   /* Clock synchronous bit */
#define     swc_u0smr2      u0smr2.bit.b2   /* SCL wait output bit */
#define     als_u0smr2      u0smr2.bit.b3   /* SDA output stop bit */
#define     stc_u0smr2      u0smr2.bit.b4   /* UARTi initialize bit */
#define     swc2_u0smr2     u0smr2.bit.b5   /* SCL wait output bit2 */
#define     sdhi_u0smr2     u0smr2.bit.b6   /* SDA output inhibit bit */
#define     su1him_u0smr2   u0smr2.bit.b7   /* External clock synchronous enable bit */


/*------------------------------------------------------
     u1smr2
------------------------------------------------------*/
#define     u1smr2b      u1smr2.byte

#define     iicm2_u1smr2    u1smr2.bit.b0   /* IIC mode select bit2 */
#define     csc_u1smr2      u1smr2.bit.b1   /* Clock synchronous bit */
#define     swc_u1smr2      u1smr2.bit.b2   /* SCL wait output bit */
#define     als_u1smr2      u1smr2.bit.b3   /* SDA output stop bit */
#define     stc_u1smr2      u1smr2.bit.b4   /* UARTi initialize bit */
#define     swc2_u1smr2     u1smr2.bit.b5   /* SCL wait output bit2 */
#define     sdhi_u1smr2     u1smr2.bit.b6   /* SDA output inhibit bit */
#define     su1him_u1smr2   u1smr2.bit.b7   /* External clock synchronous enable bit */

/*------------------------------------------------------
     u2smr2
------------------------------------------------------*/
#define     u2smr2b      u2smr2.byte

#define     iicm2_u2smr2    u2smr2.bit.b0   /* IIC mode select bit2 */
#define     csc_u2smr2      u2smr2.bit.b1   /* Clock synchronous bit */
#define     swc_u2smr2      u2smr2.bit.b2   /* SCL wait output bit */
#define     als_u2smr2      u2smr2.bit.b3   /* SDA output stop bit */
#define     stc_u2smr2      u2smr2.bit.b4   /* UARTi initialize bit */
#define     swc2_u2smr2     u2smr2.bit.b5   /* SCL wait output bit2 */
#define     sdhi_u2smr2     u2smr2.bit.b6   /* SDA output inhibit bit */
#define     su1him_u2smr2   u2smr2.bit.b7   /* External clock synchronous enable bit */

/*------------------------------------------------------
     u3smr2
------------------------------------------------------*/
#define     u3smr2b      u3smr2.byte

#define     iicm2_u3smr2    u3smr2.bit.b0   /* IIC mode select bit2 */
#define     csc_u3smr2      u3smr2.bit.b1   /* Clock synchronous bit */
#define     swc_u3smr2      u3smr2.bit.b2   /* SCL wait output bit */
#define     als_u3smr2      u3smr2.bit.b3   /* SDA output stop bit */
#define     stc_u3smr2      u3smr2.bit.b4   /* UARTi initialize bit */
#define     swc2_u3smr2     u3smr2.bit.b5   /* SCL wait output bit2 */
#define     sdhi_u3smr2     u3smr2.bit.b6   /* SDA output inhibit bit */
#define     su1him_u3smr2   u3smr2.bit.b7   /* External clock synchronous enable bit */

/*------------------------------------------------------
     u4smr2
------------------------------------------------------*/
#define     u4smr2b      u4smr2.byte

#define     iicm2_u4smr2    u4smr2.bit.b0   /* IIC mode select bit2 */
#define     csc_u4smr2      u4smr2.bit.b1   /* Clock synchronous bit */
#define     swc_u4smr2      u4smr2.bit.b2   /* SCL wait output bit */
#define     als_u4smr2      u4smr2.bit.b3   /* SDA output stop bit */
#define     stc_u4smr2      u4smr2.bit.b4   /* UARTi initialize bit */
#define     swc2_u4smr2     u4smr2.bit.b5   /* SCL wait output bit2 */
#define     sdhi_u4smr2     u4smr2.bit.b6   /* SDA output inhibit bit */
#define     su1him_u4smr2   u4smr2.bit.b7   /* External clock synchronous enable bit */

/*------------------------------------------------------
    UARTi (i=0,1,2,3,4) special mode register 3
------------------------------------------------------*/

/*------------------------------------------------------
     u0smr3
------------------------------------------------------*/
#define     u0smr3b      u0smr3.byte

#define     sse_u0smr3  u0smr3.bit.b0   /* SS pin function enable bit */
#define     ckph_u0smr3 u0smr3.bit.b1   /* Clock-phase set bit */
#define     dinc_u0smr3 u0smr3.bit.b2   /* Serial input port set bit */
#define     nodc_u0smr3 u0smr3.bit.b3   /* Clock output select bit */
#define     err_u0smr3  u0smr3.bit.b4   /* Fault error flag */
#define     dl0_u0smr3  u0smr3.bit.b5   /* (b7-b5) SDAi digital delay time set bit */
#define     dl1_u0smr3  u0smr3.bit.b6
#define     dl2_u0smr3  u0smr3.bit.b7

/*------------------------------------------------------
     u1smr3
------------------------------------------------------*/
#define     u1smr3b      u1smr3.byte

#define     sse_u1smr3  u1smr3.bit.b0   /* SS pin function enable bit */
#define     ckph_u1smr3 u1smr3.bit.b1   /* Clock-phase set bit */
#define     dinc_u1smr3 u1smr3.bit.b2   /* Serial input port set bit */
#define     nodc_u1smr3 u1smr3.bit.b3   /* Clock output select bit */
#define     err_u1smr3  u1smr3.bit.b4   /* Fault error flag */
#define     dl0_u1smr3  u1smr3.bit.b5   /* (b7-b5) SDAi digital delay time set bit */
#define     dl1_u1smr3  u1smr3.bit.b6
#define     dl2_u1smr3  u1smr3.bit.b7

/*------------------------------------------------------
     u2smr3
------------------------------------------------------*/
#define     u2smr3b      u2smr3.byte

#define     sse_u2smr3  u2smr3.bit.b0   /* SS pin function enable bit */
#define     ckph_u2smr3 u2smr3.bit.b1   /* Clock-phase set bit */
#define     dinc_u2smr3 u2smr3.bit.b2   /* Serial input port set bit */
#define     nodc_u2smr3 u2smr3.bit.b3   /* Clock output select bit */
#define     err_u2smr3  u2smr3.bit.b4   /* Fault error flag */
#define     dl0_u2smr3  u2smr3.bit.b5   /* (b7-b5) SDAi digital delay time set bit */
#define     dl1_u2smr3  u2smr3.bit.b6
#define     dl2_u2smr3  u2smr3.bit.b7

/*------------------------------------------------------
     u3smr3
------------------------------------------------------*/
#define     u3smr3b      u3smr3.byte

#define     sse_u3smr3  u3smr3.bit.b0   /* SS pin function enable bit */
#define     ckph_u3smr3 u3smr3.bit.b1   /* Clock-phase set bit */
#define     dinc_u3smr3 u3smr3.bit.b2   /* Serial input port set bit */
#define     nodc_u3smr3 u3smr3.bit.b3   /* Clock output select bit */
#define     err_u3smr3  u3smr3.bit.b4   /* Fault error flag */
#define     dl0_u3smr3  u3smr3.bit.b5   /* (b7-b5) SDAi digital delay time set bit */
#define     dl1_u3smr3  u3smr3.bit.b6
#define     dl2_u3smr3  u3smr3.bit.b7

/*------------------------------------------------------
     u4smr3
------------------------------------------------------*/
#define     u4smr3b      u4smr3.byte

#define     sse_u4smr3  u4smr3.bit.b0   /* SS pin function enable bit */
#define     ckph_u4smr3 u4smr3.bit.b1   /* Clock-phase set bit */
#define     dinc_u4smr3 u4smr3.bit.b2   /* Serial input port set bit */
#define     nodc_u4smr3 u4smr3.bit.b3   /* Clock output select bit */
#define     err_u4smr3  u4smr3.bit.b4   /* Fault error flag */
#define     dl0_u4smr3  u4smr3.bit.b5   /* (b7-b5) SDAi digital delay time set bit */
#define     dl1_u4smr3  u4smr3.bit.b6
#define     dl2_u4smr3  u4smr3.bit.b7

/*------------------------------------------------------
    UARTi (i=0,1,2,3,4) special mode register 4
------------------------------------------------------*/

/*------------------------------------------------------
     u0smr4
------------------------------------------------------*/
#define     u0smr4b      u0smr4.byte

#define     stareq_u0smr4   u0smr4.bit.b0    /* Start condition generate bit */
#define     rstareq_u0smr4  u0smr4.bit.b1    /* Restart condition generate bit */
#define     stpreq_u0smr4   u0smr4.bit.b2    /* Stop condition generate bit */
#define     stspsel_u0smr4  u0smr4.bit.b3    /* SCL, SDA output select bit */
#define     ackd_u0smr4     u0smr4.bit.b4    /* ACK data bit */
#define     ackc_u0smr4     u0smr4.bit.b5    /* ACK data output enable bit */
#define     sclhi_u0smr4    u0smr4.bit.b6    /* SCL output stop enable bit */
#define     swc9_u0smr4     u0smr4.bit.b7    /* SCL wait output bit */


/*------------------------------------------------------
     u1smr4
------------------------------------------------------*/
#define     u1smr4b      u1smr4.byte

#define     stareq_u1smr4   u1smr4.bit.b0    /* Start condition generate bit */
#define     rstareq_u1smr4  u1smr4.bit.b1    /* Restart condition generate bit */
#define     stpreq_u1smr4   u1smr4.bit.b2    /* Stop condition generate bit */
#define     stspsel_u1smr4  u1smr4.bit.b3    /* SCL, SDA output select bit */
#define     ackd_u1smr4     u1smr4.bit.b4    /* ACK data bit */
#define     ackc_u1smr4     u1smr4.bit.b5    /* ACK data output enable bit */
#define     sclhi_u1smr4    u1smr4.bit.b6    /* SCL output stop enable bit */
#define     swc9_u1smr4     u1smr4.bit.b7    /* SCL wait output bit */


/*------------------------------------------------------
     u2smr4
------------------------------------------------------*/
#define     u2smr4b      u2smr4.byte

#define     stareq_u2smr4   u2smr4.bit.b0    /* Start condition generate bit */
#define     rstareq_u2smr4  u2smr4.bit.b1    /* Restart condition generate bit */
#define     stpreq_u2smr4   u2smr4.bit.b2    /* Stop condition generate bit */
#define     stspsel_u2smr4  u2smr4.bit.b3    /* SCL, SDA output select bit */
#define     ackd_u2smr4     u2smr4.bit.b4    /* ACK data bit */
#define     ackc_u2smr4     u2smr4.bit.b5    /* ACK data output enable bit */
#define     sclhi_u2smr4    u2smr4.bit.b6    /* SCL output stop enable bit */
#define     swc9_u2smr4     u2smr4.bit.b7    /* SCL wait output bit */


/*------------------------------------------------------
     u3smr4
------------------------------------------------------*/
#define     u3smr4b      u3smr4.byte

#define     stareq_u3smr4   u3smr4.bit.b0    /* Start condition generate bit */
#define     rstareq_u3smr4  u3smr4.bit.b1    /* Restart condition generate bit */
#define     stpreq_u3smr4   u3smr4.bit.b2    /* Stop condition generate bit */
#define     stspsel_u3smr4  u3smr4.bit.b3    /* SCL, SDA output select bit */
#define     ackd_u3smr4     u3smr4.bit.b4    /* ACK data bit */
#define     ackc_u3smr4     u3smr4.bit.b5    /* ACK data output enable bit */
#define     sclhi_u3smr4    u3smr4.bit.b6    /* SCL output stop enable bit */
#define     swc9_u3smr4     u3smr4.bit.b7    /* SCL wait output bit */

/*------------------------------------------------------
     u4smr4
------------------------------------------------------*/
#define     u4smr4b      u4smr4.byte

#define     stareq_u4smr4   u4smr4.bit.b0    /* Start condition generate bit */
#define     rstareq_u4smr4  u4smr4.bit.b1    /* Restart condition generate bit */
#define     stpreq_u4smr4   u4smr4.bit.b2    /* Stop condition generate bit */
#define     stspsel_u4smr4  u4smr4.bit.b3    /* SCL, SDA output select bit */
#define     ackd_u4smr4     u4smr4.bit.b4    /* ACK data bit */
#define     ackc_u4smr4     u4smr4.bit.b5    /* ACK data output enable bit */
#define     sclhi_u4smr4    u4smr4.bit.b6    /* SCL output stop enable bit */
#define     swc9_u4smr4     u4smr4.bit.b7    /* SCL wait output bit */

/*------------------------------------------------------
    DMAi request factor select register
------------------------------------------------------*/

/*------------------------------------------------------
     dm0sl
------------------------------------------------------*/
#define     dm0slb       dm0sl.byte

#define     dsel0_dm0sl dm0sl.bit.b0         /* DMA request cause select bit */
#define     dsel1_dm0sl dm0sl.bit.b1         /* DMA request cause select bit */
#define     dsel2_dm0sl dm0sl.bit.b2         /* DMA request cause select bit */
#define     dsel3_dm0sl dm0sl.bit.b3         /* DMA request cause select bit */
#define     dsel4_dm0sl dm0sl.bit.b4         /* DMA request cause select bit */
#define     dsr_dm0sl   dm0sl.bit.b5         /* Software DMA request bit */
#define     drq_dm0sl   dm0sl.bit.b7         /* DMA request bit */

/*------------------------------------------------------
     dm1sl
------------------------------------------------------*/
#define     dm1slb       dm1sl.byte

#define     dsel0_dm1sl dm1sl.bit.b0         /* DMA request cause select bit */
#define     dsel1_dm1sl dm1sl.bit.b1         /* DMA request cause select bit */
#define     dsel2_dm1sl dm1sl.bit.b2         /* DMA request cause select bit */
#define     dsel3_dm1sl dm1sl.bit.b3         /* DMA request cause select bit */
#define     dsel4_dm1sl dm1sl.bit.b4         /* DMA request cause select bit */
#define     dsr_dm1sl   dm1sl.bit.b5         /* Software DMA request bit */
#define     drq_dm1sl   dm1sl.bit.b7         /* DMA request bit */

/*------------------------------------------------------
     dm2sl
------------------------------------------------------*/
#define     dm2slb       dm2sl.byte

#define     dsel0_dm2sl dm2sl.bit.b0         /* DMA request cause select bit */
#define     dsel1_dm2sl dm2sl.bit.b1         /* DMA request cause select bit */
#define     dsel2_dm2sl dm2sl.bit.b2         /* DMA request cause select bit */
#define     dsel3_dm2sl dm2sl.bit.b3         /* DMA request cause select bit */
#define     dsel4_dm2sl dm2sl.bit.b4         /* DMA request cause select bit */
#define     dsr_dm2sl   dm2sl.bit.b5         /* Software DMA request bit */
#define     drq_dm2sl   dm2sl.bit.b7         /* DMA request bit */

/*------------------------------------------------------
     dm3sl
------------------------------------------------------*/
#define     dm3slb       dm3sl.byte

#define     dsel0_dm3sl dm3sl.bit.b0         /* DMA request cause select bit */
#define     dsel1_dm3sl dm3sl.bit.b1         /* DMA request cause select bit */
#define     dsel2_dm3sl dm3sl.bit.b2         /* DMA request cause select bit */
#define     dsel3_dm3sl dm3sl.bit.b3         /* DMA request cause select bit */
#define     dsel4_dm3sl dm3sl.bit.b4         /* DMA request cause select bit */
#define     dsr_dm3sl   dm3sl.bit.b5         /* Software DMA request bit */
#define     drq_dm3sl   dm3sl.bit.b7         /* DMA request bit */


/*-------------------------------------------------------
    CAN0/1 control register 0
-------------------------------------------------------*/
    struct can01_bit
	{
        char    reset0:1;           /* Reset0 */
        char    loopback:1;         /* Loop Back Mode */
        char    dummy0:1;
        char    basiccan:1;         /* Basic CAN Mode */
        char    reset1:1;           /* Reset1 */
        char    dummy1:3;
        char    tspre:2;            /* Time Stamp Prescaler */
        char    tsreset:1;          /* Time Stamp Reset */
        char    ecreset:1;          /* Error Counter Reset */
        char    dummy2:4;
    };
    
	struct can01_byte
	{
        char    low;                /* Low  8 bit */
        char    high;               /* High 8 bit */
    };
    
	union can01_cr0
	{
		struct can01_bit bit;
		struct can01_byte byte;
		unsigned short  word;
	};
	
	
#define     c0ctlr0w             c0ctlr0.word
#define     c0ctlr0l            c0ctlr0.byte.low
#define     c0ctlr0h            c0ctlr0.byte.high

#define     reset0_c0ctlr       c0ctlr0.bit.reset0       /* Reset 0 */
#define     loopback_c0ctlr     c0ctlr0.bit.loopback     /* Loop Back Mode */
#define     basiccan_c0ctlr     c0ctlr0.bit.basiccan     /* Basic CAN Mode */
#define     reset1_c0ctlr       c0ctlr0.bit.reset1       /* Reset 1 */
#define     tspre_c0ctlr        c0ctlr0.bit.tspre        /* Time Stamp Prescaler */
#define     tsreset_c0ctlr      c0ctlr0.bit.tsreset      /* Time Stamp Reset */
#define     ecreset_c0ctlr      c0ctlr0.bit.ecreset      /* Error Counter Reset */

#define     c1ctlr0w             c1ctlr0.word
#define     c1ctlr0l            c1ctlr0.byte.low
#define     c1ctlr0h            c1ctlr0.byte.high

#define     reset0_c1ctlr       c1ctlr0.bit.reset0       /* Reset 0 */
#define     loopback_c1ctlr     c1ctlr0.bit.loopback     /* Loop Back Mode */
#define     basiccan_c1ctlr     c1ctlr0.bit.basiccan     /* Basic CAN Mode */
#define     reset1_c1ctlr       c1ctlr0.bit.reset1       /* Reset 1 */
#define     tspre_c1ctlr        c1ctlr0.bit.tspre        /* Time Stamp Prescaler */
#define     tsreset_c1ctlr      c1ctlr0.bit.tsreset      /* Time Stamp Reset */
#define     ecreset_c1ctlr      c1ctlr0.bit.ecreset      /* Error Counter Reset */

	
/*-------------------------------------------------------
    CAN0/1 control register 1
-------------------------------------------------------*/
union can01_cr1
{
    struct{
        char    dummy0:3;
        char    banksel:1;
        char    dummy1:2;
        char    intsel:1;
        char    dummy2:1;
    }b;
    char    byte;
};

#define     c0ctlr1b     c0ctlr1.byte

#define     banksel_c0ctlr  c0ctlr1.b.banksel
#define     intsel_c0ctlr   c0ctlr1.b.intsel

#define     c1ctlr1b     c1ctlr1.byte

#define     banksel_c1ctlr  c1ctlr1.b.banksel
#define     intsel_c1ctlr   c1ctlr1.b.intsel


/*-------------------------------------------------------
    CAN0/1 sleep control register
-------------------------------------------------------*/
union can01_scr
{
    struct{
        char    sleep:1;
        char    dummy0:7;
    }b;
    char    byte;
};

#define     c0slprb      c0slpr.byte

#define     sleep_c0slpr    c0slpr.b.sleep

#define     c1slprb      c1slpr.byte

#define     sleep_c1slpr    c1slpr.b.sleep


/*------------------------------------------------------
    CAN0/1 status register
------------------------------------------------------*/
union can01_sr
{
    struct{
        char    mbox:4;             /* Message Slot Number */
        char    trmsucc:1;          /* Transmit Success */
        char    recsucc:1;          /* Receive Success */
        char    trmstate:1;         /* Transmit Status */
        char    recstate:1;         /* Receive Status */
        char    state_reset:1;      /* CAN Reset Status */
        char    state_loopback:1;   /* LoopBack Status */
        char    dummy0:1;
        char    state_basiccan:1;   /* BasicCAN Status */
        char    state_buserror:1;   /* CAN BusError */
        char    state_errpas:1;     /* Error Passive Status */
        char    state_busoff:1;     /* BusOff Status */
        char    dummy1:1;
    }b;
    struct{
        char    low;                /* Low  8 bit */
        char    high;               /* High 8 bit */
    }byte;
    unsigned short  word;
};

#define     c0strw                   c0str.word
#define     c0strl                  c0str.byte.low
#define     c0strh                  c0str.byte.high

#define     mbox_c0str              c0str.b.mbox               /* Message Slot Number */
#define     trmsucc_c0str           c0str.b.trmsucc            /* Transmit Success */
#define     recsucc_c0str           c0str.b.recsucc            /* Receive Success */
#define     trmstate_c0str          c0str.b.trmstate           /* Transmit Status */
#define     recstate_c0str          c0str.b.recstate           /* Receive Status */
#define     state_reset_c0str       c0str.b.state_reset        /* CAN Reset Status */
#define     state_loopback_c0str    c0str.b.state_loopback     /* LoopBack Status */
#define     state_basiccan_c0str    c0str.b.state_basiccan     /* BasicCAN Status */
#define     state_buserror_c0str    c0str.b.state_buserror     /* CAN BusError */
#define     state_errpas_c0str      c0str.b.state_errpas       /* Error Passive Status */
#define     state_busoff_c0str      c0str.b.state_busoff       /* BusOff Status */

#define     c1strw                   c1str.word
#define     c1strl                  c1str.byte.low
#define     c1strh                  c1str.byte.high

#define     mbox_c1str              c1str.b.mbox               /* Message Slot Number */
#define     trmsucc_c1str           c1str.b.trmsucc            /* Transmit Success */
#define     recsucc_c1str           c1str.b.recsucc            /* Receive Success */
#define     trmstate_c1str          c1str.b.trmstate           /* Transmit Status */
#define     recstate_c1str          c1str.b.recstate           /* Receive Status */
#define     state_reset_c1str       c1str.b.state_reset        /* CAN Reset Status */
#define     state_loopback_c1str    c1str.b.state_loopback     /* LoopBack Status */
#define     state_basiccan_c1str    c1str.b.state_basiccan     /* BasicCAN Status */
#define     state_buserror_c1str    c1str.b.state_buserror     /* CAN BusError */
#define     state_errpas_c1str      c1str.b.state_errpas       /* Error Passive Status */
#define     state_busoff_c1str      c1str.b.state_busoff       /* BusOff Status */

/*------------------------------------------------------
    CAN0/1 extended ID register
------------------------------------------------------*/
union can01_eir
{
    struct{
        char    ide15:1;           /* for Slot15 */
        char    ide14:1;           /* for Slot14 */
        char    ide13:1;           /* for Slot13 */
        char    ide12:1;           /* for Slot12 */
        char    ide11:1;           /* for Slot11 */
        char    ide10:1;           /* for Slot10 */
        char    ide9:1;            /* for Slot9 */
        char    ide8:1;            /* for Slot8 */
        char    ide7:1;            /* for Slot7 */
        char    ide6:1;            /* for Slot6 */
        char    ide5:1;            /* for Slot5 */
        char    ide4:1;            /* for Slot4 */
        char    ide3:1;            /* for Slot3 */
        char    ide2:1;            /* for Slot2 */
        char    ide1:1;            /* for Slot1 */
        char    ide0:1;            /* for Slot0 */
    }b;
    struct{
        char    low;                /* Low  8 bit */
        char    high;               /* High 8 bit */
    }byte;
    unsigned short  word;
};

#define     c0idrw           c0idr.word
#define     c0idrl          c0idr.byte.low
#define     c0idrh          c0idr.byte.high

#define     ide15_c0idr         c0idr.b.ide15         /* for Slot15 */
#define     ide14_c0idr         c0idr.b.ide14         /* for Slot14 */
#define     ide13_c0idr         c0idr.b.ide13         /* for Slot13 */
#define     ide12_c0idr         c0idr.b.ide12         /* for Slot12 */
#define     ide11_c0idr         c0idr.b.ide11         /* for Slot11 */
#define     ide10_c0idr         c0idr.b.ide10         /* for Slot10 */
#define     ide9_c0idr          c0idr.b.ide9          /* for Slot9 */
#define     ide8_c0idr          c0idr.b.ide8          /* for Slot8 */
#define     ide7_c0idr          c0idr.b.ide7          /* for Slot7 */
#define     ide6_c0idr          c0idr.b.ide6          /* for Slot6 */
#define     ide5_c0idr          c0idr.b.ide5          /* for Slot5 */
#define     ide4_c0idr          c0idr.b.ide4          /* for Slot4 */
#define     ide3_c0idr          c0idr.b.ide3          /* for Slot3 */
#define     ide2_c0idr          c0idr.b.ide2          /* for Slot2 */
#define     ide1_c0idr          c0idr.b.ide1          /* for Slot1 */
#define     ide0_c0idr          c0idr.b.ide0          /* for Slot0 */

#define     c1idrw           c1idr.word
#define     c1idrl          c1idr.byte.low
#define     c1idrh          c1idr.byte.high

#define     ide15_c1idr         c1idr.b.ide15         /* for Slot15 */
#define     ide14_c1idr         c1idr.b.ide14         /* for Slot14 */
#define     ide13_c1idr         c1idr.b.ide13         /* for Slot13 */
#define     ide12_c1idr         c1idr.b.ide12         /* for Slot12 */
#define     ide11_c1idr         c1idr.b.ide11         /* for Slot11 */
#define     ide10_c1idr         c1idr.b.ide10         /* for Slot10 */
#define     ide9_c1idr          c1idr.b.ide9          /* for Slot9 */
#define     ide8_c1idr          c1idr.b.ide8          /* for Slot8 */
#define     ide7_c1idr          c1idr.b.ide7          /* for Slot7 */
#define     ide6_c1idr          c1idr.b.ide6          /* for Slot6 */
#define     ide5_c1idr          c1idr.b.ide5          /* for Slot5 */
#define     ide4_c1idr          c1idr.b.ide4          /* for Slot4 */
#define     ide3_c1idr          c1idr.b.ide3          /* for Slot3 */
#define     ide2_c1idr          c1idr.b.ide2          /* for Slot2 */
#define     ide1_c1idr          c1idr.b.ide1          /* for Slot1 */
#define     ide0_c1idr          c1idr.b.ide0          /* for Slot0 */

/*------------------------------------------------------
    CAN0/1 configuration register
------------------------------------------------------*/
union can01_cr
{
    struct{
        char    dummy0:4;
        char    sam:1;              /* Sampling Time */
        char    pts:3;              /* Propagation Time Segment */
        char    pbs1:3;             /* Phase Buffer Segment 1 */
        char    pbs2:3;             /* Phase Buffer Segment 2 */
        char    sjw:2;              /* ReSynchronization Jump Width */
    }b;
    struct{
        char    low;                /* Low  8 bit */
        char    high;               /* High 8 bit */
    }byte;
    unsigned short  word;
};

#define     c0conrw          c0conr.word
#define     c0conrl         c0conr.byte.low
#define     c0conrh         c0conr.byte.high

#define     sam_c0conr      c0conr.b.sam       /* Sampling Time */
#define     pts_c0conr      c0conr.b.pts       /* PTS */
#define     pbs1_c0conr     c0conr.b.pbs1      /* PBS1 */
#define     pbs2_c0conr     c0conr.b.pbs2      /* PBS2 */
#define     sjw_c0conr      c0conr.b.sjw       /* SJW */

#define     c1conrw          c1conr.word
#define     c1conrl         c1conr.byte.low
#define     c1conrh         c1conr.byte.high

#define     sam_c1conr      c1conr.b.sam       /* Sampling Time */
#define     pts_c1conr      c1conr.b.pts       /* PTS */
#define     pbs1_c1conr     c1conr.b.pbs1      /* PBS1 */
#define     pbs2_c1conr     c1conr.b.pbs2      /* PBS2 */
#define     sjw_c1conr      c1conr.b.sjw       /* SJW */


/*------------------------------------------------------
    CAN0/1 time stamp register
------------------------------------------------------*/
union can01_stmpr
{
    struct{
        char    low;                /* Low  8 bit */
        char    high;               /* High 8 bit */
    }byte;
    unsigned short  word;
};

#define     c0tsrw           c0tsr.word
#define     c0tsrl          c0tsr.byte.low
#define     c0tsrh          c0tsr.byte.high

#define     c1tsrw           c1tsr.word
#define     c1tsrl          c1tsr.byte.low
#define     c1tsrh          c1tsr.byte.high

/*------------------------------------------------------
    CAN0/1 slot interrupt status register
------------------------------------------------------*/
union can01_sisr
{
    struct{
        char    sis15:1;            /* for Slot15 */
        char    sis14:1;            /* for Slot14 */
        char    sis13:1;            /* for Slot13 */
        char    sis12:1;            /* for Slot12 */
        char    sis11:1;            /* for Slot11 */
        char    sis10:1;            /* for Slot10 */
        char    sis9:1;             /* for Slot9 */
        char    sis8:1;             /* for Slot8 */
        char    sis7:1;             /* for Slot7 */
        char    sis6:1;             /* for Slot6 */
        char    sis5:1;             /* for Slot5 */
        char    sis4:1;             /* for Slot4 */
        char    sis3:1;             /* for Slot3 */
        char    sis2:1;             /* for Slot2 */
        char    sis1:1;             /* for Slot1 */
        char    sis0:1;             /* for Slot0 */
    }b;
    struct{
        char    low;                /* Low  8 bit */
        char    high;               /* High 8 bit */
    }byte;
    unsigned short  word;
};

#define     c0sistrw         c0sistr.word
#define     c0sistrl        c0sistr.byte.low
#define     c0sistrh        c0sistr.byte.high

#define     sis15_c0sistr   c0sistr.b.sis15       /* for Slot15 */
#define     sis14_c0sistr   c0sistr.b.sis14       /* for Slot14 */
#define     sis13_c0sistr   c0sistr.b.sis13       /* for Slot13 */
#define     sis12_c0sistr   c0sistr.b.sis12       /* for Slot12 */
#define     sis11_c0sistr   c0sistr.b.sis11       /* for Slot11 */
#define     sis10_c0sistr   c0sistr.b.sis10       /* for Slot10 */
#define     sis9_c0sistr    c0sistr.b.sis9        /* for Slot9 */
#define     sis8_c0sistr    c0sistr.b.sis8        /* for Slot8 */
#define     sis7_c0sistr    c0sistr.b.sis7        /* for Slot7 */
#define     sis6_c0sistr    c0sistr.b.sis6        /* for Slot6 */
#define     sis5_c0sistr    c0sistr.b.sis5        /* for Slot5 */
#define     sis4_c0sistr    c0sistr.b.sis4        /* for Slot4 */
#define     sis3_c0sistr    c0sistr.b.sis3        /* for Slot3 */
#define     sis2_c0sistr    c0sistr.b.sis2        /* for Slot2 */
#define     sis1_c0sistr    c0sistr.b.sis1        /* for Slot1 */
#define     sis0_c0sistr    c0sistr.b.sis0        /* for Slot0 */

#define     c1sistrw         c1sistr.word
#define     c1sistrl        c1sistr.byte.low
#define     c1sistrh        c1sistr.byte.high

#define     sis15_c1sistr   c1sistr.b.sis15       /* for Slot15 */
#define     sis14_c1sistr   c1sistr.b.sis14       /* for Slot14 */
#define     sis13_c1sistr   c1sistr.b.sis13       /* for Slot13 */
#define     sis12_c1sistr   c1sistr.b.sis12       /* for Slot12 */
#define     sis11_c1sistr   c1sistr.b.sis11       /* for Slot11 */
#define     sis10_c1sistr   c1sistr.b.sis10       /* for Slot10 */
#define     sis9_c1sistr    c1sistr.b.sis9        /* for Slot9 */
#define     sis8_c1sistr    c1sistr.b.sis8        /* for Slot8 */
#define     sis7_c1sistr    c1sistr.b.sis7        /* for Slot7 */
#define     sis6_c1sistr    c1sistr.b.sis6        /* for Slot6 */
#define     sis5_c1sistr    c1sistr.b.sis5        /* for Slot5 */
#define     sis4_c1sistr    c1sistr.b.sis4        /* for Slot4 */
#define     sis3_c1sistr    c1sistr.b.sis3        /* for Slot3 */
#define     sis2_c1sistr    c1sistr.b.sis2        /* for Slot2 */
#define     sis1_c1sistr    c1sistr.b.sis1        /* for Slot1 */
#define     sis0_c1sistr    c1sistr.b.sis0        /* for Slot0 */

/*------------------------------------------------------
    CAN0/1 slot interrupt mask register
------------------------------------------------------*/
union can01_simr
{
    struct{
        char    sim15:1;            /* for Slot15 */
        char    sim14:1;            /* for Slot14 */
        char    sim13:1;            /* for Slot13 */
        char    sim12:1;            /* for Slot12 */
        char    sim11:1;            /* for Slot11 */
        char    sim10:1;            /* for Slot10 */
        char    sim9:1;             /* for Slot9 */
        char    sim8:1;             /* for Slot8 */
        char    sim7:1;             /* for Slot7 */
        char    sim6:1;             /* for Slot6 */
        char    sim5:1;             /* for Slot5 */
        char    sim4:1;             /* for Slot4 */
        char    sim3:1;             /* for Slot3 */
        char    sim2:1;             /* for Slot2 */
        char    sim1:1;             /* for Slot1 */
        char    sim0:1;             /* for Slot0 */
    }b;
    struct{
        char    low;                /* Low  8 bit */
        char    high;               /* High 8 bit */
    }byte;
    unsigned short  word;
};

#define     c0simkrw         c0simkr.word
#define     c0simkrl        c0simkr.byte.low
#define     c0simkrh        c0simkr.byte.high

#define     sim15_c0simkr   c0simkr.b.sim15       /* for Slot15 */
#define     sim14_c0simkr   c0simkr.b.sim14       /* for Slot14 */
#define     sim13_c0simkr   c0simkr.b.sim13       /* for Slot13 */
#define     sim12_c0simkr   c0simkr.b.sim12       /* for Slot12 */
#define     sim11_c0simkr   c0simkr.b.sim11       /* for Slot11 */
#define     sim10_c0simkr   c0simkr.b.sim10       /* for Slot10 */
#define     sim9_c0simkr    c0simkr.b.sim9        /* for Slot9 */
#define     sim8_c0simkr    c0simkr.b.sim8        /* for Slot8 */
#define     sim7_c0simkr    c0simkr.b.sim7        /* for Slot7 */
#define     sim6_c0simkr    c0simkr.b.sim6        /* for Slot6 */
#define     sim5_c0simkr    c0simkr.b.sim5        /* for Slot5 */
#define     sim4_c0simkr    c0simkr.b.sim4        /* for Slot4 */
#define     sim3_c0simkr    c0simkr.b.sim3        /* for Slot3 */
#define     sim2_c0simkr    c0simkr.b.sim2        /* for Slot2 */
#define     sim1_c0simkr    c0simkr.b.sim1        /* for Slot1 */
#define     sim0_c0simkr    c0simkr.b.sim0        /* for Slot0 */

#define     c1simkrw         c1simkr.word
#define     c1simkrl        c1simkr.byte.low
#define     c1simkrh        c1simkr.byte.high

#define     sim15_c1simkr   c1simkr.b.sim15       /* for Slot15 */
#define     sim14_c1simkr   c1simkr.b.sim14       /* for Slot14 */
#define     sim13_c1simkr   c1simkr.b.sim13       /* for Slot13 */
#define     sim12_c1simkr   c1simkr.b.sim12       /* for Slot12 */
#define     sim11_c1simkr   c1simkr.b.sim11       /* for Slot11 */
#define     sim10_c1simkr   c1simkr.b.sim10       /* for Slot10 */
#define     sim9_c1simkr    c1simkr.b.sim9        /* for Slot9 */
#define     sim8_c1simkr    c1simkr.b.sim8        /* for Slot8 */
#define     sim7_c1simkr    c1simkr.b.sim7        /* for Slot7 */
#define     sim6_c1simkr    c1simkr.b.sim6        /* for Slot6 */
#define     sim5_c1simkr    c1simkr.b.sim5        /* for Slot5 */
#define     sim4_c1simkr    c1simkr.b.sim4        /* for Slot4 */
#define     sim3_c1simkr    c1simkr.b.sim3        /* for Slot3 */
#define     sim2_c1simkr    c1simkr.b.sim2        /* for Slot2 */
#define     sim1_c1simkr    c1simkr.b.sim1        /* for Slot1 */
#define     sim0_c1simkr    c1simkr.b.sim0        /* for Slot0 */

/*------------------------------------------------------
     CAN0/1 error interrupt status register
------------------------------------------------------*/
union can01_eisr
{
    struct{
        char    boim:1;         /* BusOff Interrupt */
        char    epim:1;         /* Error Passive Interrupt */
        char    beim:1;         /* CAN BusError Interrupt */
        char    dummy0:5;
    }b;
    char    byte;
};

#define     c0eimkrb     c0eimkr.byte

#define     boim_c0eimkr    c0eimkr.b.boim     /* BusOff Interrupt Status */
#define     epim_c0eimkr    c0eimkr.b.epim     /* Error Passive Interrupt Status */
#define     beim_c0eimkr    c0eimkr.b.beim     /* CAN BusError Interrupt Status */

#define     c1eimkrb     c1eimkr.byte

#define     boim_c1eimkr    c1eimkr.b.boim     /* BusOff Interrupt Status */
#define     epim_c1eimkr    c1eimkr.b.epim     /* Error Passive Interrupt Status */
#define     beim_c1eimkr    c1eimkr.b.beim     /* CAN BusError Interrupt Status */

/*------------------------------------------------------
     CAN0/1 error interrupt mask register
------------------------------------------------------*/
union can01_eimr
{
    struct{
        char    bois:1;         /* BusOff Interrupt */
        char    epis:1;         /* Error Passive Interrupt */
        char    beis:1;         /* CAN BusError Interrupt */
        char    rsv4:1;
        char    rsv3:1;
        char    rsv2:1;
        char    rsv1:1;
        char    rsv0:1;
    }b;
    char    byte;
};

#define     c0eistrb     c0eistr.byte

#define     bois_c0eistr    c0eistr.b.bois     /* BusOff Interrupt Mask */
#define     epis_c0eistr    c0eistr.b.epis     /* Error Passive Interrupt Mask */
#define     beis_c0eistr    c0eistr.b.beis     /* CAN BusError Interrupt Mask */

#define     c1eistrb     c1eistr.byte

#define     bois_c1eistr    c1eistr.b.bois     /* BusOff Interrupt Mask */
#define     epis_c1eistr    c1eistr.b.epis     /* Error Passive Interrupt Mask */
#define     beis_c1eistr    c1eistr.b.beis     /* CAN BusError Interrupt Mask */

/*-------------------------------------------------------
    CAN0/1 error factor register
-------------------------------------------------------*/
union can01_efr
{
    struct{
        char    acke:1;
        char    crce:1;
        char    forme:1;
        char    stfe:1;
        char    bite0:1;
        char    bite1:1;
        char    rcve:1;
        char    tre:1;
    }b;
    char    byte;
};

#define     c0efrb      c0efr.byte

#define     acke_c0efr    c0efr.b.acke
#define     crce_c0efr    c0efr.b.crce
#define     forme_c0efr   c0efr.b.forme
#define     stfe_c0efr    c0efr.b.stfe
#define     bite0_c0efr   c0efr.b.bite0
#define     bite1_c0efr   c0efr.b.bite1
#define     rcve_c0efr    c0efr.b.rcve
#define     tre_c0efr     c0efr.b.tre

#define     c1efrb      c1efr.byte

#define     acke_c1efr    c1efr.b.acke
#define     crce_c1efr    c1efr.b.crce
#define     forme_c1efr   c1efr.b.forme
#define     stfe_c1efr    c1efr.b.stfe
#define     bite0_c1efr   c1efr.b.bite0
#define     bite1_c1efr   c1efr.b.bite1
#define     rcve_c1efr    c1efr.b.rcve
#define     tre_c1efr     c1efr.b.tre

/*-------------------------------------------------------
    CAN0/1 mode register
-------------------------------------------------------*/
union can01_mr
{
    struct{
        char    cmod:2;
        char    dummy0:6;
    }b;
    char    byte;
};

#define     c0mdrb      c0mdr.byte

#define     cmod_c0mdr    c0mdr.b.cmod

#define     c1mdrb      c1mdr.byte

#define     cmod_c1mdr    c1mdr.b.cmod

/*------------------------------------------------------
    CAN0/1 single shot control register
------------------------------------------------------*/
union can01_sscr
{
    struct{
        char    ssc15:1;            /* for Slot15 */
        char    ssc14:1;            /* for Slot14 */
        char    ssc13:1;            /* for Slot13 */
        char    ssc12:1;            /* for Slot12 */
        char    ssc11:1;            /* for Slot11 */
        char    ssc10:1;            /* for Slot10 */
        char    ssc9:1;             /* for Slot9 */
        char    ssc8:1;             /* for Slot8 */
        char    ssc7:1;             /* for Slot7 */
        char    ssc6:1;             /* for Slot6 */
        char    ssc5:1;             /* for Slot5 */
        char    ssc4:1;             /* for Slot4 */
        char    ssc3:1;             /* for Slot3 */
        char    ssc2:1;             /* for Slot2 */
        char    ssc1:1;             /* for Slot1 */
        char    ssc0:1;             /* for Slot0 */
    }b;
    struct{
        char    low;                /* Low  8 bit */
        char    high;               /* High 8 bit */
    }byte;
    unsigned short  word;
};


#define     c0ssctlrw         c0ssctlr.word
#define     c0ssctlrl        c0ssctlr.byte.low
#define     c0ssctlrh        c0ssctlr.byte.high

#define     ssc15_c0ssctlr   c0ssctlr.b.ssc15       /* for Slot15 */
#define     ssc14_c0ssctlr   c0ssctlr.b.ssc14       /* for Slot14 */
#define     ssc13_c0ssctlr   c0ssctlr.b.ssc13       /* for Slot13 */
#define     ssc12_c0ssctlr   c0ssctlr.b.ssc12       /* for Slot12 */
#define     ssc11_c0ssctlr   c0ssctlr.b.ssc11       /* for Slot11 */
#define     ssc10_c0ssctlr   c0ssctlr.b.ssc10       /* for Slot10 */
#define     ssc9_c0ssctlr    c0ssctlr.b.ssc9        /* for Slot9 */
#define     ssc8_c0ssctlr    c0ssctlr.b.ssc8        /* for Slot8 */
#define     ssc7_c0ssctlr    c0ssctlr.b.ssc7        /* for Slot7 */
#define     ssc6_c0ssctlr    c0ssctlr.b.ssc6        /* for Slot6 */
#define     ssc5_c0ssctlr    c0ssctlr.b.ssc5        /* for Slot5 */
#define     ssc4_c0ssctlr    c0ssctlr.b.ssc4        /* for Slot4 */
#define     ssc3_c0ssctlr    c0ssctlr.b.ssc3        /* for Slot3 */
#define     ssc2_c0ssctlr    c0ssctlr.b.ssc2        /* for Slot2 */
#define     ssc1_c0ssctlr    c0ssctlr.b.ssc1        /* for Slot1 */
#define     ssc0_c0ssctlr    c0ssctlr.b.ssc0        /* for Slot0 */

#define     c1ssctlrw         c1ssctlr.word
#define     c1ssctlrl        c1ssctlr.byte.low
#define     c1ssctlrh        c1ssctlr.byte.high

#define     ssc15_c1ssctlr   c1ssctlr.b.ssc15       /* for Slot15 */
#define     ssc14_c1ssctlr   c1ssctlr.b.ssc14       /* for Slot14 */
#define     ssc13_c1ssctlr   c1ssctlr.b.ssc13       /* for Slot13 */
#define     ssc12_c1ssctlr   c1ssctlr.b.ssc12       /* for Slot12 */
#define     ssc11_c1ssctlr   c1ssctlr.b.ssc11       /* for Slot11 */
#define     ssc10_c1ssctlr   c1ssctlr.b.ssc10       /* for Slot10 */
#define     ssc9_c1ssctlr    c1ssctlr.b.ssc9        /* for Slot9 */
#define     ssc8_c1ssctlr    c1ssctlr.b.ssc8        /* for Slot8 */
#define     ssc7_c1ssctlr    c1ssctlr.b.ssc7        /* for Slot7 */
#define     ssc6_c1ssctlr    c1ssctlr.b.ssc6        /* for Slot6 */
#define     ssc5_c1ssctlr    c1ssctlr.b.ssc5        /* for Slot5 */
#define     ssc4_c1ssctlr    c1ssctlr.b.ssc4        /* for Slot4 */
#define     ssc3_c1ssctlr    c1ssctlr.b.ssc3        /* for Slot3 */
#define     ssc2_c1ssctlr    c1ssctlr.b.ssc2        /* for Slot2 */
#define     ssc1_c1ssctlr    c1ssctlr.b.ssc1        /* for Slot1 */
#define     ssc0_c1ssctlr    c1ssctlr.b.ssc0        /* for Slot0 */

/*------------------------------------------------------
    CAN0/1 single shot status register
------------------------------------------------------*/
union can01_sssr
{
    struct{
        char    sss15:1;            /* for Slot15 */
        char    sss14:1;            /* for Slot14 */
        char    sss13:1;            /* for Slot13 */
        char    sss12:1;            /* for Slot12 */
        char    sss11:1;            /* for Slot11 */
        char    sss10:1;            /* for Slot10 */
        char    sss9:1;             /* for Slot9 */
        char    sss8:1;             /* for Slot8 */
        char    sss7:1;             /* for Slot7 */
        char    sss6:1;             /* for Slot6 */
        char    sss5:1;             /* for Slot5 */
        char    sss4:1;             /* for Slot4 */
        char    sss3:1;             /* for Slot3 */
        char    sss2:1;             /* for Slot2 */
        char    sss1:1;             /* for Slot1 */
        char    sss0:1;             /* for Slot0 */
    }b;
    struct{
        char    low;                /* Low  8 bit */
        char    high;               /* High 8 bit */
    }byte;
    unsigned short  word;
};

#define     c0ssstrw         c0ssstr.word
#define     c0ssstrl        c0ssstr.byte.low
#define     c0ssstrh        c0ssstr.byte.high

#define     sss15_c0ssstr   c0ssstr.b.sss15       /* for Slot15 */
#define     sss14_c0ssstr   c0ssstr.b.sss14       /* for Slot14 */
#define     sss13_c0ssstr   c0ssstr.b.sss13       /* for Slot13 */
#define     sss12_c0ssstr   c0ssstr.b.sss12       /* for Slot12 */
#define     sss11_c0ssstr   c0ssstr.b.sss11       /* for Slot11 */
#define     sss10_c0ssstr   c0ssstr.b.sss10       /* for Slot10 */
#define     sss9_c0ssstr    c0ssstr.b.sss9        /* for Slot9 */
#define     sss8_c0ssstr    c0ssstr.b.sss8        /* for Slot8 */
#define     sss7_c0ssstr    c0ssstr.b.sss7        /* for Slot7 */
#define     sss6_c0ssstr    c0ssstr.b.sss6        /* for Slot6 */
#define     sss5_c0ssstr    c0ssstr.b.sss5        /* for Slot5 */
#define     sss4_c0ssstr    c0ssstr.b.sss4        /* for Slot4 */
#define     sss3_c0ssstr    c0ssstr.b.sss3        /* for Slot3 */
#define     sss2_c0ssstr    c0ssstr.b.sss2        /* for Slot2 */
#define     sss1_c0ssstr    c0ssstr.b.sss1        /* for Slot1 */
#define     sss0_c0ssstr    c0ssstr.b.sss0        /* for Slot0 */

#define     c1ssstrw         c1ssstr.word
#define     c1ssstrl        c1ssstr.byte.low
#define     c1ssstrh        c1ssstr.byte.high

#define     sss15_c1ssstr   c1ssstr.b.sss15       /* for Slot15 */
#define     sss14_c1ssstr   c1ssstr.b.sss14       /* for Slot14 */
#define     sss13_c1ssstr   c1ssstr.b.sss13       /* for Slot13 */
#define     sss12_c1ssstr   c1ssstr.b.sss12       /* for Slot12 */
#define     sss11_c1ssstr   c1ssstr.b.sss11       /* for Slot11 */
#define     sss10_c1ssstr   c1ssstr.b.sss10       /* for Slot10 */
#define     sss9_c1ssstr    c1ssstr.b.sss9        /* for Slot9 */
#define     sss8_c1ssstr    c1ssstr.b.sss8        /* for Slot8 */
#define     sss7_c1ssstr    c1ssstr.b.sss7        /* for Slot7 */
#define     sss6_c1ssstr    c1ssstr.b.sss6        /* for Slot6 */
#define     sss5_c1ssstr    c1ssstr.b.sss5        /* for Slot5 */
#define     sss4_c1ssstr    c1ssstr.b.sss4        /* for Slot4 */
#define     sss3_c1ssstr    c1ssstr.b.sss3        /* for Slot3 */
#define     sss2_c1ssstr    c1ssstr.b.sss2        /* for Slot2 */
#define     sss1_c1ssstr    c1ssstr.b.sss1        /* for Slot1 */
#define     sss0_c1ssstr    c1ssstr.b.sss0        /* for Slot0 */

/*-------------------------------------------------------
    CAN0/1 global mask register
    CAN0/1 local mask A register
    CAN0/1 local mask B register
-------------------------------------------------------*/

union can01_glmr
{
    struct{
        char    sidh;                   /* Standard-ID register [10:6] */
        char    sidl;                   /* Standard-ID register [5:0] */
        char    eidh;                   /* Extended-ID register [17:14] */
        char    eidm;                   /* Extended-ID register [13:6] */
        char    eidl;                   /* Extended-ID register [5:0] */
    } ba;
    char byte[5];
};

/*-------------------------------------------------------
     CAN0/1 message slot(0-15) control register
-------------------------------------------------------*/
union can01_mscr
{
    struct{
        char    newdata:1;      /* New Data */
        char    invaldata:1;    /* Invalid Data */
        char    msglost:1;      /* Message Lost */
        char    remactive:1;    /* Remote Active */
        char    rsplock:1;      /* Response Locked */
        char    remote:1;       /* Remote Mailbox */
        char    recreq:1;       /* Receive Request */
        char    dummy0:1;             /* Reserved bit */
    }receive;
    struct{
        char    sentdata:1;     /* Sent Data */
        char    trmactive:1;    /* Transmission Active */
        char    dummy0:1;             /* Reserved bit */
        char    remactive:1;    /* Remote Active */
        char    dummy1:1;             /* Reserved bit */
        char    remote:1;       /* Remote Mailbox */
        char    dummy2:1;             /* Reserved bit */
        char    trmreq:1;       /* Transmit Request */
    }transmit;
    char byte;
};

/*-------------------------------------------------------
    CAN0/1 slot buffer select register
-------------------------------------------------------*/
union can01_sbsr{
    struct{
        char    buffer0:4;
        char    buffer1:4;
    }b;
    char    byte;
};

#define     c0sbsb       c0sbs.byte

#define     buffer0_c0sbs   c0sbs.b.buffer0    /* CAN0 message slot buffer 0 */
#define     buffer1_c0sbs   c0sbs.b.buffer1    /* CAN0 message slot buffer 1 */

#define     c1sbsb       c1sbs.byte

#define     buffer0_c1sbs   c1sbs.b.buffer0    /* CAN1 message slot buffer 0 */
#define     buffer1_c1sbs   c1sbs.b.buffer1    /* CAN1 message slot buffer 1 */

/*------------------------------------------------------
    CAN0/1 message slot buffer
------------------------------------------------------*/
union can01_msb
{
    struct{
        char    sidh;                   /* Standard-ID register [10:6] */
        char    sidl;                   /* Standard-ID register [5:0] */
        char    eidh;                   /* Extended-ID register [17:14] */
        char    eidm;                   /* Extended-ID register [13:6] */
        char    eidl;                   /* Extended-ID register [5:0] */
        char    dlc;                    /* Data length code */
        char    data[8];                /* Data(8byte) */
        char    tsh;                    /* Time stamp register(High) */
        char    tsl;                    /* Time stamp register(Low) */
    } ba;
    char byte[16];
    short word[8];
};

/*-------------------------------------------------------
     CAN0/1 acceptance filter support register
-------------------------------------------------------*/
union can01_afsr
{
    struct{
        char    low;            /* Low  8 bit */
        char    high;           /* High 8 bit */
    }byte;
    unsigned short  word;
};

#define     c0afsw           c0afs.word
#define     c0afsl          c0afs.byte.low
#define     c0afsh          c0afs.byte.high

#define     c1afsw           c1afs.word
#define     c1afsl          c1afs.byte.low
#define     c1afsh          c1afs.byte.high


/********************************************************
*   declare SFR union                                   *
********************************************************/
struct bit_def {
        char    b0:1;
        char    b1:1;
        char    b2:1;
        char    b3:1;
        char    b4:1;
        char    b5:1;
        char    b6:1;
        char    b7:1;
};
union byte_def{
    struct bit_def bit;
    char    byte;
};


union rmadi_def{
    struct{
        char    b0:1;
        char    b1:1;
        char    b2:1;
        char    b3:1;
        char    b4:1;
        char    b5:1;
        char    b6:1;
        char    b7:1;
        char    b8:1;
        char    b9:1;
        char    b10:1;
        char    b11:1;
        char    b12:1;
        char    b13:1;
        char    b14:1;
        char    b15:1;
        char    b16:1;
        char    b17:1;
        char    b18:1;
        char    b19:1;
    }bit;
    struct{
        char    low;                /* low  8 bit */
        char    mid;                /* mid  8 bit */
        char    high;               /* high 8 bit */
        char    nc;                 /* non use */
    }byte;
    unsigned long   dword;
};

#define     rmad0w   rmad0.dword        /* Address match interrupt register 0 32 bit */
#define     rmad0l  rmad0.byte.low         /* Address match interrupt register 0 low  8 bit */
#define     rmad0m  rmad0.byte.mid         /* Address match interrupt register 0 mid  8 bit */
#define     rmad0h  rmad0.byte.high        /* Address match interrupt register 0 high 8 bit */
#define     rmad1w   rmad1.dword        /* Address match interrupt register 1 32 bit */
#define     rmad1l  rmad1.byte.low         /* Address match interrupt register 1 low  8 bit */
#define     rmad1m  rmad1.byte.mid         /* Address match interrupt register 1 mid  8 bit */
#define     rmad1h  rmad1.byte.high        /* Address match interrupt register 1 high 8 bit */
#define     rmad2w   rmad2.dword        /* Address match interrupt register 2 32 bit */
#define     rmad2l  rmad2.byte.low         /* Address match interrupt register 2 low  8 bit */
#define     rmad2m  rmad2.byte.mid         /* Address match interrupt register 2 mid  8 bit */
#define     rmad2h  rmad2.byte.high        /* Address match interrupt register 2 high 8 bit */
#define     rmad3w   rmad3.dword        /* Address match interrupt register 3 32 bit */
#define     rmad3l  rmad3.byte.low         /* Address match interrupt register 3 low  8 bit */
#define     rmad3m  rmad3.byte.mid         /* Address match interrupt register 3 mid  8 bit */
#define     rmad3h  rmad3.byte.high        /* Address match interrupt register 3 high 8 bit */
#define     rmad4w   rmad4.dword        /* Address match interrupt register 4 32 bit */
#define     rmad4l  rmad4.byte.low         /* Address match interrupt register 3 low  8 bit */
#define     rmad4m  rmad4.byte.mid         /* Address match interrupt register 3 mid  8 bit */
#define     rmad4h  rmad4.byte.high        /* Address match interrupt register 3 high 8 bit */
#define     rmad5w  rmad5.dword        /* Address match interrupt register 5 32 bit */
#define     rmad5l  rmad5.byte.low         /* Address match interrupt register 3 low  8 bit */
#define     rmad5m  rmad5.byte.mid         /* Address match interrupt register 3 mid  8 bit */
#define     rmad5h  rmad5.byte.high        /* Address match interrupt register 3 high 8 bit */
#define     rmad6w   rmad6.dword        /* Address match interrupt register 6 32 bit */
#define     rmad6l  rmad6.byte.low         /* Address match interrupt register 3 low  8 bit */
#define     rmad6m  rmad6.byte.mid         /* Address match interrupt register 3 mid  8 bit */
#define     rmad6h  rmad6.byte.high        /* Address match interrupt register 3 high 8 bit */
#define     rmad7w   rmad7.dword        /* Address match interrupt register 7 32 bit */
#define     rmad7l  rmad7.byte.low         /* Address match interrupt register 3 low  8 bit */
#define     rmad7m  rmad7.byte.mid         /* Address match interrupt register 3 mid  8 bit */
#define     rmad7h  rmad7.byte.high        /* Address match interrupt register 3 high 8 bit */


union uarti_reg_def{
    struct{
        char    b0:1;
        char    b1:1;
        char    b2:1;
        char    b3:1;
        char    b4:1;
        char    b5:1;
        char    b6:1;
        char    b7:1;
        char    b8:1;
        char    b9:1;
        char    b10:1;
        char    b11:1;
        char    b12:1;
        char    b13:1;
        char    b14:1;
        char    b15:1;
    }bit;
    struct{
        char    low;                /* low  8 bit */
        char    high;               /* high 8 bit */
    }byte;
    unsigned short  word;
};

#define     u0tbw    u0tb.word          /* UART0 Transmit buffer register 16 bit */
#define     u0tbl   u0tb.byte.low          /* UART0 Transmit buffer register low  8 bit */
#define     u0tbh   u0tb.byte.high         /* UART0 Transmit buffer register high 8 bit */
#define     u1tbw    u1tb.word          /* UART1 Transmit buffer register 16 bit */
#define     u1tbl   u1tb.byte.low          /* UART1 Transmit buffer register low  8 bit */
#define     u1tbh   u1tb.byte.high         /* UART1 Transmit buffer register high 8 bit */
#define     u2tbw    u2tb.word          /* UART2 Transmit buffer register 16 bit */
#define     u2tbl   u2tb.byte.low          /* UART2 Transmit buffer register low  8 bit */
#define     u2tbh   u2tb.byte.high         /* UART2 Transmit buffer register high 8 bit */
#define     u3tbw    u3tb.word          /* UART3 Transmit buffer register 16 bit */
#define     u3tbl   u3tb.byte.low          /* UART3 Transmit buffer register low  8 bit */
#define     u3tbh   u3tb.byte.high         /* UART3 Transmit buffer register high 8 bit */
#define     u4tbw    u4tb.word          /* UART4 Transmit buffer register 16 bit */
#define     u4tbl   u4tb.byte.low          /* UART4 Transmit buffer register low  8 bit */
#define     u4tbh   u4tb.byte.high         /* UART4 Transmit buffer register high 8 bit */
#define     u5tbw    u5tb.word          /* UART5 Transmit buffer register 16 bit */
#define     u5tbl   u5tb.byte.low          /* UART5 Transmit buffer register low  8 bit */
#define     u5tbh   u5tb.byte.high         /* UART5 Transmit buffer register high 8 bit */
#define     u6tbw    u6tb.word          /* UART6 Transmit buffer register 16 bit */
#define     u6tbl   u6tb.byte.low          /* UART6 Transmit buffer register low  8 bit */
#define     u6tbh   u6tb.byte.high         /* UART6 Transmit buffer register high 8 bit */

/*------------------------------------------------------
    CRC data register
------------------------------------------------------*/
#define     crcdw    crcd.word          /* CRC data register 16 bit */
#define     crcdl   crcd.byte.low          /* CRC data register low  8 bit */
#define     crcdh   crcd.byte.high         /* CRC data register high 8 bit */

/*------------------------------------------------------
    A/D0 register i (i=0 to7)
------------------------------------------------------*/
#define     ad00w    ad00.word           /* A/D0 register 0 16 bit */
#define     ad00l    ad00.byte.low           /* A/D0 register 0 low  8 bit */
#define     ad00h    ad00.byte.high          /* A/D0 register 0 high 8 bit */
#define     ad01w    ad01.word           /* A/D0 register 1 16 bit */
#define     ad01l    ad01.byte.low           /* A/D0 register 1 low  8 bit */
#define     ad01h    ad01.byte.high          /* A/D0 register 1 high 8 bit */
#define     ad02w    ad02.word           /* A/D0 register 2 16 bit */
#define     ad02l    ad02.byte.low           /* A/D0 register 2 low  8 bit */
#define     ad02h    ad02.byte.high          /* A/D0 register 2 high 8 bit */
#define     ad03w    ad03.word           /* A/D0 register 3 16 bit */
#define     ad03l    ad03.byte.low           /* A/D0 register 3 low  8 bit */
#define     ad03h    ad03.byte.high          /* A/D0 register 3 high 8 bit */
#define     ad04w    ad04.word           /* A/D0 register 4 16 bit */
#define     ad04l    ad04.byte.low           /* A/D0 register 4 low  8 bit */
#define     ad04h    ad04.byte.high          /* A/D0 register 4 high 8 bit */
#define     ad05w    ad05.word           /* A/D0 register 5 16 bit */
#define     ad05l    ad05.byte.low           /* A/D0 register 5 low  8 bit */
#define     ad05h    ad05.byte.high          /* A/D0 register 5 high 8 bit */
#define     ad06w    ad06.word           /* A/D0 register 6 16 bit */
#define     ad06l    ad06.byte.low           /* A/D0 register 6 low  8 bit */
#define     ad06h    ad06.byte.high          /* A/D0 register 6 high 8 bit */
#define     ad07w    ad07.word           /* A/D0 register 7 16 bit */
#define     ad07l    ad07.byte.low           /* A/D0 register 7 low  8 bit */
#define     ad07h    ad07.byte.high          /* A/D0 register 7 high 8 bit */


#define     x0rw     x0r.word       /* X-Y Conversion */
#define     x0rl    x0r.byte.low
#define     x0rh    x0r.byte.high
#define     y0rw     y0r.word
#define     y0rl    y0r.byte.low
#define     y0rh    y0r.byte.high
#define     x1rw     x1r.word
#define     x1rl    x1r.byte.low
#define     x1rh    x1r.byte.high
#define     y1rw    y1r.word
#define     y1rl    y1r.byte.low
#define     y1rh    y1r.byte.high
#define     x2rw    x2r.byte.low
#define     x2rh    x2r.byte.high
#define     y2rw     y2r.word
#define     y2rl    y2r.byte.low
#define     y2rh    y2r.byte.high
#define     x3rw     x3r.word
#define     x3rl    x3r.byte.low
#define     x3rh    x3r.byte.high
#define     y3rw     y3r.word
#define     y3rl    y3r.byte.low
#define     y3rh    y3r.byte.high
#define     x4rw     x4r.word
#define     x4rl    x4r.byte.low
#define     x4rh    x4r.byte.high
#define     y4rw     y4r.word
#define     y4rl    y4r.byte.low
#define     y4rh    y4r.byte.high
#define     x5rw     x5r.word
#define     x5rl    x5r.byte.low
#define     x5rh    x5r.byte.high
#define     y5rw     y5r.word
#define     y5rl    y5r.byte.low
#define     y5rh    y5r.byte.high
#define     x6rw     x6r.word
#define     x6rl    x6r.byte.low
#define     x6rh    x6r.byte.high
#define     y6rw     y6r.word
#define     y6rl    y6r.byte.low
#define     y6rh    y6r.byte.high
#define     x7rw     x7r.word
#define     x7rl    x7r.byte.low
#define     x7rh    x7r.byte.high
#define     y7rw     y7r.word
#define     y7rl    y7r.byte.low
#define     y7rh    y7r.byte.high
#define     x8rw     x8r.word
#define     x8rl    x8r.byte.low
#define     x8rh    x8r.byte.high
#define     y8rw     y8r.word
#define     y8rl    y8r.byte.low
#define     y8rh    y8r.byte.high
#define     x9rw     x9r.word
#define     x9rl    x9r.byte.low
#define     x9rh    x9r.byte.high
#define     y9rw     y9r.word
#define     y9rl    y9r.byte.low
#define     y9rh    y9r.byte.high
#define     x10rw    x10r.word
#define     x10rl   x10r.byte.low
#define     x10rh   x10r.byte.high
#define     y10rw    y10r.word
#define     y10rl   y10r.byte.low
#define     y10rh   y10r.byte.high
#define     x11rw    x11r.word
#define     x11rl   x11r.byte.low
#define     x11rh   x11r.byte.high
#define     y11rw    y11r.word
#define     y11rl   y11r.byte.low
#define     y11rh   y11r.byte.high
#define     x12rw    x12r.word
#define     x12rl   x12r.byte.low
#define     x12rh   x12r.byte.high
#define     y12rw    y12r.word
#define     y12rl   y12r.byte.low
#define     y12rh   y12r.byte.high
#define     x13rw    x13r.word
#define     x13rl   x13r.byte.low
#define     x13rh   x13r.byte.high
#define     y13rw    y13r.word
#define     y13rl   y13r.byte.low
#define     y13rh   y13r.byte.high
#define     x14rw    x14r.word
#define     x14rl   x14r.byte.low
#define     x14rh   x14r.byte.high
#define     y14rw    y14r.word
#define     y14rl   y14r.byte.low
#define     y14rh   y14r.byte.high
#define     x15rw    x15r.word
#define     x15rl   x15r.byte.low
#define     x15rh   x15r.byte.high
#define     y15rw    y15r.word
#define     y15rl   y15r.byte.low
#define     y15rh   y15r.byte.high

#endif

